# This file was automatically generated by SWIG (http://www.swig.org).
# Version 1.3.40
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.
# This file is compatible with both classic and new-style classes.

"""

PyTrilinos.NOX.Epetra.Interface is the python interface to the
Epetra::Interface namespace of the Trilinos package NOX:

    http://trilinos.sandia.gov/packages/nox

The purpose of NOX.Epetra.Interface is to provide base classes the
user should derive from in order to define the nonlinear function to
be solved, and if needed, its Jacobian and the desired preconditioner.

NOX.Epetra.Interface provides the following user-level classes:

    * Required        - Required class for computing the nonlinear function
    * Jacobian        - Class for computing the Jacobian (if needed)
    * Preconditioner  - Class for computing the preconditioner (if needed)

"""

from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_Interface', [dirname(__file__)])
        except ImportError:
            import _Interface
            return _Interface
        if fp is not None:
            try:
                _mod = imp.load_module('_Interface', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _Interface = swig_import_helper()
    del swig_import_helper
else:
    import _Interface
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static) or hasattr(self,name):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


try:
    import weakref
    weakref_proxy = weakref.proxy
except:
    weakref_proxy = lambda x: x


class SwigPyIterator(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SwigPyIterator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SwigPyIterator, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _Interface.delete_SwigPyIterator
    __del__ = lambda self : None;
    def value(self): return _Interface.SwigPyIterator_value(self)
    def incr(self, n = 1): return _Interface.SwigPyIterator_incr(self, n)
    def decr(self, n = 1): return _Interface.SwigPyIterator_decr(self, n)
    def distance(self, *args): return _Interface.SwigPyIterator_distance(self, *args)
    def equal(self, *args): return _Interface.SwigPyIterator_equal(self, *args)
    def copy(self): return _Interface.SwigPyIterator_copy(self)
    def next(self): return _Interface.SwigPyIterator_next(self)
    def __next__(self): return _Interface.SwigPyIterator___next__(self)
    def previous(self): return _Interface.SwigPyIterator_previous(self)
    def advance(self, *args): return _Interface.SwigPyIterator_advance(self, *args)
    def __eq__(self, *args): return _Interface.SwigPyIterator___eq__(self, *args)
    def __ne__(self, *args): return _Interface.SwigPyIterator___ne__(self, *args)
    def __iadd__(self, *args): return _Interface.SwigPyIterator___iadd__(self, *args)
    def __isub__(self, *args): return _Interface.SwigPyIterator___isub__(self, *args)
    def __add__(self, *args): return _Interface.SwigPyIterator___add__(self, *args)
    def __sub__(self, *args): return _Interface.SwigPyIterator___sub__(self, *args)
    def __iter__(self): return self
SwigPyIterator_swigregister = _Interface.SwigPyIterator_swigregister
SwigPyIterator_swigregister(SwigPyIterator)

import PyTrilinos.Teuchos
class Required(_object):
    """
    Supplies NOX with the set nonlinear equations.

    This is the minimum required information to solve a nonlinear problem
    using the NOX::Epetra objects for the linear algebra implementation.
    Used by NOX::Epetra::Group to provide a link to the external code for
    residual fills.

    C++ includes: NOX_Epetra_Interface_Required.H 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Required, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Required, name)
    __repr__ = _swig_repr
    Residual = _Interface.Required_Residual
    Jac = _Interface.Required_Jac
    Prec = _Interface.Required_Prec
    FD_Res = _Interface.Required_FD_Res
    MF_Res = _Interface.Required_MF_Res
    MF_Jac = _Interface.Required_MF_Jac
    User = _Interface.Required_User
    def __init__(self, *args): 
        """
        __init__(self) -> Required

        NOX::Epetra::Interface::Required::Required()

        Constructor. 
        """
        if self.__class__ == Required:
            _self = None
        else:
            _self = self
        this = _Interface.new_Required(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Interface.delete_Required
    __del__ = lambda self : None;
    def computeF(self, *args):
        """
        computeF(self, Epetra.Vector x, Epetra.Vector F, FillType flag) -> bool

          Virtual method in C++ that is intended to be overridden by user.
          This method defines the nonlinear function to be solved.  Arguments
          x and F will be provided as numpy-hybrid Epetra.Vector objects.
          Return True if the computation is successful.

          It is strongly recommended that computeF() not raise any exceptions,
          accidental or otherwise.  This can be prevented by wrapping your
          algorithm in a try block:

            try:
              # Your code here...
            except Exception, e:
              print 'Python exception raised in computeF():'
              print e
              return False

          By returning False, you tell NOX that computeF() was unsuccessful.


        virtual bool NOX::Epetra::Interface::Required::computeF(const
        Epetra_Vector &x, Epetra_Vector &F, const FillType fillFlag)=0

        Compute the function, F, given the specified input vector x. Returns
        true if computation was successful. 
        """
        return _Interface.Required_computeF(self, *args)

    def __disown__(self):
        self.this.disown()
        _Interface.disown_Required(self)
        return weakref_proxy(self)
Required_swigregister = _Interface.Required_swigregister
Required_swigregister(Required)

class Jacobian(_object):
    """
    Used by NOX::Epetra to provide a link to the external code for
    Jacobian fills.

    This is only required if the user wishes to supply their own Jacobian
    operator.

    C++ includes: NOX_Epetra_Interface_Jacobian.H 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Jacobian, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Jacobian, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> Jacobian

        NOX::Epetra::Interface::Jacobian::Jacobian()

        Constructor. 
        """
        if self.__class__ == Jacobian:
            _self = None
        else:
            _self = self
        this = _Interface.new_Jacobian(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Interface.delete_Jacobian
    __del__ = lambda self : None;
    def computeJacobian(self, *args):
        """
        computeJacobian(self, Epetra_Vector x, Epetra_Operator Jac) -> bool

        virtual bool
        NOX::Epetra::Interface::Jacobian::computeJacobian(const Epetra_Vector
        &x, Epetra_Operator &Jac)=0

        Compute Jacobian given the specified input vector x. Returns true if
        computation was successful. 
        """
        return _Interface.Jacobian_computeJacobian(self, *args)

    def __disown__(self):
        self.this.disown()
        _Interface.disown_Jacobian(self)
        return weakref_proxy(self)
Jacobian_swigregister = _Interface.Jacobian_swigregister
Jacobian_swigregister(Jacobian)

class Preconditioner(_object):
    """
    Used by NOX::Epetra to provide a link to the external code for
    Precondtioner fills.

    This is only required if the user wishes to supply their own
    preconditioner operator.

    C++ includes: NOX_Epetra_Interface_Preconditioner.H 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Preconditioner, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Preconditioner, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> Preconditioner

        NOX::Epetra::Interface::Preconditioner::Preconditioner()

        Constructor. 
        """
        if self.__class__ == Preconditioner:
            _self = None
        else:
            _self = self
        this = _Interface.new_Preconditioner(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _Interface.delete_Preconditioner
    __del__ = lambda self : None;
    def computePreconditioner(self, *args):
        """
        computePreconditioner(self, Epetra_Vector x, Epetra_Operator M, ParameterList precParams = None) -> bool

        virtual bool
        NOX::Epetra::Interface::Preconditioner::computePreconditioner(const
        Epetra_Vector &x, Epetra_Operator &M, Teuchos::ParameterList
        *precParams=0)=0

        Computes a user defined preconditioner. 
        """
        return _Interface.Preconditioner_computePreconditioner(self, *args)

    def __disown__(self):
        self.this.disown()
        _Interface.disown_Preconditioner(self)
        return weakref_proxy(self)
Preconditioner_swigregister = _Interface.Preconditioner_swigregister
Preconditioner_swigregister(Preconditioner)



