# This file was automatically generated by SWIG (http://www.swig.org).
# Version 1.3.40
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.
# This file is compatible with both classic and new-style classes.

"""

PyTrilinos.Pliris is the python interface to the Trilinos package
Pliris, an LU solver for dense matrices:

    http://trilinos.sandia.gov/packages/pliris

The purpose of Pliris is to provide an object-oriented interface to an
LU solver for dense matrices on parallel platforms. These matrices are
double precision real matrices distributed on a parallel machine.  The
python version of the Pliris package supports the following class:

    * Pliris  - Primary solver class.

"""

from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_Pliris', [dirname(__file__)])
        except ImportError:
            import _Pliris
            return _Pliris
        if fp is not None:
            try:
                _mod = imp.load_module('_Pliris', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _Pliris = swig_import_helper()
    del swig_import_helper
else:
    import _Pliris
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static) or hasattr(self,name):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


__version__ = PACKAGE_VERSION

class Pliris(_object):
    """Proxy of C++ Pliris class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Pliris, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Pliris, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, Epetra_Vector A, Epetra_MultiVector X, Epetra_MultiVector B) -> Pliris
        __init__(self) -> Pliris
        """
        this = _Pliris.new_Pliris(*args)
        try: self.this.append(this)
        except: self.this = this
    def SetLHS(self, *args):
        """SetLHS(self, Epetra_MultiVector X) -> int"""
        return _Pliris.Pliris_SetLHS(self, *args)

    def SetRHS(self, *args):
        """SetRHS(self, Epetra_MultiVector B) -> int"""
        return _Pliris.Pliris_SetRHS(self, *args)

    def SetMatrix(self, *args):
        """
        SetMatrix(self, Epetra_Vector A) -> int
        SetMatrix(self, Epetra_SerialDenseVector A) -> int
        """
        return _Pliris.Pliris_SetMatrix(self, *args)

    def GetDistribution(self, *args):
        """
        GetDistribution(self, int nprocs_row, int number_of_unknowns, int nrhs, int my_rows, 
            int my_cols, int my_first_row, int my_first_col, 
            int my_rhs, int my_row, int my_col) -> int
        """
        return _Pliris.Pliris_GetDistribution(self, *args)

    def FactorSolve(self, *args):
        """
        FactorSolve(self, Epetra_Vector A, int my_rows, int my_cols, int matrix_size, 
            int num_procsr, int num_rhs, double secs) -> int
        FactorSolve(self, Epetra_SerialDenseVector AA, int my_rows, int my_cols, 
            int matrix_size, int num_procsr, int num_rhs, 
            double secs) -> int
        """
        return _Pliris.Pliris_FactorSolve(self, *args)

    def Factor(self, *args):
        """
        Factor(self, Epetra_Vector A, int matrix_size, int num_procsr, int permute, 
            double secs) -> int
        """
        return _Pliris.Pliris_Factor(self, *args)

    def Solve(self, *args):
        """Solve(self, int permute, int num_rhs) -> int"""
        return _Pliris.Pliris_Solve(self, *args)

    __swig_destroy__ = _Pliris.delete_Pliris
    __del__ = lambda self : None;
Pliris_swigregister = _Pliris.Pliris_swigregister
Pliris_swigregister(Pliris)



