# This file was automatically generated by SWIG (http://www.swig.org).
# Version 1.3.40
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.
# This file is compatible with both classic and new-style classes.

"""

PyTrilinos.TriUtils is the python interface to the Trilinos utilities
package TriUtils:

    http://trilinos.sandia.gov/packages/triutils

The purpose of TriUtils is to provide some utilities typically needed
when testing Trilinos software.

TriUtils provides the following user-level classes:

    * CrsMatrixGallery  - Provide example CrsMatrix objects
    * VbrMatrixGallery  - Provide example VbrMatrix objects

and function:

    * ReadHB            - Obtain a problem from an HB file

For an examples of usage, please consult the following script in the
example subdirectory of the PyTrilinos package:

    * exIFPACK.py

"""

from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_TriUtils', [dirname(__file__)])
        except ImportError:
            import _TriUtils
            return _TriUtils
        if fp is not None:
            try:
                _mod = imp.load_module('_TriUtils', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _TriUtils = swig_import_helper()
    del swig_import_helper
else:
    import _TriUtils
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static) or hasattr(self,name):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


try:
    import weakref
    weakref_proxy = weakref.proxy
except:
    weakref_proxy = lambda x: x


import Epetra

def TriUtils_Version(*args):
  """
    TriUtils_Version() -> string

    string Triutils_Version() 
    """
  return _TriUtils.TriUtils_Version(*args)
__version__ = TriUtils_Version().split()[2]


def ReadHB(*args):
  """
    ReadHB(char data_file, Comm comm)

    void
    Trilinos_Util_ReadHb2Epetra(char *data_file, const Epetra_Comm &comm,
    Epetra_Map *&map, Epetra_CrsMatrix *&A, Epetra_Vector *&x,
    Epetra_Vector *&b, Epetra_Vector *&xexact) 
    """
  return _TriUtils.ReadHB(*args)
class CrsMatrixGallery(_object):
    """Proxy of C++ Trilinos_Util::CrsMatrixGallery class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CrsMatrixGallery, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CrsMatrixGallery, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, string name, Comm comm) -> CrsMatrixGallery
        __init__(self, string name, Map map) -> CrsMatrixGallery

        Trilinos_Util::CrsMatrixGallery::CrsMatrixGallery(const string name,
        const Epetra_Map &map)

        Creates an Triutils_Gallery object using a given map.

        Create a Triutils_Gallery object using an Epetra_Map. Problem size
        must match the elements in map.

        Parameters:
        -----------

        In:  name - definition of the problem to be created.

        In:  map - Epetra_Map 
        """
        this = _TriUtils.new_CrsMatrixGallery(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _TriUtils.delete_CrsMatrixGallery
    __del__ = lambda self : None;
    def Set(self, *args):
        """
        Set(self, string parameter, int value) -> int
        Set(self, string parameter, string value) -> int
        Set(self, string parameter, double value) -> int
        Set(self, string parameter, Epetra_Vector value) -> int
        Set(self, Trilinos_Util::CommandLineParser CLP) -> int

        int
        Trilinos_Util::CrsMatrixGallery::Set(Trilinos_Util::CommandLineParser
        &CLP)

        Sets gallery options using values passed from the shell. 
        """
        return _TriUtils.CrsMatrixGallery_Set(self, *args)

    def GetMatrix(self, *args):
        """
        GetMatrix(self) -> CrsMatrix

        Epetra_CrsMatrix * Trilinos_Util::CrsMatrixGallery::GetMatrix()

        Returns a pointer to the CrsMatrix. 
        """
        return _TriUtils.CrsMatrixGallery_GetMatrix(self, *args)

    def GetMatrixRef(self, *args):
        """
        GetMatrixRef(self) -> CrsMatrix

        Epetra_CrsMatrix & Trilinos_Util::CrsMatrixGallery::GetMatrixRef() 
        """
        return _TriUtils.CrsMatrixGallery_GetMatrixRef(self, *args)

    def GetExactSolution(self, *args):
        """
        GetExactSolution(self) -> Epetra_MultiVector

        Epetra_MultiVector
        * Trilinos_Util::CrsMatrixGallery::GetExactSolution()

        Returns a pointer to the exact solution.

        Returns a pointer to the exact solution.

        Some choices are available to define the exact solution, using
        Set("exact solution", value). value can be: constant: the exact
        solution vector is made up of 1's.

        random: a random solution vector

        linear: value at node i is defined as alpha*i. The double value alpha
        can be set via Set("alpha",DoubleVal). 
        """
        return _TriUtils.CrsMatrixGallery_GetExactSolution(self, *args)

    def GetStartingSolution(self, *args):
        """
        GetStartingSolution(self) -> Epetra_MultiVector

        Epetra_MultiVector *
        Trilinos_Util::CrsMatrixGallery::GetStartingSolution()

        Returns a pointer to the starting solution (typically, for HB
        problems).

        Returns a pointer to the starting solution. This is typically used
        while reading a HB problem. However, the user can set a starting
        solution using Set("starting solution", "value"). Value can be
        zero

        random 
        """
        return _TriUtils.CrsMatrixGallery_GetStartingSolution(self, *args)

    def GetRHS(self, *args):
        """
        GetRHS(self) -> Epetra_MultiVector

        Epetra_MultiVector * Trilinos_Util::CrsMatrixGallery::GetRHS()

        Returns a pointer to the rhs corresponding to the selected exact
        solution. 
        """
        return _TriUtils.CrsMatrixGallery_GetRHS(self, *args)

    def GetMap(self, *args):
        """
        GetMap(self) -> Map

        const
        Epetra_Map * Trilinos_Util::CrsMatrixGallery::GetMap()

        Returns a pointer the internally stored Map. 
        """
        return _TriUtils.CrsMatrixGallery_GetMap(self, *args)

    def GetMapRef(self, *args):
        """
        GetMapRef(self) -> Map

        const Epetra_Map & Trilinos_Util::CrsMatrixGallery::GetMapRef() 
        """
        return _TriUtils.CrsMatrixGallery_GetMapRef(self, *args)

    def GetLinearProblem(self, *args):
        """
        GetLinearProblem(self) -> LinearProblem

        Epetra_LinearProblem *
        Trilinos_Util::CrsMatrixGallery::GetLinearProblem()

        Returns a pointer to Epetra_LinearProblem. 
        """
        return _TriUtils.CrsMatrixGallery_GetLinearProblem(self, *args)

    def ComputeResidual(self, *args):
        """
        ComputeResidual(self, double residual)

        void
        Trilinos_Util::CrsMatrixGallery::ComputeResidual(double *residual)

        Computes the 2-norm of the residual. 
        """
        return _TriUtils.CrsMatrixGallery_ComputeResidual(self, *args)

    def ComputeDiffBetweenStartingAndExactSolutions(self, *args):
        """
        ComputeDiffBetweenStartingAndExactSolutions(self, double residual)

        void
        Trilinos_Util::CrsMatrixGallery::ComputeDiffBetweenStartingAndExactSolutions(double
        *residual)

        Computes the 2-norm of the difference between the starting solution
        and the exact solution. 
        """
        return _TriUtils.CrsMatrixGallery_ComputeDiffBetweenStartingAndExactSolutions(self, *args)

    def PrintMatrixAndVectors(self, *args):
        """
        PrintMatrixAndVectors(self,  os)
        PrintMatrixAndVectors(self)

        void
        Trilinos_Util::CrsMatrixGallery::PrintMatrixAndVectors() 
        """
        return _TriUtils.CrsMatrixGallery_PrintMatrixAndVectors(self, *args)

    def GetCartesianCoordinates(self, *args):
        """
        GetCartesianCoordinates(self, double x, double y, double z)

        void
        Trilinos_Util::CrsMatrixGallery::GetCartesianCoordinates(double *&x,
        double *&y, double *&z)

        Get pointers to double vectors containing coordinates of points. 
        """
        return _TriUtils.CrsMatrixGallery_GetCartesianCoordinates(self, *args)

    def WriteMatrix(self, *args):
        """
        WriteMatrix(self, string FileName, bool UseSparse = True) -> int

        int Trilinos_Util::CrsMatrixGallery::WriteMatrix(const string
        &FileName, const bool UseSparse=true)

        Print matrix on file in MATLAB format. 
        """
        return _TriUtils.CrsMatrixGallery_WriteMatrix(self, *args)

CrsMatrixGallery_swigregister = _TriUtils.CrsMatrixGallery_swigregister
CrsMatrixGallery_swigregister(CrsMatrixGallery)

class VbrMatrixGallery(CrsMatrixGallery):
    """Proxy of C++ Trilinos_Util::VbrMatrixGallery class"""
    __swig_setmethods__ = {}
    for _s in [CrsMatrixGallery]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, VbrMatrixGallery, name, value)
    __swig_getmethods__ = {}
    for _s in [CrsMatrixGallery]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, VbrMatrixGallery, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, string name, Map map) -> VbrMatrixGallery
        __init__(self, string name, Comm Comm) -> VbrMatrixGallery

        Trilinos_Util::VbrMatrixGallery::VbrMatrixGallery(const string name,
        const Epetra_Comm &Comm) 
        """
        this = _TriUtils.new_VbrMatrixGallery(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _TriUtils.delete_VbrMatrixGallery
    __del__ = lambda self : None;
    def GetBlockMap(self, *args):
        """
        GetBlockMap(self) -> BlockMap

        const Epetra_BlockMap * Trilinos_Util::VbrMatrixGallery::GetBlockMap()

        Returns a pointer the internally stored BlockMap. 
        """
        return _TriUtils.VbrMatrixGallery_GetBlockMap(self, *args)

    def GetBlockMapRef(self, *args):
        """
        GetBlockMapRef(self) -> BlockMap

        const Epetra_BlockMap &
        Trilinos_Util::VbrMatrixGallery::GetBlockMapRef() 
        """
        return _TriUtils.VbrMatrixGallery_GetBlockMapRef(self, *args)

    def GetVbrMatrix(self, *args):
        """
        GetVbrMatrix(self, int NumPDEEqns) -> VbrMatrix
        GetVbrMatrix(self) -> VbrMatrix

        Epetra_VbrMatrix * Trilinos_Util::VbrMatrixGallery::GetVbrMatrix()

        Returns a VbrMatrix, starting from the CsrMatrix. 
        """
        return _TriUtils.VbrMatrixGallery_GetVbrMatrix(self, *args)

    def GetVbrMatrixRef(self, *args):
        """
        GetVbrMatrixRef(self) -> VbrMatrix

        Epetra_VbrMatrix &
        Trilinos_Util::VbrMatrixGallery::GetVbrMatrixRef() 
        """
        return _TriUtils.VbrMatrixGallery_GetVbrMatrixRef(self, *args)

    def GetVbrRHS(self, *args):
        """
        GetVbrRHS(self) -> Epetra_MultiVector

        Epetra_MultiVector * Trilinos_Util::VbrMatrixGallery::GetVbrRHS()

        Returns a pointer to the RHS for the selected Vbr exact solution.

        Returns a pointer to the RHS corresponding to the selected exact
        solution to the linear systems defined by the Epetra_VbrMatrix. 
        """
        return _TriUtils.VbrMatrixGallery_GetVbrRHS(self, *args)

    def GetVbrExactSolution(self, *args):
        """
        GetVbrExactSolution(self) -> Epetra_MultiVector

        Epetra_MultiVector *
        Trilinos_Util::VbrMatrixGallery::GetVbrExactSolution()

        Returns a pointer to the selected Vbr exact solution. 
        """
        return _TriUtils.VbrMatrixGallery_GetVbrExactSolution(self, *args)

    def GetVbrStartingSolution(self, *args):
        """
        GetVbrStartingSolution(self) -> Epetra_MultiVector

        Epetra_MultiVector *
        Trilinos_Util::VbrMatrixGallery::GetVbrStartingSolution()

        Returns a pointer to the starting solution for Vbr problems. 
        """
        return _TriUtils.VbrMatrixGallery_GetVbrStartingSolution(self, *args)

    def CreateVbrMatrix(self, *args):
        """
        CreateVbrMatrix(self)

        void
        Trilinos_Util::VbrMatrixGallery::CreateVbrMatrix(void) 
        """
        return _TriUtils.VbrMatrixGallery_CreateVbrMatrix(self, *args)

    def GetVbrLinearProblem(self, *args):
        """
        GetVbrLinearProblem(self) -> LinearProblem

        Epetra_LinearProblem *
        Trilinos_Util::VbrMatrixGallery::GetVbrLinearProblem()

        Returns a pointer to Epetra_LinearProblem for VBR. 
        """
        return _TriUtils.VbrMatrixGallery_GetVbrLinearProblem(self, *args)

    def ComputeResidualVbr(self, *args):
        """
        ComputeResidualVbr(self, double residual)

        void
        Trilinos_Util::VbrMatrixGallery::ComputeResidualVbr(double *residual)

        Computes the 2-norm of the residual for the VBR problem. 
        """
        return _TriUtils.VbrMatrixGallery_ComputeResidualVbr(self, *args)

    def ComputeDiffBetweenStartingAndExactSolutionsVbr(self, *args):
        """
        ComputeDiffBetweenStartingAndExactSolutionsVbr(self, double residual)

        void
        Trilinos_Util::VbrMatrixGallery::ComputeDiffBetweenStartingAndExactSolutionsVbr(double
        *residual)

        Computes the 2-norm of the difference between the starting solution
        and the exact solution for the VBR problem. 
        """
        return _TriUtils.VbrMatrixGallery_ComputeDiffBetweenStartingAndExactSolutionsVbr(self, *args)

    def PrintVbrMatrixAndVectors(self, *args):
        """
        PrintVbrMatrixAndVectors(self,  os)
        PrintVbrMatrixAndVectors(self)

        void
        Trilinos_Util::VbrMatrixGallery::PrintVbrMatrixAndVectors() 
        """
        return _TriUtils.VbrMatrixGallery_PrintVbrMatrixAndVectors(self, *args)

VbrMatrixGallery_swigregister = _TriUtils.VbrMatrixGallery_swigregister
VbrMatrixGallery_swigregister(VbrMatrixGallery)



