# This file was automatically generated by SWIG (http://www.swig.org).
# Version 1.3.40
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.
# This file is compatible with both classic and new-style classes.

"""

PyTrilinos.NOX.Epetra is the python interface to namespace Epetra for
the Trilinos package NOX:

    http://trilinos.sandia.gov/packages/nox

The purpose of NOX.Epetra is to provide a concrete interface beteen
NOX and Epetra.

NOX.Epetra provides the following user-level classes:

    * Group                    - Epetra implementation of Abstract.Group
    * Vector                   - Epetra implementation of Abstract.Vector
    * FiniteDifference         - Class for estimating Jacobian w/finite differences
    * FiniteDifferenceColoring - FiniteDifference class, w/coloring efficiencies
    * MatrixFree               - Base class for Jacobian-free algorithms
    * Scaling                  - Class for controlling scalling of algebraic objects
    * LinearSystem             - Base class for interface to linear solvers
    * LinearSystemAztecOO      - Concrete implementation of LinearSystem

"""

from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('___init__', [dirname(__file__)])
        except ImportError:
            import ___init__
            return ___init__
        if fp is not None:
            try:
                _mod = imp.load_module('___init__', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    ___init__ = swig_import_helper()
    del swig_import_helper
else:
    import ___init__
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static) or hasattr(self,name):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


try:
    import weakref
    weakref_proxy = weakref.proxy
except:
    weakref_proxy = lambda x: x


class SwigPyIterator(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SwigPyIterator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SwigPyIterator, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_SwigPyIterator
    __del__ = lambda self : None;
    def value(self): return ___init__.SwigPyIterator_value(self)
    def incr(self, n = 1): return ___init__.SwigPyIterator_incr(self, n)
    def decr(self, n = 1): return ___init__.SwigPyIterator_decr(self, n)
    def distance(self, *args): return ___init__.SwigPyIterator_distance(self, *args)
    def equal(self, *args): return ___init__.SwigPyIterator_equal(self, *args)
    def copy(self): return ___init__.SwigPyIterator_copy(self)
    def next(self): return ___init__.SwigPyIterator_next(self)
    def __next__(self): return ___init__.SwigPyIterator___next__(self)
    def previous(self): return ___init__.SwigPyIterator_previous(self)
    def advance(self, *args): return ___init__.SwigPyIterator_advance(self, *args)
    def __eq__(self, *args): return ___init__.SwigPyIterator___eq__(self, *args)
    def __ne__(self, *args): return ___init__.SwigPyIterator___ne__(self, *args)
    def __iadd__(self, *args): return ___init__.SwigPyIterator___iadd__(self, *args)
    def __isub__(self, *args): return ___init__.SwigPyIterator___isub__(self, *args)
    def __add__(self, *args): return ___init__.SwigPyIterator___add__(self, *args)
    def __sub__(self, *args): return ___init__.SwigPyIterator___sub__(self, *args)
    def __iter__(self): return self
SwigPyIterator_swigregister = ___init__.SwigPyIterator_swigregister
SwigPyIterator_swigregister(SwigPyIterator)

import PyTrilinos.Teuchos
# Much of the Epetra module is compatible with the numpy module
import numpy

# From numpy version 1.0 forward, we want to use the following import syntax for
# user_array.container.  We rename it UserArray for backward compatibility with
# 0.9.x versions of numpy:
try:
    from numpy.lib.user_array import container as UserArray

# If the previous import failed, it is because we are using a numpy version
# prior to 1.0.  So we catch it and try again with different syntax.
except ImportError:

    # There is a bug in UserArray from numpy 0.9.8.  If this is the case, we
    # have our own patched version.
    try:
        from UserArrayFix import UserArray
        
    # If the previous import failed, it is because we are using a version of
    # numpy prior to 0.9.8, such as 0.9.6, which has no bug and therefore has no
    # local patch.  Now we can import using the old syntax:
    except ImportError:
        from numpy.lib.UserArray import UserArray

Error = ___init__.Error

def Version(*args):
  """Version() -> string"""
  return ___init__.Version(*args)
__version__ = Version().split()[2]

Add = ___init__.Add
Zero = ___init__.Zero
Insert = ___init__.Insert
InsertAdd = ___init__.InsertAdd
Average = ___init__.Average
AbsMax = ___init__.AbsMax
Copy = ___init__.Copy
View = ___init__.View
class Object(_object):
    """
    The base Epetra class.
        
    The Epetra_Object class provides capabilities common to all Epetra
    objects, such as a label that identifies an object instance, constant
    definitions, enum types.  In C++, it supports a ``Print()`` method
    that takes an output stream as an argument.  In the python
    implementation for this and all derived classes, this method takes an
    optional file object argument whose default value is standard out.
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Object, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Object, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, int TracebackModeIn = -1, bool set_label = True) -> Object
        __init__(self, char Label, int TracebackModeIn = -1) -> Object
        __init__(self, Object Object) -> Object

        The base Epetra class.
            
        The Epetra_Object class provides capabilities common to all Epetra
        objects, such as a label that identifies an object instance, constant
        definitions, enum types.  In C++, it supports a ``Print()`` method
        that takes an output stream as an argument.  In the python
        implementation for this and all derived classes, this method takes an
        optional file object argument whose default value is standard out.
        """
        this = ___init__.new_Object(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_Object
    __del__ = lambda self : None;
    def SetLabel(self, *args):
        """SetLabel(self, char Label)"""
        return ___init__.Object_SetLabel(self, *args)

    def Label(self, *args):
        """Label(self) -> char"""
        return ___init__.Object_Label(self, *args)

    def SetTracebackMode(*args):
        """SetTracebackMode(int TracebackModeValue)"""
        return ___init__.Object_SetTracebackMode(*args)

    if _newclass:SetTracebackMode = staticmethod(SetTracebackMode)
    __swig_getmethods__["SetTracebackMode"] = lambda x: SetTracebackMode
    def GetTracebackMode(*args):
        """GetTracebackMode() -> int"""
        return ___init__.Object_GetTracebackMode(*args)

    if _newclass:GetTracebackMode = staticmethod(GetTracebackMode)
    __swig_getmethods__["GetTracebackMode"] = lambda x: GetTracebackMode
    def GetTracebackStream(*args):
        """GetTracebackStream()"""
        return ___init__.Object_GetTracebackStream(*args)

    if _newclass:GetTracebackStream = staticmethod(GetTracebackStream)
    __swig_getmethods__["GetTracebackStream"] = lambda x: GetTracebackStream
    def ReportError(self, *args):
        """ReportError(self, string Message, int ErrorCode) -> int"""
        return ___init__.Object_ReportError(self, *args)

    __swig_setmethods__["TracebackMode"] = ___init__.Object_TracebackMode_set
    __swig_getmethods__["TracebackMode"] = ___init__.Object_TracebackMode_get
    if _newclass:TracebackMode = _swig_property(___init__.Object_TracebackMode_get, ___init__.Object_TracebackMode_set)
    def __str__(self, *args):
        """
        __str__(self) -> PyObject

        Returns the results of ``Print()`` in a string, so that
        the ``print`` command will work on ``Epetra`` objects.  The
        ``Print()`` methods are designed to run correctly in parallel, so do
        not execute ``print`` on an Epetra object conditionally on the
        processor number.  For example, do not do

          ``if comm.MyPID() == 0: print epetra_obj``

        or it will hang your code.
        """
        return ___init__.Object___str__(self, *args)

    def Print(self, *args):
        """Print(self, PyObject pf = None)"""
        return ___init__.Object_Print(self, *args)

Object_swigregister = ___init__.Object_swigregister
Object_swigregister(Object)

def Object_SetTracebackMode(*args):
  """Object_SetTracebackMode(int TracebackModeValue)"""
  return ___init__.Object_SetTracebackMode(*args)

def Object_GetTracebackMode(*args):
  """Object_GetTracebackMode() -> int"""
  return ___init__.Object_GetTracebackMode(*args)

def Object_GetTracebackStream(*args):
  """Object_GetTracebackStream()"""
  return ___init__.Object_GetTracebackStream(*args)
cvar = ___init__.cvar

class SrcDistObject(_object):
    """Proxy of C++ Epetra_SrcDistObject class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SrcDistObject, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SrcDistObject, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_SrcDistObject
    __del__ = lambda self : None;
    def Map(self, *args):
        """Map(self) -> BlockMap"""
        return ___init__.SrcDistObject_Map(self, *args)

SrcDistObject_swigregister = ___init__.SrcDistObject_swigregister
SrcDistObject_swigregister(SrcDistObject)

class DistObject(Object,SrcDistObject):
    """Proxy of C++ Epetra_DistObject class"""
    __swig_setmethods__ = {}
    for _s in [Object,SrcDistObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DistObject, name, value)
    __swig_getmethods__ = {}
    for _s in [Object,SrcDistObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, DistObject, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_DistObject
    __del__ = lambda self : None;
    def Import(self, *args):
        """
        Import(self, SrcDistObject A, Import Importer, Epetra_CombineMode CombineMode, 
            OffsetIndex Indexor = None) -> int
        Import(self, SrcDistObject A, Export Exporter, Epetra_CombineMode CombineMode, 
            OffsetIndex Indexor = None) -> int
        """
        return ___init__.DistObject_Import(self, *args)

    def Export(self, *args):
        """
        Export(self, SrcDistObject A, Import Importer, Epetra_CombineMode CombineMode, 
            OffsetIndex Indexor = None) -> int
        Export(self, SrcDistObject A, Export Exporter, Epetra_CombineMode CombineMode, 
            OffsetIndex Indexor = None) -> int
        """
        return ___init__.DistObject_Export(self, *args)

    def Map(self, *args):
        """Map(self) -> BlockMap"""
        return ___init__.DistObject_Map(self, *args)

    def Comm(self, *args):
        """Comm(self) -> Comm"""
        return ___init__.DistObject_Comm(self, *args)

    def DistributedGlobal(self, *args):
        """DistributedGlobal(self) -> bool"""
        return ___init__.DistObject_DistributedGlobal(self, *args)

DistObject_swigregister = ___init__.DistObject_swigregister
DistObject_swigregister(DistObject)

class CompObject(_object):
    """Proxy of C++ Epetra_CompObject class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CompObject, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CompObject, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> CompObject
        __init__(self, CompObject Source) -> CompObject
        """
        this = ___init__.new_CompObject(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_CompObject
    __del__ = lambda self : None;
    def SetFlopCounter(self, *args):
        """
        SetFlopCounter(self, FLOPS FlopCounter_in)
        SetFlopCounter(self, CompObject CompObject)
        """
        return ___init__.CompObject_SetFlopCounter(self, *args)

    def UnsetFlopCounter(self, *args):
        """UnsetFlopCounter(self)"""
        return ___init__.CompObject_UnsetFlopCounter(self, *args)

    def GetFlopCounter(self, *args):
        """GetFlopCounter(self) -> FLOPS"""
        return ___init__.CompObject_GetFlopCounter(self, *args)

    def ResetFlops(self, *args):
        """ResetFlops(self)"""
        return ___init__.CompObject_ResetFlops(self, *args)

    def Flops(self, *args):
        """Flops(self) -> double"""
        return ___init__.CompObject_Flops(self, *args)

    def UpdateFlops(self, *args):
        """
        UpdateFlops(self, long Flops_in)
        UpdateFlops(self, double Flops_in)
        """
        return ___init__.CompObject_UpdateFlops(self, *args)

CompObject_swigregister = ___init__.CompObject_swigregister
CompObject_swigregister(CompObject)

class BLAS(_object):
    """Proxy of C++ Epetra_BLAS class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, BLAS, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, BLAS, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> BLAS
        __init__(self, BLAS BLAS) -> BLAS
        """
        this = ___init__.new_BLAS(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_BLAS
    __del__ = lambda self : None;
BLAS_swigregister = ___init__.BLAS_swigregister
BLAS_swigregister(BLAS)

class LAPACK(_object):
    """Proxy of C++ Epetra_LAPACK class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, LAPACK, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, LAPACK, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LAPACK
        __init__(self, LAPACK LAPACK) -> LAPACK
        """
        this = ___init__.new_LAPACK(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_LAPACK
    __del__ = lambda self : None;
LAPACK_swigregister = ___init__.LAPACK_swigregister
LAPACK_swigregister(LAPACK)

class FLOPS(_object):
    """Proxy of C++ Epetra_Flops class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, FLOPS, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, FLOPS, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> FLOPS
        __init__(self, FLOPS Flops_in) -> FLOPS
        """
        this = ___init__.new_FLOPS(*args)
        try: self.this.append(this)
        except: self.this = this
    def Flops(self, *args):
        """Flops(self) -> double"""
        return ___init__.FLOPS_Flops(self, *args)

    def ResetFlops(self, *args):
        """ResetFlops(self)"""
        return ___init__.FLOPS_ResetFlops(self, *args)

    __swig_destroy__ = ___init__.delete_FLOPS
    __del__ = lambda self : None;
FLOPS_swigregister = ___init__.FLOPS_swigregister
FLOPS_swigregister(FLOPS)

class Time(Object):
    """Proxy of C++ Epetra_Time class"""
    __swig_setmethods__ = {}
    for _s in [Object]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Time, name, value)
    __swig_getmethods__ = {}
    for _s in [Object]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Time, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, Comm Comm) -> Time
        __init__(self, Time Time) -> Time
        """
        this = ___init__.new_Time(*args)
        try: self.this.append(this)
        except: self.this = this
    def WallTime(self, *args):
        """WallTime(self) -> double"""
        return ___init__.Time_WallTime(self, *args)

    def ResetStartTime(self, *args):
        """ResetStartTime(self)"""
        return ___init__.Time_ResetStartTime(self, *args)

    def ElapsedTime(self, *args):
        """ElapsedTime(self) -> double"""
        return ___init__.Time_ElapsedTime(self, *args)

    __swig_destroy__ = ___init__.delete_Time
    __del__ = lambda self : None;
Time_swigregister = ___init__.Time_swigregister
Time_swigregister(Time)

class Util(_object):
    """
    Epetra Util Wrapper Class.

    The Epetra.Util class is a collection of useful functions that cut
    across a broad set of other classes.  A random number generator is
    provided, along with methods to set and retrieve the random-number
    seed.

    The random number generator is a multiplicative linear congruential
    generator, with multiplier 16807 and modulus 2^31 - 1. It is based on
    the algorithm described in 'Random Number Generators: Good Ones Are
    Hard To Find', S. K. Park and K. W. Miller, Communications of the ACM,
    vol. 31, no. 10, pp. 1192-1201.

    The C++ Sort() method is not supported in python.

    A static function is provided for creating a new Epetra.Map object
    with 1-to-1 ownership of entries from an existing map which may have
    entries that appear on multiple processors.

    Epetra.Util is a serial interface only.  This is appropriate since the
    standard utilities are only specified for serial execution (or shared
    memory parallel).
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Util, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Util, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> Util
        __init__(self, Util Util) -> Util

        Epetra Util Wrapper Class.

        The Epetra.Util class is a collection of useful functions that cut
        across a broad set of other classes.  A random number generator is
        provided, along with methods to set and retrieve the random-number
        seed.

        The random number generator is a multiplicative linear congruential
        generator, with multiplier 16807 and modulus 2^31 - 1. It is based on
        the algorithm described in 'Random Number Generators: Good Ones Are
        Hard To Find', S. K. Park and K. W. Miller, Communications of the ACM,
        vol. 31, no. 10, pp. 1192-1201.

        The C++ Sort() method is not supported in python.

        A static function is provided for creating a new Epetra.Map object
        with 1-to-1 ownership of entries from an existing map which may have
        entries that appear on multiple processors.

        Epetra.Util is a serial interface only.  This is appropriate since the
        standard utilities are only specified for serial execution (or shared
        memory parallel).
        """
        this = ___init__.new_Util(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_Util
    __del__ = lambda self : None;
    def RandomInt(self, *args):
        """RandomInt(self) -> unsigned int"""
        return ___init__.Util_RandomInt(self, *args)

    def RandomDouble(self, *args):
        """RandomDouble(self) -> double"""
        return ___init__.Util_RandomDouble(self, *args)

    def Seed(self, *args):
        """Seed(self) -> unsigned int"""
        return ___init__.Util_Seed(self, *args)

    def SetSeed(self, *args):
        """SetSeed(self, unsigned int Seed_in) -> int"""
        return ___init__.Util_SetSeed(self, *args)

    def Create_Root_Map(*args):
        """Create_Root_Map(Map usermap, int root = 0) -> Map"""
        return ___init__.Util_Create_Root_Map(*args)

    if _newclass:Create_Root_Map = staticmethod(Create_Root_Map)
    __swig_getmethods__["Create_Root_Map"] = lambda x: Create_Root_Map
    def Create_OneToOne_Map(*args):
        """Create_OneToOne_Map(Map usermap, bool high_rank_proc_owns_shared = False) -> Map"""
        return ___init__.Util_Create_OneToOne_Map(*args)

    if _newclass:Create_OneToOne_Map = staticmethod(Create_OneToOne_Map)
    __swig_getmethods__["Create_OneToOne_Map"] = lambda x: Create_OneToOne_Map
    def Create_OneToOne_BlockMap(*args):
        """Create_OneToOne_BlockMap(BlockMap usermap, bool high_rank_proc_owns_shared = False) -> BlockMap"""
        return ___init__.Util_Create_OneToOne_BlockMap(*args)

    if _newclass:Create_OneToOne_BlockMap = staticmethod(Create_OneToOne_BlockMap)
    __swig_getmethods__["Create_OneToOne_BlockMap"] = lambda x: Create_OneToOne_BlockMap
    def Chop(*args):
        """Chop(double Value) -> double"""
        return ___init__.Util_Chop(*args)

    if _newclass:Chop = staticmethod(Chop)
    __swig_getmethods__["Chop"] = lambda x: Chop
Util_swigregister = ___init__.Util_swigregister
Util_swigregister(Util)

def Util_Create_Root_Map(*args):
  """Util_Create_Root_Map(Map usermap, int root = 0) -> Map"""
  return ___init__.Util_Create_Root_Map(*args)

def Util_Create_OneToOne_Map(*args):
  """Util_Create_OneToOne_Map(Map usermap, bool high_rank_proc_owns_shared = False) -> Map"""
  return ___init__.Util_Create_OneToOne_Map(*args)

def Util_Create_OneToOne_BlockMap(*args):
  """Util_Create_OneToOne_BlockMap(BlockMap usermap, bool high_rank_proc_owns_shared = False) -> BlockMap"""
  return ___init__.Util_Create_OneToOne_BlockMap(*args)

def Util_Chop(*args):
  """Util_Chop(double Value) -> double"""
  return ___init__.Util_Chop(*args)
Util.chopVal_ = ___init__.cvar.Util_chopVal_


def Epetra_Util_binary_search(*args):
  """Epetra_Util_binary_search(int item, int list, int len, int insertPoint) -> int"""
  return ___init__.Epetra_Util_binary_search(*args)

def Epetra_Util_ExtractHbData(*args):
  """
    Epetra_Util_ExtractHbData(CrsMatrix A, Epetra_MultiVector LHS, Epetra_MultiVector RHS, 
        int M, int N, int nz, int ptr, int ind, 
        double val, int Nrhs, double rhs, int ldrhs, 
        double lhs, int ldlhs) -> int
    """
  return ___init__.Epetra_Util_ExtractHbData(*args)
class MapColoring(DistObject):
    """Proxy of C++ Epetra_MapColoring class"""
    __swig_setmethods__ = {}
    for _s in [DistObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MapColoring, name, value)
    __swig_getmethods__ = {}
    for _s in [DistObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MapColoring, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_MapColoring
    __del__ = lambda self : None;
    def __call__(self, *args):
        """__call__(self, int GID) -> int"""
        return ___init__.MapColoring___call__(self, *args)

    def NumColors(self, *args):
        """NumColors(self) -> int"""
        return ___init__.MapColoring_NumColors(self, *args)

    def MaxNumColors(self, *args):
        """MaxNumColors(self) -> int"""
        return ___init__.MapColoring_MaxNumColors(self, *args)

    def DefaultColor(self, *args):
        """DefaultColor(self) -> int"""
        return ___init__.MapColoring_DefaultColor(self, *args)

    def NumElementsWithColor(self, *args):
        """NumElementsWithColor(self, int Color) -> int"""
        return ___init__.MapColoring_NumElementsWithColor(self, *args)

    def GenerateMap(self, *args):
        """GenerateMap(self, int Color) -> Map"""
        return ___init__.MapColoring_GenerateMap(self, *args)

    def GenerateBlockMap(self, *args):
        """GenerateBlockMap(self, int Color) -> BlockMap"""
        return ___init__.MapColoring_GenerateBlockMap(self, *args)

    def __init__(self, *args): 
        """
        __init__(self, BlockMap Map, int DefaultColor = 0) -> MapColoring
        __init__(self, MapColoring Source) -> MapColoring
        __init__(self, BlockMap map, int numColors, int defaultColor = 0) -> MapColoring
        """
        this = ___init__.new_MapColoring(*args)
        try: self.this.append(this)
        except: self.this = this
    def __getitem__(self, *args):
        """__getitem__(self, int i) -> int"""
        return ___init__.MapColoring___getitem__(self, *args)

    def __setitem__(self, *args):
        """__setitem__(self, int i, int color)"""
        return ___init__.MapColoring___setitem__(self, *args)

    def ListOfColors(self, *args):
        """ListOfColors(self) -> PyObject"""
        return ___init__.MapColoring_ListOfColors(self, *args)

    def ColorLIDList(self, *args):
        """ColorLIDList(self, int color) -> PyObject"""
        return ___init__.MapColoring_ColorLIDList(self, *args)

    def ElementColors(self, *args):
        """ElementColors(self) -> PyObject"""
        return ___init__.MapColoring_ElementColors(self, *args)

MapColoring_swigregister = ___init__.MapColoring_swigregister
MapColoring_swigregister(MapColoring)

class BlockMap(Object):
    """Proxy of C++ Epetra_BlockMap class"""
    __swig_setmethods__ = {}
    for _s in [Object]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BlockMap, name, value)
    __swig_getmethods__ = {}
    for _s in [Object]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BlockMap, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_BlockMap
    __del__ = lambda self : None;
    def LID(self, *args):
        """LID(self, int GID) -> int"""
        return ___init__.BlockMap_LID(self, *args)

    def GID(self, *args):
        """GID(self, int LID) -> int"""
        return ___init__.BlockMap_GID(self, *args)

    def MyGID(self, *args):
        """MyGID(self, int GID_in) -> bool"""
        return ___init__.BlockMap_MyGID(self, *args)

    def MyLID(self, *args):
        """MyLID(self, int LID_in) -> bool"""
        return ___init__.BlockMap_MyLID(self, *args)

    def MinAllGID(self, *args):
        """MinAllGID(self) -> int"""
        return ___init__.BlockMap_MinAllGID(self, *args)

    def MaxAllGID(self, *args):
        """MaxAllGID(self) -> int"""
        return ___init__.BlockMap_MaxAllGID(self, *args)

    def MinMyGID(self, *args):
        """MinMyGID(self) -> int"""
        return ___init__.BlockMap_MinMyGID(self, *args)

    def MaxMyGID(self, *args):
        """MaxMyGID(self) -> int"""
        return ___init__.BlockMap_MaxMyGID(self, *args)

    def MinLID(self, *args):
        """MinLID(self) -> int"""
        return ___init__.BlockMap_MinLID(self, *args)

    def MaxLID(self, *args):
        """MaxLID(self) -> int"""
        return ___init__.BlockMap_MaxLID(self, *args)

    def NumGlobalElements(self, *args):
        """NumGlobalElements(self) -> int"""
        return ___init__.BlockMap_NumGlobalElements(self, *args)

    def NumMyElements(self, *args):
        """NumMyElements(self) -> int"""
        return ___init__.BlockMap_NumMyElements(self, *args)

    def ElementSize(self, *args):
        """
        ElementSize(self) -> int
        ElementSize(self, int LID) -> int
        """
        return ___init__.BlockMap_ElementSize(self, *args)

    def FirstPointInElement(self, *args):
        """FirstPointInElement(self, int LID) -> int"""
        return ___init__.BlockMap_FirstPointInElement(self, *args)

    def IndexBase(self, *args):
        """IndexBase(self) -> int"""
        return ___init__.BlockMap_IndexBase(self, *args)

    def NumGlobalPoints(self, *args):
        """NumGlobalPoints(self) -> int"""
        return ___init__.BlockMap_NumGlobalPoints(self, *args)

    def NumMyPoints(self, *args):
        """NumMyPoints(self) -> int"""
        return ___init__.BlockMap_NumMyPoints(self, *args)

    def MinMyElementSize(self, *args):
        """MinMyElementSize(self) -> int"""
        return ___init__.BlockMap_MinMyElementSize(self, *args)

    def MaxMyElementSize(self, *args):
        """MaxMyElementSize(self) -> int"""
        return ___init__.BlockMap_MaxMyElementSize(self, *args)

    def MinElementSize(self, *args):
        """MinElementSize(self) -> int"""
        return ___init__.BlockMap_MinElementSize(self, *args)

    def MaxElementSize(self, *args):
        """MaxElementSize(self) -> int"""
        return ___init__.BlockMap_MaxElementSize(self, *args)

    def UniqueGIDs(self, *args):
        """UniqueGIDs(self) -> bool"""
        return ___init__.BlockMap_UniqueGIDs(self, *args)

    def ConstantElementSize(self, *args):
        """ConstantElementSize(self) -> bool"""
        return ___init__.BlockMap_ConstantElementSize(self, *args)

    def SameAs(self, *args):
        """SameAs(self, BlockMap Map) -> bool"""
        return ___init__.BlockMap_SameAs(self, *args)

    def PointSameAs(self, *args):
        """PointSameAs(self, BlockMap Map) -> bool"""
        return ___init__.BlockMap_PointSameAs(self, *args)

    def LinearMap(self, *args):
        """LinearMap(self) -> bool"""
        return ___init__.BlockMap_LinearMap(self, *args)

    def DistributedGlobal(self, *args):
        """DistributedGlobal(self) -> bool"""
        return ___init__.BlockMap_DistributedGlobal(self, *args)

    def Comm(self, *args):
        """Comm(self) -> Comm"""
        return ___init__.BlockMap_Comm(self, *args)

    def IsOneToOne(self, *args):
        """IsOneToOne(self) -> bool"""
        return ___init__.BlockMap_IsOneToOne(self, *args)

    def __init__(self, *args): 
        """
        __init__(self, int numGlobalElements, int elementSize, int indexBase,
             Comm comm) -> BlockMap

        BlockMap constructor with implicit local elements and constant element
        size.  Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             elementSize        - The number of degrees of freedom associated
                                  with every element.
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.

        __init__(self, int numGlobalElements, int numMyElements, int elementSize,
             int indexBase, Comm comm) -> BlockMap

        BlockMap constructor with specified number of local elements and
        constant element size.  Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             numMyElements      - Number of local elements on this processor.
             elementSize        - The number of degrees of freedom associated
                                  with every element.
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.

        __init__(self, int numGlobalElements, PySequence myGlobalElements,
             int elementSize, int indexBase, Comm comm) -> BlockMap

        BlockMap constructor with specified list of local elements and
        constant element size.  Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             myGlobalElements   - A sequence of integers specifying the global
                                  element indexes on this processor.
             elementSize        - The number of degrees of freedom associated
                                  with every element.
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.

        __init__(self, BlockMap map) -> BlockMap

        BlockMap copy constructor.

        __init__(self, int numGlobalElements, PySequence myGlobalElements,
             PySequence elementsSizes, int indexBase, Comm comm) -> BlockMap

        BlockMap constructor with specified list of local elements and
        specified list of element sizes.  Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             myGlobalElements   - A sequence of integers specifying the global
                                  element indexes on this processor.
             elementSizes       - A sequence of integers specifying the number of
                                  degrees of freedom associated with each element
                                  on this processor.
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.
        """
        this = ___init__.new_BlockMap(*args)
        try: self.this.append(this)
        except: self.this = this
    def RemoteIDList(self, *args):
        """
        RemoteIDList(self, PyObject GIDList) -> PyObject

        ``GIDList`` is a sequence of integer global IDs, and the return
        argument is the three-tuple ``(PIDList, LIDList, sizeList)``, which
        are ``numpy.ndarray`` objects of integers representing the processor
        IDs, local IDs and element sizes, respectively.
        """
        return ___init__.BlockMap_RemoteIDList(self, *args)

    def FindLocalElementID(self, *args):
        """
        FindLocalElementID(self, int pointID) -> PyObject

        Returns a tuple containing the local ID of the element that contains
        the given local pointID, and the offset of the point in that element.
        """
        return ___init__.BlockMap_FindLocalElementID(self, *args)

    def MyGlobalElements(self, *args):
        """
        MyGlobalElements(self) -> PyObject

        Returns a numpy array of integers specifying the list of global IDs on
        the processor.
        """
        return ___init__.BlockMap_MyGlobalElements(self, *args)

    def FirstPointInElementList(self, *args):
        """
        FirstPointInElementList(self) -> PyObject

        Returns a numpy array of integer first local point numbers for all of
        the local elements.
        """
        return ___init__.BlockMap_FirstPointInElementList(self, *args)

    def ElementSizeList(self, *args):
        """
        ElementSizeList(self) -> PyObject

        Returns a numpy array of integer sizes for each local element.
        """
        return ___init__.BlockMap_ElementSizeList(self, *args)

    def PointToElementList(self, *args):
        """
        PointToElementList(self) -> PyObject

        Returns a numpy array of integers such that for each local point, it
        indicates the local element ID that the point belongs to.
        """
        return ___init__.BlockMap_PointToElementList(self, *args)

BlockMap_swigregister = ___init__.BlockMap_swigregister
BlockMap_swigregister(BlockMap)

class Map(BlockMap):
    """Proxy of C++ Epetra_Map class"""
    __swig_setmethods__ = {}
    for _s in [BlockMap]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Map, name, value)
    __swig_getmethods__ = {}
    for _s in [BlockMap]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Map, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, int numGlobalElements, int indexBase, Comm comm) -> Map

        Map constructor with implicit number of elements per processor.
        Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.

        __init__(self, int numGlobalElements, int numMyElements, int indexBase,
             Comm comm) -> Map

        Map constructor with specified number of elements per processor.
        Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             numMyElements      - Number of local elements on this processor.
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.

        __init__(self, int numGlobalElements, PySequence myGlobalElements,
             int indexBase, Comm comm) -> Map

        Map constructor with specified list of global element IDs for each
        processor.  Arguments are:

             numGlobalElements  - Total number of elements over all processors.
                                  Specify -1 to have the constructor compute
                                  the number of global elements
             myGlobalElements   - A sequence of integers specifying the global
                                  element indexes on this processor.
             indexBase          - The base integer value for indexed array
                                  references.  Typically this is 0 for C/C++ and 1
                                  for Fortran, but it can be set to any integer
                                  value.
             comm               - The Epetra.Comm communicator. This communicator
                                  can in turn be queried for processor rank and
                                  size information.

        __init__(self, Map map) -> Map

        Map copy constructor.
        """
        this = ___init__.new_Map(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_Map
    __del__ = lambda self : None;
Map_swigregister = ___init__.Map_swigregister
Map_swigregister(Map)

class LocalMap(Map):
    """Proxy of C++ Epetra_LocalMap class"""
    __swig_setmethods__ = {}
    for _s in [Map]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LocalMap, name, value)
    __swig_getmethods__ = {}
    for _s in [Map]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LocalMap, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, int NumMyElements, int IndexBase, Comm Comm) -> LocalMap
        __init__(self, LocalMap map) -> LocalMap
        """
        this = ___init__.new_LocalMap(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_LocalMap
    __del__ = lambda self : None;
LocalMap_swigregister = ___init__.LocalMap_swigregister
LocalMap_swigregister(LocalMap)

class Directory(_object):
    """Proxy of C++ Epetra_Directory class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Directory, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Directory, name)
    def __init__(self, *args, **kwargs): raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_Directory
    __del__ = lambda self : None;
    def GetDirectoryEntries(self, *args):
        """
        GetDirectoryEntries(self, BlockMap Map, int NumEntries, int GlobalEntries, int Procs, 
            int LocalEntries, int EntrySizes, bool high_rank_sharing_procs = False) -> int
        """
        return ___init__.Directory_GetDirectoryEntries(self, *args)

    def GIDsAllUniquelyOwned(self, *args):
        """GIDsAllUniquelyOwned(self) -> bool"""
        return ___init__.Directory_GIDsAllUniquelyOwned(self, *args)

Directory_swigregister = ___init__.Directory_swigregister
Directory_swigregister(Directory)

class BasicDirectory(Directory):
    """Proxy of C++ Epetra_BasicDirectory class"""
    __swig_setmethods__ = {}
    for _s in [Directory]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BasicDirectory, name, value)
    __swig_getmethods__ = {}
    for _s in [Directory]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BasicDirectory, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, BlockMap Map) -> BasicDirectory
        __init__(self, BasicDirectory Directory) -> BasicDirectory
        """
        this = ___init__.new_BasicDirectory(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_BasicDirectory
    __del__ = lambda self : None;
    def GetDirectoryEntries(self, *args):
        """
        GetDirectoryEntries(self, BlockMap Map, int NumEntries, int GlobalEntries, int Procs, 
            int LocalEntries, int EntrySizes, bool high_rank_sharing_procs = False) -> int
        """
        return ___init__.BasicDirectory_GetDirectoryEntries(self, *args)

    def GIDsAllUniquelyOwned(self, *args):
        """GIDsAllUniquelyOwned(self) -> bool"""
        return ___init__.BasicDirectory_GIDsAllUniquelyOwned(self, *args)

BasicDirectory_swigregister = ___init__.BasicDirectory_swigregister
BasicDirectory_swigregister(BasicDirectory)

class Import(Object):
    """Proxy of C++ Epetra_Import class"""
    __swig_setmethods__ = {}
    for _s in [Object]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Import, name, value)
    __swig_getmethods__ = {}
    for _s in [Object]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Import, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, BlockMap TargetMap, BlockMap SourceMap) -> Import
        __init__(self, Import Importer) -> Import
        """
        this = ___init__.new_Import(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_Import
    __del__ = lambda self : None;
    def NumSameIDs(self, *args):
        """NumSameIDs(self) -> int"""
        return ___init__.Import_NumSameIDs(self, *args)

    def NumPermuteIDs(self, *args):
        """NumPermuteIDs(self) -> int"""
        return ___init__.Import_NumPermuteIDs(self, *args)

    def NumRemoteIDs(self, *args):
        """NumRemoteIDs(self) -> int"""
        return ___init__.Import_NumRemoteIDs(self, *args)

    def NumExportIDs(self, *args):
        """NumExportIDs(self) -> int"""
        return ___init__.Import_NumExportIDs(self, *args)

    def NumSend(self, *args):
        """NumSend(self) -> int"""
        return ___init__.Import_NumSend(self, *args)

    def NumRecv(self, *args):
        """NumRecv(self) -> int"""
        return ___init__.Import_NumRecv(self, *args)

    def SourceMap(self, *args):
        """SourceMap(self) -> BlockMap"""
        return ___init__.Import_SourceMap(self, *args)

    def TargetMap(self, *args):
        """TargetMap(self) -> BlockMap"""
        return ___init__.Import_TargetMap(self, *args)

    def Distributor(self, *args):
        """Distributor(self) -> Distributor"""
        return ___init__.Import_Distributor(self, *args)

    def PermuteFromLIDs(self, *args):
        """PermuteFromLIDs(self) -> PyObject"""
        return ___init__.Import_PermuteFromLIDs(self, *args)

    def PermuteToLIDs(self, *args):
        """PermuteToLIDs(self) -> PyObject"""
        return ___init__.Import_PermuteToLIDs(self, *args)

    def RemoteLIDs(self, *args):
        """RemoteLIDs(self) -> PyObject"""
        return ___init__.Import_RemoteLIDs(self, *args)

    def ExportLIDs(self, *args):
        """ExportLIDs(self) -> PyObject"""
        return ___init__.Import_ExportLIDs(self, *args)

    def ExportPIDs(self, *args):
        """ExportPIDs(self) -> PyObject"""
        return ___init__.Import_ExportPIDs(self, *args)

Import_swigregister = ___init__.Import_swigregister
Import_swigregister(Import)

class Export(Object):
    """Proxy of C++ Epetra_Export class"""
    __swig_setmethods__ = {}
    for _s in [Object]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Export, name, value)
    __swig_getmethods__ = {}
    for _s in [Object]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Export, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, BlockMap SourceMap, BlockMap TargetMap) -> Export
        __init__(self, Export Exporter) -> Export
        """
        this = ___init__.new_Export(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_Export
    __del__ = lambda self : None;
    def NumSameIDs(self, *args):
        """NumSameIDs(self) -> int"""
        return ___init__.Export_NumSameIDs(self, *args)

    def NumPermuteIDs(self, *args):
        """NumPermuteIDs(self) -> int"""
        return ___init__.Export_NumPermuteIDs(self, *args)

    def NumRemoteIDs(self, *args):
        """NumRemoteIDs(self) -> int"""
        return ___init__.Export_NumRemoteIDs(self, *args)

    def NumExportIDs(self, *args):
        """NumExportIDs(self) -> int"""
        return ___init__.Export_NumExportIDs(self, *args)

    def NumSend(self, *args):
        """NumSend(self) -> int"""
        return ___init__.Export_NumSend(self, *args)

    def NumRecv(self, *args):
        """NumRecv(self) -> int"""
        return ___init__.Export_NumRecv(self, *args)

    def SourceMap(self, *args):
        """SourceMap(self) -> BlockMap"""
        return ___init__.Export_SourceMap(self, *args)

    def TargetMap(self, *args):
        """TargetMap(self) -> BlockMap"""
        return ___init__.Export_TargetMap(self, *args)

    def Distributor(self, *args):
        """Distributor(self) -> Distributor"""
        return ___init__.Export_Distributor(self, *args)

    def PermuteFromLIDs(self, *args):
        """PermuteFromLIDs(self) -> PyObject"""
        return ___init__.Export_PermuteFromLIDs(self, *args)

    def PermuteToLIDs(self, *args):
        """PermuteToLIDs(self) -> PyObject"""
        return ___init__.Export_PermuteToLIDs(self, *args)

    def RemoteLIDs(self, *args):
        """RemoteLIDs(self) -> PyObject"""
        return ___init__.Export_RemoteLIDs(self, *args)

    def ExportLIDs(self, *args):
        """ExportLIDs(self) -> PyObject"""
        return ___init__.Export_ExportLIDs(self, *args)

    def ExportPIDs(self, *args):
        """ExportPIDs(self) -> PyObject"""
        return ___init__.Export_ExportPIDs(self, *args)

Export_swigregister = ___init__.Export_swigregister
Export_swigregister(Export)

class Operator(_object):
    """
    For cross-language polymorphism to work in python, you must call this
    constructor::

        from PyTrilinos import Epetra
        class MyOperator(Epetra.Operator):
            def __init__(self):
                Epetra.Operator.__init__(self)

    Other than that, the Epetra.Operator class is much more forgiving than
    its C++ counterpart.  Often, you can override just the Label() and
    Apply() methods.

    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Operator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Operator, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_Operator
    __del__ = lambda self : None;
    def SetUseTranspose(self, *args):
        """SetUseTranspose(self, bool UseTranspose) -> int"""
        return ___init__.Operator_SetUseTranspose(self, *args)

    def Apply(self, *args):
        """
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return ___init__.Operator_Apply(self, *args)

    def ApplyInverse(self, *args):
        """
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return ___init__.Operator_ApplyInverse(self, *args)

    def NormInf(self, *args):
        """NormInf(self) -> double"""
        return ___init__.Operator_NormInf(self, *args)

    def Label(self, *args):
        """Label(self) -> char"""
        return ___init__.Operator_Label(self, *args)

    def UseTranspose(self, *args):
        """UseTranspose(self) -> bool"""
        return ___init__.Operator_UseTranspose(self, *args)

    def HasNormInf(self, *args):
        """HasNormInf(self) -> bool"""
        return ___init__.Operator_HasNormInf(self, *args)

    def Comm(self, *args):
        """Comm(self) -> Comm"""
        return ___init__.Operator_Comm(self, *args)

    def OperatorDomainMap(self, *args):
        """OperatorDomainMap(self) -> Map"""
        return ___init__.Operator_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args):
        """OperatorRangeMap(self) -> Map"""
        return ___init__.Operator_OperatorRangeMap(self, *args)

    def __init__(self, *args): 
        """__init__(self) -> Operator"""
        if self.__class__ == Operator:
            _self = None
        else:
            _self = self
        this = ___init__.new_Operator(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    def __disown__(self):
        self.this.disown()
        ___init__.disown_Operator(self)
        return weakref_proxy(self)
Operator_swigregister = ___init__.Operator_swigregister
Operator_swigregister(Operator)

class InvOperator(Operator):
    """Proxy of C++ Epetra_InvOperator class"""
    __swig_setmethods__ = {}
    for _s in [Operator]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, InvOperator, name, value)
    __swig_getmethods__ = {}
    for _s in [Operator]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, InvOperator, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(self, Operator operatorIn) -> InvOperator"""
        if self.__class__ == InvOperator:
            _self = None
        else:
            _self = self
        this = ___init__.new_InvOperator(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_InvOperator
    __del__ = lambda self : None;
    def SetUseTranspose(self, *args):
        """SetUseTranspose(self, bool UseTranspose_in) -> int"""
        return ___init__.InvOperator_SetUseTranspose(self, *args)

    def Apply(self, *args):
        """
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return ___init__.InvOperator_Apply(self, *args)

    def ApplyInverse(self, *args):
        """
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return ___init__.InvOperator_ApplyInverse(self, *args)

    def NormInf(self, *args):
        """NormInf(self) -> double"""
        return ___init__.InvOperator_NormInf(self, *args)

    def Label(self, *args):
        """Label(self) -> char"""
        return ___init__.InvOperator_Label(self, *args)

    def Operator(self, *args):
        """Operator(self) -> Operator"""
        return ___init__.InvOperator_Operator(self, *args)

    def UseTranspose(self, *args):
        """UseTranspose(self) -> bool"""
        return ___init__.InvOperator_UseTranspose(self, *args)

    def HasNormInf(self, *args):
        """HasNormInf(self) -> bool"""
        return ___init__.InvOperator_HasNormInf(self, *args)

    def Comm(self, *args):
        """Comm(self) -> Comm"""
        return ___init__.InvOperator_Comm(self, *args)

    def OperatorDomainMap(self, *args):
        """OperatorDomainMap(self) -> Map"""
        return ___init__.InvOperator_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args):
        """OperatorRangeMap(self) -> Map"""
        return ___init__.InvOperator_OperatorRangeMap(self, *args)

    def __disown__(self):
        self.this.disown()
        ___init__.disown_InvOperator(self)
        return weakref_proxy(self)
InvOperator_swigregister = ___init__.InvOperator_swigregister
InvOperator_swigregister(InvOperator)

class RowMatrix(Operator,SrcDistObject):
    """Proxy of C++ Epetra_RowMatrix class"""
    __swig_setmethods__ = {}
    for _s in [Operator,SrcDistObject]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, RowMatrix, name, value)
    __swig_getmethods__ = {}
    for _s in [Operator,SrcDistObject]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, RowMatrix, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_RowMatrix
    __del__ = lambda self : None;
    def NumMyRowEntries(self, *args):
        """
        NumMyRowEntries(int myRow, numpy.ndarray numEntries) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....
        """
        return ___init__.RowMatrix_NumMyRowEntries(self, *args)

    def MaxNumEntries(self, *args):
        """MaxNumEntries(self) -> int"""
        return ___init__.RowMatrix_MaxNumEntries(self, *args)

    def ExtractMyRowCopy(self, *args):
        """
        ExtractMyRowCopy(int myRow, int length, numpy.ndarray numEntries,
            numpy.ndarray values, numpy.ndarray indices) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....

        Arguments values and indices are double* and int*, respectively, in
        C++.  In python, these are provided to you as numpy arrays of the
        given length, so that you may alter their entries in-place.
        """
        return ___init__.RowMatrix_ExtractMyRowCopy(self, *args)

    def ExtractDiagonalCopy(self, *args):
        """
        ExtractDiagonalCopy(Vector diagonal) -> int

        Argument diagonal is provided to you as a numpy-hybrid Epetra.Vector,
        giving you access to the numpy interface in addition to the
        Epetra_Vector C++ interface.
        """
        return ___init__.RowMatrix_ExtractDiagonalCopy(self, *args)

    def Multiply(self, *args):
        """
        Multiply(bool useTranspose, MultiVector x, MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.RowMatrix_Multiply(self, *args)

    def Solve(self, *args):
        """
        Solve((bool upper, bool trans, bool unitDiagonal, MultiVector x,
            MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.RowMatrix_Solve(self, *args)

    def InvRowSums(self, *args):
        """
        InvRowSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.RowMatrix_InvRowSums(self, *args)

    def LeftScale(self, *args):
        """
        LeftScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.RowMatrix_LeftScale(self, *args)

    def InvColSums(self, *args):
        """
        InvColSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.RowMatrix_InvColSums(self, *args)

    def RightScale(self, *args):
        """
        RightScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.RowMatrix_RightScale(self, *args)

    def Filled(self, *args):
        """Filled(self) -> bool"""
        return ___init__.RowMatrix_Filled(self, *args)

    def NormInf(self, *args):
        """NormInf(self) -> double"""
        return ___init__.RowMatrix_NormInf(self, *args)

    def NormOne(self, *args):
        """NormOne(self) -> double"""
        return ___init__.RowMatrix_NormOne(self, *args)

    def NumGlobalNonzeros(self, *args):
        """NumGlobalNonzeros(self) -> int"""
        return ___init__.RowMatrix_NumGlobalNonzeros(self, *args)

    def NumGlobalRows(self, *args):
        """NumGlobalRows(self) -> int"""
        return ___init__.RowMatrix_NumGlobalRows(self, *args)

    def NumGlobalCols(self, *args):
        """NumGlobalCols(self) -> int"""
        return ___init__.RowMatrix_NumGlobalCols(self, *args)

    def NumGlobalDiagonals(self, *args):
        """NumGlobalDiagonals(self) -> int"""
        return ___init__.RowMatrix_NumGlobalDiagonals(self, *args)

    def NumMyNonzeros(self, *args):
        """NumMyNonzeros(self) -> int"""
        return ___init__.RowMatrix_NumMyNonzeros(self, *args)

    def NumMyRows(self, *args):
        """NumMyRows(self) -> int"""
        return ___init__.RowMatrix_NumMyRows(self, *args)

    def NumMyCols(self, *args):
        """NumMyCols(self) -> int"""
        return ___init__.RowMatrix_NumMyCols(self, *args)

    def NumMyDiagonals(self, *args):
        """NumMyDiagonals(self) -> int"""
        return ___init__.RowMatrix_NumMyDiagonals(self, *args)

    def LowerTriangular(self, *args):
        """LowerTriangular(self) -> bool"""
        return ___init__.RowMatrix_LowerTriangular(self, *args)

    def UpperTriangular(self, *args):
        """UpperTriangular(self) -> bool"""
        return ___init__.RowMatrix_UpperTriangular(self, *args)

    def RowMatrixRowMap(self, *args):
        """RowMatrixRowMap(self) -> Map"""
        return ___init__.RowMatrix_RowMatrixRowMap(self, *args)

    def RowMatrixColMap(self, *args):
        """RowMatrixColMap(self) -> Map"""
        return ___init__.RowMatrix_RowMatrixColMap(self, *args)

    def RowMatrixImporter(self, *args):
        """RowMatrixImporter(self) -> Import"""
        return ___init__.RowMatrix_RowMatrixImporter(self, *args)

    def __init__(self, *args): 
        """__init__(self) -> RowMatrix"""
        if self.__class__ == RowMatrix:
            _self = None
        else:
            _self = self
        this = ___init__.new_RowMatrix(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    def __disown__(self):
        self.this.disown()
        ___init__.disown_RowMatrix(self)
        return weakref_proxy(self)
RowMatrix_swigregister = ___init__.RowMatrix_swigregister
RowMatrix_swigregister(RowMatrix)

class BasicRowMatrix(CompObject,Object,RowMatrix):
    """Proxy of C++ Epetra_BasicRowMatrix class"""
    __swig_setmethods__ = {}
    for _s in [CompObject,Object,RowMatrix]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BasicRowMatrix, name, value)
    __swig_getmethods__ = {}
    for _s in [CompObject,Object,RowMatrix]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, BasicRowMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(self, Comm Comm) -> BasicRowMatrix"""
        if self.__class__ == BasicRowMatrix:
            _self = None
        else:
            _self = self
        this = ___init__.new_BasicRowMatrix(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_BasicRowMatrix
    __del__ = lambda self : None;
    def SetMaps(self, *args):
        """
        SetMaps(self, Map RowMap, Map ColMap)
        SetMaps(self, Map RowMap, Map ColMap, Map DomainMap, Map RangeMap)
        """
        return ___init__.BasicRowMatrix_SetMaps(self, *args)

    def ExtractMyRowCopy(self, *args):
        """
        ExtractMyRowCopy(int myRow, int length, numpy.ndarray numEntries,
            numpy.ndarray values, numpy.ndarray indices) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....

        Arguments values and indices are double* and int*, respectively, in
        C++.  In python, these are provided to you as numpy arrays of the
        given length, so that you may alter their entries in-place.
        """
        return ___init__.BasicRowMatrix_ExtractMyRowCopy(self, *args)

    def ExtractMyEntryView(self, *args):
        """ExtractMyEntryView(self, int CurEntry, double Value, int RowIndex, int ColIndex) -> int"""
        return ___init__.BasicRowMatrix_ExtractMyEntryView(self, *args)

    def NumMyRowEntries(self, *args):
        """
        NumMyRowEntries(int myRow, numpy.ndarray numEntries) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....
        """
        return ___init__.BasicRowMatrix_NumMyRowEntries(self, *args)

    def Multiply(self, *args):
        """
        Multiply(bool useTranspose, MultiVector x, MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.BasicRowMatrix_Multiply(self, *args)

    def Solve(self, *args):
        """
        Solve((bool upper, bool trans, bool unitDiagonal, MultiVector x,
            MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.BasicRowMatrix_Solve(self, *args)

    def ExtractDiagonalCopy(self, *args):
        """
        ExtractDiagonalCopy(Vector diagonal) -> int

        Argument diagonal is provided to you as a numpy-hybrid Epetra.Vector,
        giving you access to the numpy interface in addition to the
        Epetra_Vector C++ interface.
        """
        return ___init__.BasicRowMatrix_ExtractDiagonalCopy(self, *args)

    def InvRowSums(self, *args):
        """
        InvRowSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.BasicRowMatrix_InvRowSums(self, *args)

    def LeftScale(self, *args):
        """
        LeftScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.BasicRowMatrix_LeftScale(self, *args)

    def InvColSums(self, *args):
        """
        InvColSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.BasicRowMatrix_InvColSums(self, *args)

    def RightScale(self, *args):
        """
        RightScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.BasicRowMatrix_RightScale(self, *args)

    def Filled(self, *args):
        """Filled(self) -> bool"""
        return ___init__.BasicRowMatrix_Filled(self, *args)

    def LowerTriangular(self, *args):
        """LowerTriangular(self) -> bool"""
        return ___init__.BasicRowMatrix_LowerTriangular(self, *args)

    def UpperTriangular(self, *args):
        """UpperTriangular(self) -> bool"""
        return ___init__.BasicRowMatrix_UpperTriangular(self, *args)

    def NormInf(self, *args):
        """NormInf(self) -> double"""
        return ___init__.BasicRowMatrix_NormInf(self, *args)

    def NormOne(self, *args):
        """NormOne(self) -> double"""
        return ___init__.BasicRowMatrix_NormOne(self, *args)

    def NumGlobalNonzeros(self, *args):
        """NumGlobalNonzeros(self) -> int"""
        return ___init__.BasicRowMatrix_NumGlobalNonzeros(self, *args)

    def NumGlobalRows(self, *args):
        """NumGlobalRows(self) -> int"""
        return ___init__.BasicRowMatrix_NumGlobalRows(self, *args)

    def NumGlobalCols(self, *args):
        """NumGlobalCols(self) -> int"""
        return ___init__.BasicRowMatrix_NumGlobalCols(self, *args)

    def NumGlobalDiagonals(self, *args):
        """NumGlobalDiagonals(self) -> int"""
        return ___init__.BasicRowMatrix_NumGlobalDiagonals(self, *args)

    def NumMyNonzeros(self, *args):
        """NumMyNonzeros(self) -> int"""
        return ___init__.BasicRowMatrix_NumMyNonzeros(self, *args)

    def NumMyRows(self, *args):
        """NumMyRows(self) -> int"""
        return ___init__.BasicRowMatrix_NumMyRows(self, *args)

    def NumMyCols(self, *args):
        """NumMyCols(self) -> int"""
        return ___init__.BasicRowMatrix_NumMyCols(self, *args)

    def NumMyDiagonals(self, *args):
        """NumMyDiagonals(self) -> int"""
        return ___init__.BasicRowMatrix_NumMyDiagonals(self, *args)

    def MaxNumEntries(self, *args):
        """MaxNumEntries(self) -> int"""
        return ___init__.BasicRowMatrix_MaxNumEntries(self, *args)

    def OperatorDomainMap(self, *args):
        """OperatorDomainMap(self) -> Map"""
        return ___init__.BasicRowMatrix_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args):
        """OperatorRangeMap(self) -> Map"""
        return ___init__.BasicRowMatrix_OperatorRangeMap(self, *args)

    def Map(self, *args):
        """Map(self) -> BlockMap"""
        return ___init__.BasicRowMatrix_Map(self, *args)

    def RowMatrixRowMap(self, *args):
        """RowMatrixRowMap(self) -> Map"""
        return ___init__.BasicRowMatrix_RowMatrixRowMap(self, *args)

    def RowMatrixColMap(self, *args):
        """RowMatrixColMap(self) -> Map"""
        return ___init__.BasicRowMatrix_RowMatrixColMap(self, *args)

    def RowMatrixImporter(self, *args):
        """RowMatrixImporter(self) -> Import"""
        return ___init__.BasicRowMatrix_RowMatrixImporter(self, *args)

    def Comm(self, *args):
        """Comm(self) -> Comm"""
        return ___init__.BasicRowMatrix_Comm(self, *args)

    def SetUseTranspose(self, *args):
        """SetUseTranspose(self, bool use_transpose) -> int"""
        return ___init__.BasicRowMatrix_SetUseTranspose(self, *args)

    def Label(self, *args):
        """Label(self) -> char"""
        return ___init__.BasicRowMatrix_Label(self, *args)

    def Apply(self, *args):
        """
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return ___init__.BasicRowMatrix_Apply(self, *args)

    def ApplyInverse(self, *args):
        """
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return ___init__.BasicRowMatrix_ApplyInverse(self, *args)

    def HasNormInf(self, *args):
        """HasNormInf(self) -> bool"""
        return ___init__.BasicRowMatrix_HasNormInf(self, *args)

    def UseTranspose(self, *args):
        """UseTranspose(self) -> bool"""
        return ___init__.BasicRowMatrix_UseTranspose(self, *args)

    def Importer(self, *args):
        """Importer(self) -> Import"""
        return ___init__.BasicRowMatrix_Importer(self, *args)

    def Exporter(self, *args):
        """Exporter(self) -> Export"""
        return ___init__.BasicRowMatrix_Exporter(self, *args)

    def ComputeStructureConstants(self, *args):
        """ComputeStructureConstants(self)"""
        return ___init__.BasicRowMatrix_ComputeStructureConstants(self, *args)

    def ComputeNumericConstants(self, *args):
        """ComputeNumericConstants(self)"""
        return ___init__.BasicRowMatrix_ComputeNumericConstants(self, *args)

    def __disown__(self):
        self.this.disown()
        ___init__.disown_BasicRowMatrix(self)
        return weakref_proxy(self)
BasicRowMatrix_swigregister = ___init__.BasicRowMatrix_swigregister
BasicRowMatrix_swigregister(BasicRowMatrix)

class CrsMatrix(DistObject,CompObject,BLAS,RowMatrix):
    """Proxy of C++ Epetra_CrsMatrix class"""
    __swig_setmethods__ = {}
    for _s in [DistObject,CompObject,BLAS,RowMatrix]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, CrsMatrix, name, value)
    __swig_getmethods__ = {}
    for _s in [DistObject,CompObject,BLAS,RowMatrix]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, CrsMatrix, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_CrsMatrix
    __del__ = lambda self : None;
    def PutScalar(self, *args):
        """PutScalar(self, double ScalarConstant) -> int"""
        return ___init__.CrsMatrix_PutScalar(self, *args)

    def Scale(self, *args):
        """Scale(self, double ScalarConstant) -> int"""
        return ___init__.CrsMatrix_Scale(self, *args)

    def ReplaceDiagonalValues(self, *args):
        """ReplaceDiagonalValues(self, Epetra_Vector Diagonal) -> int"""
        return ___init__.CrsMatrix_ReplaceDiagonalValues(self, *args)

    def FillComplete(self, *args):
        """
        FillComplete(self, bool OptimizeDataStorage = True) -> int
        FillComplete(self, Map DomainMap, Map RangeMap, bool OptimizeDataStorage = True) -> int
        """
        return ___init__.CrsMatrix_FillComplete(self, *args)

    def OptimizeStorage(self, *args):
        """OptimizeStorage(self) -> int"""
        return ___init__.CrsMatrix_OptimizeStorage(self, *args)

    def MakeDataContiguous(self, *args):
        """MakeDataContiguous(self) -> int"""
        return ___init__.CrsMatrix_MakeDataContiguous(self, *args)

    def ExtractDiagonalCopy(self, *args):
        """
        ExtractDiagonalCopy(Vector diagonal) -> int

        Argument diagonal is provided to you as a numpy-hybrid Epetra.Vector,
        giving you access to the numpy interface in addition to the
        Epetra_Vector C++ interface.
        """
        return ___init__.CrsMatrix_ExtractDiagonalCopy(self, *args)

    def Multiply(self, *args):
        """
        Multiply(bool useTranspose, MultiVector x, MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        Multiply(bool useTranspose, MultiVector x, MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.CrsMatrix_Multiply(self, *args)

    def Multiply1(self, *args):
        """
        Multiply1(self, bool TransA, Epetra_Vector x, Epetra_Vector y) -> int
        Multiply1(self, bool TransA, Epetra_MultiVector X, Epetra_MultiVector Y) -> int
        """
        return ___init__.CrsMatrix_Multiply1(self, *args)

    def Solve(self, *args):
        """
        Solve((bool upper, bool trans, bool unitDiagonal, MultiVector x,
            MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        Solve((bool upper, bool trans, bool unitDiagonal, MultiVector x,
            MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.CrsMatrix_Solve(self, *args)

    def InvRowSums(self, *args):
        """
        InvRowSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.CrsMatrix_InvRowSums(self, *args)

    def InvRowMaxs(self, *args):
        """InvRowMaxs(self, Epetra_Vector x) -> int"""
        return ___init__.CrsMatrix_InvRowMaxs(self, *args)

    def LeftScale(self, *args):
        """
        LeftScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.CrsMatrix_LeftScale(self, *args)

    def InvColSums(self, *args):
        """
        InvColSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.CrsMatrix_InvColSums(self, *args)

    def InvColMaxs(self, *args):
        """InvColMaxs(self, Epetra_Vector x) -> int"""
        return ___init__.CrsMatrix_InvColMaxs(self, *args)

    def RightScale(self, *args):
        """
        RightScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.CrsMatrix_RightScale(self, *args)

    def Filled(self, *args):
        """Filled(self) -> bool"""
        return ___init__.CrsMatrix_Filled(self, *args)

    def StorageOptimized(self, *args):
        """StorageOptimized(self) -> bool"""
        return ___init__.CrsMatrix_StorageOptimized(self, *args)

    def IndicesAreGlobal(self, *args):
        """IndicesAreGlobal(self) -> bool"""
        return ___init__.CrsMatrix_IndicesAreGlobal(self, *args)

    def IndicesAreLocal(self, *args):
        """IndicesAreLocal(self) -> bool"""
        return ___init__.CrsMatrix_IndicesAreLocal(self, *args)

    def IndicesAreContiguous(self, *args):
        """IndicesAreContiguous(self) -> bool"""
        return ___init__.CrsMatrix_IndicesAreContiguous(self, *args)

    def LowerTriangular(self, *args):
        """LowerTriangular(self) -> bool"""
        return ___init__.CrsMatrix_LowerTriangular(self, *args)

    def UpperTriangular(self, *args):
        """UpperTriangular(self) -> bool"""
        return ___init__.CrsMatrix_UpperTriangular(self, *args)

    def NoDiagonal(self, *args):
        """NoDiagonal(self) -> bool"""
        return ___init__.CrsMatrix_NoDiagonal(self, *args)

    def NormInf(self, *args):
        """NormInf(self) -> double"""
        return ___init__.CrsMatrix_NormInf(self, *args)

    def NormOne(self, *args):
        """NormOne(self) -> double"""
        return ___init__.CrsMatrix_NormOne(self, *args)

    def NormFrobenius(self, *args):
        """NormFrobenius(self) -> double"""
        return ___init__.CrsMatrix_NormFrobenius(self, *args)

    def NumGlobalNonzeros(self, *args):
        """NumGlobalNonzeros(self) -> int"""
        return ___init__.CrsMatrix_NumGlobalNonzeros(self, *args)

    def NumGlobalRows(self, *args):
        """NumGlobalRows(self) -> int"""
        return ___init__.CrsMatrix_NumGlobalRows(self, *args)

    def NumGlobalCols(self, *args):
        """NumGlobalCols(self) -> int"""
        return ___init__.CrsMatrix_NumGlobalCols(self, *args)

    def NumGlobalDiagonals(self, *args):
        """NumGlobalDiagonals(self) -> int"""
        return ___init__.CrsMatrix_NumGlobalDiagonals(self, *args)

    def NumMyNonzeros(self, *args):
        """NumMyNonzeros(self) -> int"""
        return ___init__.CrsMatrix_NumMyNonzeros(self, *args)

    def NumMyRows(self, *args):
        """NumMyRows(self) -> int"""
        return ___init__.CrsMatrix_NumMyRows(self, *args)

    def NumMyCols(self, *args):
        """NumMyCols(self) -> int"""
        return ___init__.CrsMatrix_NumMyCols(self, *args)

    def NumMyDiagonals(self, *args):
        """NumMyDiagonals(self) -> int"""
        return ___init__.CrsMatrix_NumMyDiagonals(self, *args)

    def NumGlobalEntries(self, *args):
        """NumGlobalEntries(self, int Row) -> int"""
        return ___init__.CrsMatrix_NumGlobalEntries(self, *args)

    def NumAllocatedGlobalEntries(self, *args):
        """NumAllocatedGlobalEntries(self, int Row) -> int"""
        return ___init__.CrsMatrix_NumAllocatedGlobalEntries(self, *args)

    def MaxNumEntries(self, *args):
        """MaxNumEntries(self) -> int"""
        return ___init__.CrsMatrix_MaxNumEntries(self, *args)

    def GlobalMaxNumEntries(self, *args):
        """GlobalMaxNumEntries(self) -> int"""
        return ___init__.CrsMatrix_GlobalMaxNumEntries(self, *args)

    def NumMyEntries(self, *args):
        """NumMyEntries(self, int Row) -> int"""
        return ___init__.CrsMatrix_NumMyEntries(self, *args)

    def NumAllocatedMyEntries(self, *args):
        """NumAllocatedMyEntries(self, int Row) -> int"""
        return ___init__.CrsMatrix_NumAllocatedMyEntries(self, *args)

    def IndexBase(self, *args):
        """IndexBase(self) -> int"""
        return ___init__.CrsMatrix_IndexBase(self, *args)

    def StaticGraph(self, *args):
        """StaticGraph(self) -> bool"""
        return ___init__.CrsMatrix_StaticGraph(self, *args)

    def Graph(self, *args):
        """Graph(self) -> CrsGraph"""
        return ___init__.CrsMatrix_Graph(self, *args)

    def RowMap(self, *args):
        """RowMap(self) -> Map"""
        return ___init__.CrsMatrix_RowMap(self, *args)

    def ReplaceRowMap(self, *args):
        """ReplaceRowMap(self, BlockMap newmap) -> int"""
        return ___init__.CrsMatrix_ReplaceRowMap(self, *args)

    def HaveColMap(self, *args):
        """HaveColMap(self) -> bool"""
        return ___init__.CrsMatrix_HaveColMap(self, *args)

    def ReplaceColMap(self, *args):
        """ReplaceColMap(self, BlockMap newmap) -> int"""
        return ___init__.CrsMatrix_ReplaceColMap(self, *args)

    def ColMap(self, *args):
        """ColMap(self) -> Map"""
        return ___init__.CrsMatrix_ColMap(self, *args)

    def DomainMap(self, *args):
        """DomainMap(self) -> Map"""
        return ___init__.CrsMatrix_DomainMap(self, *args)

    def RangeMap(self, *args):
        """RangeMap(self) -> Map"""
        return ___init__.CrsMatrix_RangeMap(self, *args)

    def Importer(self, *args):
        """Importer(self) -> Import"""
        return ___init__.CrsMatrix_Importer(self, *args)

    def Exporter(self, *args):
        """Exporter(self) -> Export"""
        return ___init__.CrsMatrix_Exporter(self, *args)

    def Comm(self, *args):
        """Comm(self) -> Comm"""
        return ___init__.CrsMatrix_Comm(self, *args)

    def LRID(self, *args):
        """LRID(self, int GRID_in) -> int"""
        return ___init__.CrsMatrix_LRID(self, *args)

    def GRID(self, *args):
        """GRID(self, int LRID_in) -> int"""
        return ___init__.CrsMatrix_GRID(self, *args)

    def LCID(self, *args):
        """LCID(self, int GCID_in) -> int"""
        return ___init__.CrsMatrix_LCID(self, *args)

    def GCID(self, *args):
        """GCID(self, int LCID_in) -> int"""
        return ___init__.CrsMatrix_GCID(self, *args)

    def MyGRID(self, *args):
        """MyGRID(self, int GRID_in) -> bool"""
        return ___init__.CrsMatrix_MyGRID(self, *args)

    def MyLRID(self, *args):
        """MyLRID(self, int LRID_in) -> bool"""
        return ___init__.CrsMatrix_MyLRID(self, *args)

    def MyGCID(self, *args):
        """MyGCID(self, int GCID_in) -> bool"""
        return ___init__.CrsMatrix_MyGCID(self, *args)

    def MyLCID(self, *args):
        """MyLCID(self, int LCID_in) -> bool"""
        return ___init__.CrsMatrix_MyLCID(self, *args)

    def MyGlobalRow(self, *args):
        """MyGlobalRow(self, int GID) -> bool"""
        return ___init__.CrsMatrix_MyGlobalRow(self, *args)

    def Label(self, *args):
        """Label(self) -> char"""
        return ___init__.CrsMatrix_Label(self, *args)

    def SetUseTranspose(self, *args):
        """SetUseTranspose(self, bool UseTranspose_in) -> int"""
        return ___init__.CrsMatrix_SetUseTranspose(self, *args)

    def Apply(self, *args):
        """
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return ___init__.CrsMatrix_Apply(self, *args)

    def ApplyInverse(self, *args):
        """
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return ___init__.CrsMatrix_ApplyInverse(self, *args)

    def HasNormInf(self, *args):
        """HasNormInf(self) -> bool"""
        return ___init__.CrsMatrix_HasNormInf(self, *args)

    def UseTranspose(self, *args):
        """UseTranspose(self) -> bool"""
        return ___init__.CrsMatrix_UseTranspose(self, *args)

    def OperatorDomainMap(self, *args):
        """OperatorDomainMap(self) -> Map"""
        return ___init__.CrsMatrix_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args):
        """OperatorRangeMap(self) -> Map"""
        return ___init__.CrsMatrix_OperatorRangeMap(self, *args)

    def NumMyRowEntries(self, *args):
        """
        NumMyRowEntries(int myRow, numpy.ndarray numEntries) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....
        """
        return ___init__.CrsMatrix_NumMyRowEntries(self, *args)

    def Map(self, *args):
        """Map(self) -> BlockMap"""
        return ___init__.CrsMatrix_Map(self, *args)

    def RowMatrixRowMap(self, *args):
        """RowMatrixRowMap(self) -> Map"""
        return ___init__.CrsMatrix_RowMatrixRowMap(self, *args)

    def RowMatrixColMap(self, *args):
        """RowMatrixColMap(self) -> Map"""
        return ___init__.CrsMatrix_RowMatrixColMap(self, *args)

    def RowMatrixImporter(self, *args):
        """RowMatrixImporter(self) -> Import"""
        return ___init__.CrsMatrix_RowMatrixImporter(self, *args)

    def SortGhostsAssociatedWithEachProcessor(self, *args):
        """SortGhostsAssociatedWithEachProcessor(self, bool Flag) -> int"""
        return ___init__.CrsMatrix_SortGhostsAssociatedWithEachProcessor(self, *args)

    def ImportMap(self, *args):
        """ImportMap(self) -> Map"""
        return ___init__.CrsMatrix_ImportMap(self, *args)

    def TransformToLocal(self, *args):
        """
        TransformToLocal(self) -> int
        TransformToLocal(self, Map DomainMap, Map RangeMap) -> int
        """
        return ___init__.CrsMatrix_TransformToLocal(self, *args)

    def InsertGlobalValues(self, *args):
        """
        InsertGlobalValues(self, int globalRow, PySequence values, PySequence
            indices) -> int

          Arguments:

            globalRow - global row index
            values    - a sequence of doubles that represent the values to insert
            indices   - a sequence of integers that represent the indices to insert

        InsertGlobalValues(self, PySequence rows, PySequence cols, PySequence
            values) -> int

          Arguments:

            rows    - a sequence of integers that represent the row indices to insert
            cols    - a sequence of integers that represent the column indices to
                      insert
            values  - a sequence of doubles that represent the values to insert

        """
        return ___init__.CrsMatrix_InsertGlobalValues(self, *args)

    def ReplaceGlobalValues(self, *args):
        """
        ReplaceGlobalValues(self, int globalRow, PySequence values, PySequence
            indices) -> int

          Arguments:

            globalRow - global row index
            values    - a sequence of doubles that represent the values to replace
            indices   - a sequence of integers that represent the indices to replace

        ReplaceGlobalValues(self, PySequence rows, PySequence cols, PySequence
            values) -> int

          Arguments:

            rows    - a sequence of integers that represent the row indices to replace
            cols    - a sequence of integers that represent the column indices to
                      replace
            values  - a sequence of doubles that represent the values to replace

        """
        return ___init__.CrsMatrix_ReplaceGlobalValues(self, *args)

    def SumIntoGlobalValues(self, *args):
        """
        SumIntoGlobalValues(self, int globalRow, PySequence values, PySequence
            indices) -> int

          Arguments:

            globalRow - global row index
            values    - a sequence of doubles that represent the values to sum into
            indices   - a sequence of integers that represent the indices to sum into

        SumIntoGlobalValues(self, PySequence rows, PySequence cols, PySequence
            values) -> int

          Arguments:

            rows    - a sequence of integers that represent the row indices to sum into
            cols    - a sequence of integers that represent the column indices to
                      sum into
            values  - a sequence of doubles that represent the values to sum into

        """
        return ___init__.CrsMatrix_SumIntoGlobalValues(self, *args)

    def InsertMyValues(self, *args):
        """
        InsertMyValues(self, int myRow, PySequence values, PySequence indices) -> int

          Arguments:

            myRow     - local row index
            values    - a sequence of doubles that represent the values to insert
            indices   - a sequence of integers that represent the indices to insert

        InsertMyValues(self, PySequence rows, PySequence cols, PySequence
            values) -> int

          Arguments:

            rows    - a sequence of integers that represent the row indices to insert
            cols    - a sequence of integers that represent the column indices to
                      insert
            values  - a sequence of doubles that represent the values to insert

        """
        return ___init__.CrsMatrix_InsertMyValues(self, *args)

    def ReplaceMyValues(self, *args):
        """
        ReplaceMyValues(self, int myRow, PySequence values, PySequence indices) -> int

          Arguments:

            myRow     - local row index
            values    - a sequence of doubles that represent the values to replace
            indices   - a sequence of integers that represent the indices to replace

        ReplaceMyValues(self, PySequence rows, PySequence cols, PySequence
            values) -> int

          Arguments:

            rows    - a sequence of integers that represent the row indices to replace
            cols    - a sequence of integers that represent the column indices to
                      replace
            values  - a sequence of doubles that represent the values to replace

        """
        return ___init__.CrsMatrix_ReplaceMyValues(self, *args)

    def SumIntoMyValues(self, *args):
        """
        SumIntoMyValues(self, int myRow, PySequence values, PySequence indices) -> int

          Arguments:

            myRow     - local row index
            values    - a sequence of doubles that represent the values to sum into
            indices   - a sequence of integers that represent the indices to sum into

        SumIntoMyValues(self, PyObject Rows, PyObject Cols, PyObject Values) -> int
        """
        return ___init__.CrsMatrix_SumIntoMyValues(self, *args)

    def __init__(self, *args): 
        """
        __init__(self, Epetra_DataAccess CV, Map rowMap, int numEntriesPerRow, 
            bool staticProfile=False) -> CrsMatrix

          CrsMatrix constructor with implicit column map and constant number
          of entries per row.  Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - describes distribution of rows across processors
            numEntriesPerRow  - constant number of entries per row
            staticProfile     - static profile flag

        __init__(self, Epetra_DataAccess CV, Map rowMap, Map colMap, int numEntriesPerRow, 
            bool staticProfile=False) -> CrsMatrix

          CrsMatrix constructor with specified column map and constant number
          of entries per row.  Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - describes distribution of rows across processors
            colMap            - describes distribution of columns across processors
            numEntriesPerRow  - constant number of entries per row
            staticProfile     - static profile flag

        __init__(self, Epetra_DataAccess CV, CrsGraph graph) -> CrsMatrix

          CrsMatrix constructor with CrsGraph.  Arguments:

            CV     - Epetra.Copy or Epetra.View
            graph  - CrsGraph describing structure of matrix

        __init__(self, CrsMatrix matrix) -> CrsMatrix

          CrsMatrix copy constructor.  Argument:

            matrix  - source CrsMatrix

        __init__(self, Epetra_DataAccess CV, Map rowMap, PySequence numEntriesPerRow, 
            bool staticProfile=False) -> CrsMatrix

          CrsMatrix constructor with implicit column map and variable number
          of entries per row.  Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - describes distribution of rows across processors
            numEntriesPerRow  - variable number of entries per row
            staticProfile     - static profile flag

        __init__(self, Epetra_DataAccess CV, Map rowMap, Map colMap, PySequence
            numEntriesPerRow, bool staticProfile=False) -> CrsMatrix

          CrsMatrix constructor with specified column map and variable number
          of entries per row.  Arguments:

            CV                - Epetra.Copy or Epetra.View
            rowMap            - describes distribution of rows across processors
            colMap            - describes distribution of columns across processors
            numEntriesPerRow  - variable number of entries per row
            staticProfile     - static profile flag

        """
        this = ___init__.new_CrsMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    def ExtractGlobalRowCopy(self, *args):
        """
        ExtractGlobalRowCopy(self, int globalRow) -> (numpy.ndarray,numpy.ndarray)

          Returns a two-tuple of numpy arrays of the same size; the first is
          an array of integers that represent the nonzero columns on the
          matrix; the second is an array of doubles that represent the values
          of the matrix entries.  The input argument is a global row index.
        """
        return ___init__.CrsMatrix_ExtractGlobalRowCopy(self, *args)

    def ExtractMyRowCopy(self, *args):
        """
        ExtractMyRowCopy(self, int myRow) -> (numpy.ndarray,numpy.ndarray)

          Returns a two-tuple of numpy arrays of the same size; the first is
          an array of integers that represent the nonzero columns on the
          matrix; the second is an array of doubles that represent the values
          of the matrix entries.  The input argument is a local row index.
        """
        return ___init__.CrsMatrix_ExtractMyRowCopy(self, *args)

    def __setitem__(self, *args):
        """
        __setitem__(self, PyTuple index, double val)

        The __setitem__() method is called when square-bracket indexing is
        used to set a value of the matrix.  For example, the last line of::

            comm = Epetra.SerialComm()
            m = Epetra.CrsMatrix(9,0,comm)
            m[0,0] = 3.14

        calls::

            m.__setitem__((0,0), 3.14)

        Thus, argument 'index' is a tuple filled with whatever indices you
        give the square-bracket operator when setting.  For __setitem__(),
        this raises an IndexError unless 'index' is a two-tuple of integers.
        Argument 'val' must be convertible to a double.  Under the covers,
        __setitem__() calls ReplaceGlobalValues() or InsertGlobalValues() as
        necessary, so the indices are expected to be global IDs.  Note that if
        you use __setitem__() to insert a new matrix element, you will need to
        call FillComplete() again, whether or not you have called it before.

        """
        return ___init__.CrsMatrix___setitem__(self, *args)

    def __getitem__(self, *args):
        """
        __getitem__(self, PyTuple index) -> double
        __getitem__(self, int row) -> numpy.ndarray

        The __getitem__() method is called when square-bracket indexing is
        used to get a value from the matrix.  For example, the last two lines
        of::

            comm = Epetra.SerialComm()
            m = Epetra.CrsMatrix(9,0,comm)
            m.InsertGlobalValues(0, [0.0, 1.0, 2.0], [0,1,2])
            diag = m[0,0]
            row  = m[0]

        call::

            m.__getitem__((0,0))
            m.__getitem__(0)

        The __getitem__() method behaves according to the following table:

                            FillComplete()    #    
            Index               called      procs  Return value
            --------------  --------------  -----  ---------------------------
            single integer       true        any   numpy array of doubles
            single integer       false        1    numpy array of doubles
            single integer       false       >1    raise IndexError
            two integers         either      any   double

        You should provide global IDs as the integer indices if FillComplete()
        has been called.  If not, you should provide local IDs.  If you
        reference a matrix element that is off-processor, __getitem__() will
        raise an IndexError.

        Under the covers, __getitem__() will call ExtractGlobalRowView() if
        FillComplete() has been called, or ExtractMyRowView() if it has not.
        If either of these return a non-zero return code, this is converted to
        a python RuntimeError.  The resulting data is copied to the output
        array.

        """
        return ___init__.CrsMatrix___getitem__(self, *args)

CrsMatrix_swigregister = ___init__.CrsMatrix_swigregister
CrsMatrix_swigregister(CrsMatrix)

class FECrsMatrix(CrsMatrix):
    """Proxy of C++ Epetra_FECrsMatrix class"""
    __swig_setmethods__ = {}
    for _s in [CrsMatrix]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FECrsMatrix, name, value)
    __swig_getmethods__ = {}
    for _s in [CrsMatrix]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FECrsMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, Epetra_DataAccess CV, Map RowMap, int NumEntriesPerRow, 
            bool ignoreNonLocalEntries = False) -> FECrsMatrix
        __init__(self, Epetra_DataAccess CV, Map RowMap, int NumEntriesPerRow, 
            bool ignoreNonLocalEntries = False) -> FECrsMatrix
        __init__(self, Epetra_DataAccess CV, Map RowMap, Map ColMap, int NumEntriesPerRow, 
            bool ignoreNonLocalEntries = False) -> FECrsMatrix
        __init__(self, Epetra_DataAccess CV, Map RowMap, Map ColMap, int NumEntriesPerRow, 
            bool ignoreNonLocalEntries = False) -> FECrsMatrix
        __init__(self, Epetra_DataAccess CV, CrsGraph Graph, bool ignoreNonLocalEntries = False) -> FECrsMatrix
        __init__(self, FECrsMatrix src) -> FECrsMatrix
        """
        this = ___init__.new_FECrsMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_FECrsMatrix
    __del__ = lambda self : None;
    ROW_MAJOR = ___init__.FECrsMatrix_ROW_MAJOR
    COLUMN_MAJOR = ___init__.FECrsMatrix_COLUMN_MAJOR
    def GlobalAssemble(self, *args):
        """
        GlobalAssemble(self, bool callFillComplete = True) -> int
        GlobalAssemble(self, Map domain_map, Map range_map, bool callFillComplete = True) -> int
        """
        return ___init__.FECrsMatrix_GlobalAssemble(self, *args)

    def setIgnoreNonLocalEntries(self, *args):
        """setIgnoreNonLocalEntries(self, bool flag)"""
        return ___init__.FECrsMatrix_setIgnoreNonLocalEntries(self, *args)

    def __setitem__(self, *args):
        """__setitem__(self, PyObject args, double val)"""
        return ___init__.FECrsMatrix___setitem__(self, *args)

    def __getitem__(self, *args):
        """__getitem__(self, PyObject args) -> PyObject"""
        return ___init__.FECrsMatrix___getitem__(self, *args)

    def InsertGlobalValues(self, *args):
        """
        InsertGlobalValues(self, int Row, int Size, Epetra_SerialDenseVector Values, 
            Epetra_IntSerialDenseVector Entries) -> int
        """
        return ___init__.FECrsMatrix_InsertGlobalValues(self, *args)

    def InsertGlobalValue(self, *args):
        """InsertGlobalValue(self, int i, int j, double val) -> int"""
        return ___init__.FECrsMatrix_InsertGlobalValue(self, *args)

FECrsMatrix_swigregister = ___init__.FECrsMatrix_swigregister
FECrsMatrix_swigregister(FECrsMatrix)

class CrsSingletonFilter(_object):
    """Proxy of C++ Epetra_CrsSingletonFilter class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CrsSingletonFilter, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CrsSingletonFilter, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(self) -> CrsSingletonFilter"""
        this = ___init__.new_CrsSingletonFilter(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_CrsSingletonFilter
    __del__ = lambda self : None;
    def Analyze(self, *args):
        """Analyze(self, RowMatrix FullMatrix) -> int"""
        return ___init__.CrsSingletonFilter_Analyze(self, *args)

    def SingletonsDetected(self, *args):
        """SingletonsDetected(self) -> bool"""
        return ___init__.CrsSingletonFilter_SingletonsDetected(self, *args)

    def ConstructReducedProblem(self, *args):
        """ConstructReducedProblem(self, LinearProblem Problem) -> int"""
        return ___init__.CrsSingletonFilter_ConstructReducedProblem(self, *args)

    def UpdateReducedProblem(self, *args):
        """UpdateReducedProblem(self, LinearProblem Problem) -> int"""
        return ___init__.CrsSingletonFilter_UpdateReducedProblem(self, *args)

    def ComputeFullSolution(self, *args):
        """ComputeFullSolution(self) -> int"""
        return ___init__.CrsSingletonFilter_ComputeFullSolution(self, *args)

    def NumRowSingletons(self, *args):
        """NumRowSingletons(self) -> int"""
        return ___init__.CrsSingletonFilter_NumRowSingletons(self, *args)

    def NumColSingletons(self, *args):
        """NumColSingletons(self) -> int"""
        return ___init__.CrsSingletonFilter_NumColSingletons(self, *args)

    def NumSingletons(self, *args):
        """NumSingletons(self) -> int"""
        return ___init__.CrsSingletonFilter_NumSingletons(self, *args)

    def RatioOfDimensions(self, *args):
        """RatioOfDimensions(self) -> double"""
        return ___init__.CrsSingletonFilter_RatioOfDimensions(self, *args)

    def RatioOfNonzeros(self, *args):
        """RatioOfNonzeros(self) -> double"""
        return ___init__.CrsSingletonFilter_RatioOfNonzeros(self, *args)

    def FullProblem(self, *args):
        """FullProblem(self) -> LinearProblem"""
        return ___init__.CrsSingletonFilter_FullProblem(self, *args)

    def ReducedProblem(self, *args):
        """ReducedProblem(self) -> LinearProblem"""
        return ___init__.CrsSingletonFilter_ReducedProblem(self, *args)

    def FullMatrix(self, *args):
        """FullMatrix(self) -> RowMatrix"""
        return ___init__.CrsSingletonFilter_FullMatrix(self, *args)

    def ReducedMatrix(self, *args):
        """ReducedMatrix(self) -> CrsMatrix"""
        return ___init__.CrsSingletonFilter_ReducedMatrix(self, *args)

    def RowMapColors(self, *args):
        """RowMapColors(self) -> MapColoring"""
        return ___init__.CrsSingletonFilter_RowMapColors(self, *args)

    def ColMapColors(self, *args):
        """ColMapColors(self) -> MapColoring"""
        return ___init__.CrsSingletonFilter_ColMapColors(self, *args)

    def ReducedMatrixRowMap(self, *args):
        """ReducedMatrixRowMap(self) -> Map"""
        return ___init__.CrsSingletonFilter_ReducedMatrixRowMap(self, *args)

    def ReducedMatrixColMap(self, *args):
        """ReducedMatrixColMap(self) -> Map"""
        return ___init__.CrsSingletonFilter_ReducedMatrixColMap(self, *args)

    def ReducedMatrixDomainMap(self, *args):
        """ReducedMatrixDomainMap(self) -> Map"""
        return ___init__.CrsSingletonFilter_ReducedMatrixDomainMap(self, *args)

    def ReducedMatrixRangeMap(self, *args):
        """ReducedMatrixRangeMap(self) -> Map"""
        return ___init__.CrsSingletonFilter_ReducedMatrixRangeMap(self, *args)

CrsSingletonFilter_swigregister = ___init__.CrsSingletonFilter_swigregister
CrsSingletonFilter_swigregister(CrsSingletonFilter)

class VbrMatrix(DistObject,CompObject,BLAS,RowMatrix):
    """Proxy of C++ Epetra_VbrMatrix class"""
    __swig_setmethods__ = {}
    for _s in [DistObject,CompObject,BLAS,RowMatrix]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, VbrMatrix, name, value)
    __swig_getmethods__ = {}
    for _s in [DistObject,CompObject,BLAS,RowMatrix]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, VbrMatrix, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_VbrMatrix
    __del__ = lambda self : None;
    def PutScalar(self, *args):
        """PutScalar(self, double ScalarConstant) -> int"""
        return ___init__.VbrMatrix_PutScalar(self, *args)

    def Scale(self, *args):
        """Scale(self, double ScalarConstant) -> int"""
        return ___init__.VbrMatrix_Scale(self, *args)

    def BeginInsertGlobalValues(self, *args):
        """BeginInsertGlobalValues(self, int BlockRow, int NumBlockEntries) -> int"""
        return ___init__.VbrMatrix_BeginInsertGlobalValues(self, *args)

    def BeginInsertMyValues(self, *args):
        """BeginInsertMyValues(self, int BlockRow, int NumBlockEntries) -> int"""
        return ___init__.VbrMatrix_BeginInsertMyValues(self, *args)

    def BeginReplaceGlobalValues(self, *args):
        """BeginReplaceGlobalValues(self, int BlockRow, int NumBlockEntries) -> int"""
        return ___init__.VbrMatrix_BeginReplaceGlobalValues(self, *args)

    def BeginReplaceMyValues(self, *args):
        """BeginReplaceMyValues(self, int BlockRow, int NumBlockEntries) -> int"""
        return ___init__.VbrMatrix_BeginReplaceMyValues(self, *args)

    def BeginSumIntoGlobalValues(self, *args):
        """BeginSumIntoGlobalValues(self, int BlockRow, int NumBlockEntries) -> int"""
        return ___init__.VbrMatrix_BeginSumIntoGlobalValues(self, *args)

    def BeginSumIntoMyValues(self, *args):
        """BeginSumIntoMyValues(self, int BlockRow, int NumBlockEntries) -> int"""
        return ___init__.VbrMatrix_BeginSumIntoMyValues(self, *args)

    def SubmitBlockEntry(self, *args):
        """
        SubmitBlockEntry(self, double Values, int LDA, int NumRows, int NumCols) -> int
        SubmitBlockEntry(self, Epetra_SerialDenseMatrix Mat) -> int
        """
        return ___init__.VbrMatrix_SubmitBlockEntry(self, *args)

    def EndSubmitEntries(self, *args):
        """EndSubmitEntries(self) -> int"""
        return ___init__.VbrMatrix_EndSubmitEntries(self, *args)

    def ReplaceDiagonalValues(self, *args):
        """ReplaceDiagonalValues(self, Epetra_Vector Diagonal) -> int"""
        return ___init__.VbrMatrix_ReplaceDiagonalValues(self, *args)

    def FillComplete(self, *args):
        """
        FillComplete(self) -> int
        FillComplete(self, BlockMap DomainMap, BlockMap RangeMap) -> int
        """
        return ___init__.VbrMatrix_FillComplete(self, *args)

    def Filled(self, *args):
        """Filled(self) -> bool"""
        return ___init__.VbrMatrix_Filled(self, *args)

    def ExtractGlobalBlockRowPointers(self, *args):
        """
        ExtractGlobalBlockRowPointers(self, int BlockRow, int MaxNumBlockEntries, int RowDim, int NumBlockEntries, 
            int BlockIndices, Epetra_SerialDenseMatrix Values) -> int
        """
        return ___init__.VbrMatrix_ExtractGlobalBlockRowPointers(self, *args)

    def ExtractMyBlockRowPointers(self, *args):
        """
        ExtractMyBlockRowPointers(self, int BlockRow, int MaxNumBlockEntries, int RowDim, int NumBlockEntries, 
            int BlockIndices, Epetra_SerialDenseMatrix Values) -> int
        """
        return ___init__.VbrMatrix_ExtractMyBlockRowPointers(self, *args)

    def BeginExtractGlobalBlockRowCopy(self, *args):
        """
        BeginExtractGlobalBlockRowCopy(self, int BlockRow, int MaxNumBlockEntries, int RowDim, int NumBlockEntries, 
            int BlockIndices, int ColDims) -> int
        """
        return ___init__.VbrMatrix_BeginExtractGlobalBlockRowCopy(self, *args)

    def BeginExtractMyBlockRowCopy(self, *args):
        """
        BeginExtractMyBlockRowCopy(self, int BlockRow, int MaxNumBlockEntries, int RowDim, int NumBlockEntries, 
            int BlockIndices, int ColDims) -> int
        """
        return ___init__.VbrMatrix_BeginExtractMyBlockRowCopy(self, *args)

    def ExtractEntryCopy(self, *args):
        """ExtractEntryCopy(self, int SizeOfValues, double Values, int LDA, bool SumInto) -> int"""
        return ___init__.VbrMatrix_ExtractEntryCopy(self, *args)

    def BeginExtractGlobalBlockRowView(self, *args):
        """BeginExtractGlobalBlockRowView(self, int BlockRow, int RowDim, int NumBlockEntries, int BlockIndices) -> int"""
        return ___init__.VbrMatrix_BeginExtractGlobalBlockRowView(self, *args)

    def BeginExtractMyBlockRowView(self, *args):
        """BeginExtractMyBlockRowView(self, int BlockRow, int RowDim, int NumBlockEntries, int BlockIndices) -> int"""
        return ___init__.VbrMatrix_BeginExtractMyBlockRowView(self, *args)

    def ExtractEntryView(self, *args):
        """ExtractEntryView(self, Epetra_SerialDenseMatrix entry) -> int"""
        return ___init__.VbrMatrix_ExtractEntryView(self, *args)

    def ExtractGlobalBlockRowView(self, *args):
        """
        ExtractGlobalBlockRowView(self, int BlockRow, int RowDim, int NumBlockEntries, int BlockIndices, 
            Epetra_SerialDenseMatrix Values) -> int
        """
        return ___init__.VbrMatrix_ExtractGlobalBlockRowView(self, *args)

    def ExtractMyBlockRowView(self, *args):
        """
        ExtractMyBlockRowView(self, int BlockRow, int RowDim, int NumBlockEntries, int BlockIndices, 
            Epetra_SerialDenseMatrix Values) -> int
        """
        return ___init__.VbrMatrix_ExtractMyBlockRowView(self, *args)

    def ExtractDiagonalCopy(self, *args):
        """
        ExtractDiagonalCopy(Vector diagonal) -> int

        Argument diagonal is provided to you as a numpy-hybrid Epetra.Vector,
        giving you access to the numpy interface in addition to the
        Epetra_Vector C++ interface.
        """
        return ___init__.VbrMatrix_ExtractDiagonalCopy(self, *args)

    def BeginExtractBlockDiagonalCopy(self, *args):
        """
        BeginExtractBlockDiagonalCopy(self, int MaxNumBlockDiagonalEntries, int NumBlockDiagonalEntries, 
            int RowColDims) -> int
        """
        return ___init__.VbrMatrix_BeginExtractBlockDiagonalCopy(self, *args)

    def ExtractBlockDiagonalEntryCopy(self, *args):
        """ExtractBlockDiagonalEntryCopy(self, int SizeOfValues, double Values, int LDA, bool SumInto) -> int"""
        return ___init__.VbrMatrix_ExtractBlockDiagonalEntryCopy(self, *args)

    def BeginExtractBlockDiagonalView(self, *args):
        """BeginExtractBlockDiagonalView(self, int NumBlockDiagonalEntries, int RowColDims) -> int"""
        return ___init__.VbrMatrix_BeginExtractBlockDiagonalView(self, *args)

    def ExtractBlockDiagonalEntryView(self, *args):
        """ExtractBlockDiagonalEntryView(self, double Values, int LDA) -> int"""
        return ___init__.VbrMatrix_ExtractBlockDiagonalEntryView(self, *args)

    def Multiply1(self, *args):
        """Multiply1(self, bool TransA, Epetra_Vector x, Epetra_Vector y) -> int"""
        return ___init__.VbrMatrix_Multiply1(self, *args)

    def Multiply(self, *args):
        """
        Multiply(bool useTranspose, MultiVector x, MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.VbrMatrix_Multiply(self, *args)

    def Solve(self, *args):
        """
        Solve((bool upper, bool trans, bool unitDiagonal, MultiVector x,
            MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.VbrMatrix_Solve(self, *args)

    def InvRowSums(self, *args):
        """
        InvRowSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.VbrMatrix_InvRowSums(self, *args)

    def LeftScale(self, *args):
        """
        LeftScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.VbrMatrix_LeftScale(self, *args)

    def InvColSums(self, *args):
        """
        InvColSums(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.VbrMatrix_InvColSums(self, *args)

    def RightScale(self, *args):
        """
        RightScale(Vector x) -> int

        Argument x is provided to you as a numpy-hybrid Epetra.Vector, giving
        you access to the numpy interface in addition to the Epetra_Vector C++
        interface.
        """
        return ___init__.VbrMatrix_RightScale(self, *args)

    def OptimizeStorage(self, *args):
        """OptimizeStorage(self) -> int"""
        return ___init__.VbrMatrix_OptimizeStorage(self, *args)

    def StorageOptimized(self, *args):
        """StorageOptimized(self) -> bool"""
        return ___init__.VbrMatrix_StorageOptimized(self, *args)

    def IndicesAreGlobal(self, *args):
        """IndicesAreGlobal(self) -> bool"""
        return ___init__.VbrMatrix_IndicesAreGlobal(self, *args)

    def IndicesAreLocal(self, *args):
        """IndicesAreLocal(self) -> bool"""
        return ___init__.VbrMatrix_IndicesAreLocal(self, *args)

    def IndicesAreContiguous(self, *args):
        """IndicesAreContiguous(self) -> bool"""
        return ___init__.VbrMatrix_IndicesAreContiguous(self, *args)

    def LowerTriangular(self, *args):
        """LowerTriangular(self) -> bool"""
        return ___init__.VbrMatrix_LowerTriangular(self, *args)

    def UpperTriangular(self, *args):
        """UpperTriangular(self) -> bool"""
        return ___init__.VbrMatrix_UpperTriangular(self, *args)

    def NoDiagonal(self, *args):
        """NoDiagonal(self) -> bool"""
        return ___init__.VbrMatrix_NoDiagonal(self, *args)

    def NormInf(self, *args):
        """NormInf(self) -> double"""
        return ___init__.VbrMatrix_NormInf(self, *args)

    def NormOne(self, *args):
        """NormOne(self) -> double"""
        return ___init__.VbrMatrix_NormOne(self, *args)

    def NormFrobenius(self, *args):
        """NormFrobenius(self) -> double"""
        return ___init__.VbrMatrix_NormFrobenius(self, *args)

    def MaxRowDim(self, *args):
        """MaxRowDim(self) -> int"""
        return ___init__.VbrMatrix_MaxRowDim(self, *args)

    def MaxColDim(self, *args):
        """MaxColDim(self) -> int"""
        return ___init__.VbrMatrix_MaxColDim(self, *args)

    def GlobalMaxRowDim(self, *args):
        """GlobalMaxRowDim(self) -> int"""
        return ___init__.VbrMatrix_GlobalMaxRowDim(self, *args)

    def GlobalMaxColDim(self, *args):
        """GlobalMaxColDim(self) -> int"""
        return ___init__.VbrMatrix_GlobalMaxColDim(self, *args)

    def NumMyRows(self, *args):
        """NumMyRows(self) -> int"""
        return ___init__.VbrMatrix_NumMyRows(self, *args)

    def NumMyCols(self, *args):
        """NumMyCols(self) -> int"""
        return ___init__.VbrMatrix_NumMyCols(self, *args)

    def NumMyNonzeros(self, *args):
        """NumMyNonzeros(self) -> int"""
        return ___init__.VbrMatrix_NumMyNonzeros(self, *args)

    def NumGlobalRows(self, *args):
        """NumGlobalRows(self) -> int"""
        return ___init__.VbrMatrix_NumGlobalRows(self, *args)

    def NumGlobalCols(self, *args):
        """NumGlobalCols(self) -> int"""
        return ___init__.VbrMatrix_NumGlobalCols(self, *args)

    def NumGlobalNonzeros(self, *args):
        """NumGlobalNonzeros(self) -> int"""
        return ___init__.VbrMatrix_NumGlobalNonzeros(self, *args)

    def NumMyBlockRows(self, *args):
        """NumMyBlockRows(self) -> int"""
        return ___init__.VbrMatrix_NumMyBlockRows(self, *args)

    def NumMyBlockCols(self, *args):
        """NumMyBlockCols(self) -> int"""
        return ___init__.VbrMatrix_NumMyBlockCols(self, *args)

    def NumMyBlockDiagonals(self, *args):
        """NumMyBlockDiagonals(self) -> int"""
        return ___init__.VbrMatrix_NumMyBlockDiagonals(self, *args)

    def NumMyDiagonals(self, *args):
        """NumMyDiagonals(self) -> int"""
        return ___init__.VbrMatrix_NumMyDiagonals(self, *args)

    def NumGlobalBlockRows(self, *args):
        """NumGlobalBlockRows(self) -> int"""
        return ___init__.VbrMatrix_NumGlobalBlockRows(self, *args)

    def NumGlobalBlockCols(self, *args):
        """NumGlobalBlockCols(self) -> int"""
        return ___init__.VbrMatrix_NumGlobalBlockCols(self, *args)

    def NumGlobalBlockDiagonals(self, *args):
        """NumGlobalBlockDiagonals(self) -> int"""
        return ___init__.VbrMatrix_NumGlobalBlockDiagonals(self, *args)

    def NumGlobalDiagonals(self, *args):
        """NumGlobalDiagonals(self) -> int"""
        return ___init__.VbrMatrix_NumGlobalDiagonals(self, *args)

    def NumGlobalBlockEntries(self, *args):
        """
        NumGlobalBlockEntries(self) -> int
        NumGlobalBlockEntries(self, int Row) -> int
        """
        return ___init__.VbrMatrix_NumGlobalBlockEntries(self, *args)

    def NumAllocatedGlobalBlockEntries(self, *args):
        """NumAllocatedGlobalBlockEntries(self, int Row) -> int"""
        return ___init__.VbrMatrix_NumAllocatedGlobalBlockEntries(self, *args)

    def MaxNumBlockEntries(self, *args):
        """MaxNumBlockEntries(self) -> int"""
        return ___init__.VbrMatrix_MaxNumBlockEntries(self, *args)

    def GlobalMaxNumBlockEntries(self, *args):
        """GlobalMaxNumBlockEntries(self) -> int"""
        return ___init__.VbrMatrix_GlobalMaxNumBlockEntries(self, *args)

    def NumMyBlockEntries(self, *args):
        """
        NumMyBlockEntries(self) -> int
        NumMyBlockEntries(self, int Row) -> int
        """
        return ___init__.VbrMatrix_NumMyBlockEntries(self, *args)

    def NumAllocatedMyBlockEntries(self, *args):
        """NumAllocatedMyBlockEntries(self, int Row) -> int"""
        return ___init__.VbrMatrix_NumAllocatedMyBlockEntries(self, *args)

    def MaxNumNonzeros(self, *args):
        """MaxNumNonzeros(self) -> int"""
        return ___init__.VbrMatrix_MaxNumNonzeros(self, *args)

    def GlobalMaxNumNonzeros(self, *args):
        """GlobalMaxNumNonzeros(self) -> int"""
        return ___init__.VbrMatrix_GlobalMaxNumNonzeros(self, *args)

    def IndexBase(self, *args):
        """IndexBase(self) -> int"""
        return ___init__.VbrMatrix_IndexBase(self, *args)

    def Graph(self, *args):
        """Graph(self) -> CrsGraph"""
        return ___init__.VbrMatrix_Graph(self, *args)

    def Importer(self, *args):
        """Importer(self) -> Import"""
        return ___init__.VbrMatrix_Importer(self, *args)

    def Exporter(self, *args):
        """Exporter(self) -> Export"""
        return ___init__.VbrMatrix_Exporter(self, *args)

    def DomainMap(self, *args):
        """DomainMap(self) -> BlockMap"""
        return ___init__.VbrMatrix_DomainMap(self, *args)

    def RangeMap(self, *args):
        """RangeMap(self) -> BlockMap"""
        return ___init__.VbrMatrix_RangeMap(self, *args)

    def RowMap(self, *args):
        """RowMap(self) -> BlockMap"""
        return ___init__.VbrMatrix_RowMap(self, *args)

    def ColMap(self, *args):
        """ColMap(self) -> BlockMap"""
        return ___init__.VbrMatrix_ColMap(self, *args)

    def Comm(self, *args):
        """Comm(self) -> Comm"""
        return ___init__.VbrMatrix_Comm(self, *args)

    def LRID(self, *args):
        """LRID(self, int GRID_in) -> int"""
        return ___init__.VbrMatrix_LRID(self, *args)

    def GRID(self, *args):
        """GRID(self, int LRID_in) -> int"""
        return ___init__.VbrMatrix_GRID(self, *args)

    def LCID(self, *args):
        """LCID(self, int GCID_in) -> int"""
        return ___init__.VbrMatrix_LCID(self, *args)

    def GCID(self, *args):
        """GCID(self, int LCID_in) -> int"""
        return ___init__.VbrMatrix_GCID(self, *args)

    def MyGRID(self, *args):
        """MyGRID(self, int GRID_in) -> bool"""
        return ___init__.VbrMatrix_MyGRID(self, *args)

    def MyLRID(self, *args):
        """MyLRID(self, int LRID_in) -> bool"""
        return ___init__.VbrMatrix_MyLRID(self, *args)

    def MyGCID(self, *args):
        """MyGCID(self, int GCID_in) -> bool"""
        return ___init__.VbrMatrix_MyGCID(self, *args)

    def MyLCID(self, *args):
        """MyLCID(self, int LCID_in) -> bool"""
        return ___init__.VbrMatrix_MyLCID(self, *args)

    def MyGlobalBlockRow(self, *args):
        """MyGlobalBlockRow(self, int GID) -> bool"""
        return ___init__.VbrMatrix_MyGlobalBlockRow(self, *args)

    def Label(self, *args):
        """Label(self) -> char"""
        return ___init__.VbrMatrix_Label(self, *args)

    def SetUseTranspose(self, *args):
        """SetUseTranspose(self, bool UseTranspose_in) -> int"""
        return ___init__.VbrMatrix_SetUseTranspose(self, *args)

    def Apply(self, *args):
        """
        Apply(self, MultiVector x, MultiVector y) -> int

        In C++, the Apply() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the Apply() method.  C++ code (e.g., AztecOO
        solvers) can call back to your Apply() method as needed.  You must
        support two arguments, labeled here MultiVector x and MultiVector y.
        These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent Apply() from raising any
        exceptions.  Accidental errors can be prevented by wrapping your code
        in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method Apply:'
                print e
                return -1

        By returning a -1, you inform the calling routine that Apply() was
        unsuccessful.

        """
        return ___init__.VbrMatrix_Apply(self, *args)

    def ApplyInverse(self, *args):
        """
        ApplyInverse(self, MultiVector x, MultiVector y) -> int

        In C++, the ApplyInverse() method is pure virtual, thus intended to be
        overridden by derived classes.  In python, cross-language polymorphism
        is supported, and you are expected to derive classes from this base
        class and redefine the ApplyInverse() method.  C++ code (e.g., AztecOO
        solvers) can call back to your ApplyInverse() method as needed.  You
        must support two arguments, labeled here MultiVector x and MultiVector
        y.  These will be converted from Epetra_MultiVector C++ objects to
        numpy-hybrid Epetra.MultiVector objects before they are passed to you.
        Thus, it is legal to use slice indexing and other numpy features to
        compute y from x.

        If application of your operator is successful, return 0; else return
        some non-zero error code.

        It is strongly suggested that you prevent ApplyInverse() from raising
        any exceptions.  Accidental errors can be prevented by wrapping your
        code in a try block:

            try:
                # Your code goes here...
            except Exception, e:
                print 'A python exception was raised by method ApplyInverse:'
                print e
                return -1

        By returning a -1, you inform the calling routine that ApplyInverse()
        was unsuccessful.

        """
        return ___init__.VbrMatrix_ApplyInverse(self, *args)

    def HasNormInf(self, *args):
        """HasNormInf(self) -> bool"""
        return ___init__.VbrMatrix_HasNormInf(self, *args)

    def UseTranspose(self, *args):
        """UseTranspose(self) -> bool"""
        return ___init__.VbrMatrix_UseTranspose(self, *args)

    def OperatorDomainMap(self, *args):
        """OperatorDomainMap(self) -> Map"""
        return ___init__.VbrMatrix_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args):
        """OperatorRangeMap(self) -> Map"""
        return ___init__.VbrMatrix_OperatorRangeMap(self, *args)

    def ExtractGlobalRowCopy(self, *args):
        """
        ExtractGlobalRowCopy(self, int GlobalRow, int Length, int NumEntries, double Values, 
            int Indices) -> int
        """
        return ___init__.VbrMatrix_ExtractGlobalRowCopy(self, *args)

    def ExtractMyRowCopy(self, *args):
        """
        ExtractMyRowCopy(int myRow, int length, numpy.ndarray numEntries,
            numpy.ndarray values, numpy.ndarray indices) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....

        Arguments values and indices are double* and int*, respectively, in
        C++.  In python, these are provided to you as numpy arrays of the
        given length, so that you may alter their entries in-place.
        """
        return ___init__.VbrMatrix_ExtractMyRowCopy(self, *args)

    def NumMyRowEntries(self, *args):
        """
        NumMyRowEntries(int myRow, numpy.ndarray numEntries) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....
        """
        return ___init__.VbrMatrix_NumMyRowEntries(self, *args)

    def MaxNumEntries(self, *args):
        """MaxNumEntries(self) -> int"""
        return ___init__.VbrMatrix_MaxNumEntries(self, *args)

    def Map(self, *args):
        """Map(self) -> BlockMap"""
        return ___init__.VbrMatrix_Map(self, *args)

    def RowMatrixRowMap(self, *args):
        """RowMatrixRowMap(self) -> Map"""
        return ___init__.VbrMatrix_RowMatrixRowMap(self, *args)

    def RowMatrixColMap(self, *args):
        """RowMatrixColMap(self) -> Map"""
        return ___init__.VbrMatrix_RowMatrixColMap(self, *args)

    def RowMatrixImporter(self, *args):
        """RowMatrixImporter(self) -> Import"""
        return ___init__.VbrMatrix_RowMatrixImporter(self, *args)

    def BlockImportMap(self, *args):
        """BlockImportMap(self) -> BlockMap"""
        return ___init__.VbrMatrix_BlockImportMap(self, *args)

    def TransformToLocal(self, *args):
        """
        TransformToLocal(self) -> int
        TransformToLocal(self, BlockMap DomainMap, BlockMap RangeMap) -> int
        """
        return ___init__.VbrMatrix_TransformToLocal(self, *args)

    def __init__(self, *args): 
        """
        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, int
            numBlockEntriesPerRow) -> VbrMatrix

          VbrMatrix constructor with implicit column map and constant number
          of block entries per row.


        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, BlockMap colMap,
            int numBlockEntriesPerRow) -> VbrMatrix

          VbrMatrix constructor with specified column map and constant number
          of block entries per row.



        __init__(self, Epetra_DataAccess CV, CrsGraph graph) -> VbrMatrix

          CrsGraph constructor.


        __init__(self, VbrMatrix matrix) -> VbrMatrix

          Copy constructor.


        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, PySequence
            numBlockEntriesPerRow) -> VbrMatrix

          VbrMatrix constructor with implicit column map and variable number
          of block entries per row.



        __init__(self, Epetra_DataAccess CV, BlockMap rowMap, BlockMap colMap,
            PySequence numBlockEntriesPerRow) -> VbrMatrix

          VbrMatrix constructor with specified column map and variable number
          of block entries per row.


        """
        this = ___init__.new_VbrMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
VbrMatrix_swigregister = ___init__.VbrMatrix_swigregister
VbrMatrix_swigregister(VbrMatrix)

class FEVbrMatrix(VbrMatrix):
    """Proxy of C++ Epetra_FEVbrMatrix class"""
    __swig_setmethods__ = {}
    for _s in [VbrMatrix]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FEVbrMatrix, name, value)
    __swig_getmethods__ = {}
    for _s in [VbrMatrix]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FEVbrMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, Epetra_DataAccess CV, BlockMap RowMap, int NumBlockEntriesPerRow, 
            bool ignoreNonLocalEntries = False) -> FEVbrMatrix
        __init__(self, Epetra_DataAccess CV, BlockMap RowMap, int NumBlockEntriesPerRow, 
            bool ignoreNonLocalEntries = False) -> FEVbrMatrix
        __init__(self, Epetra_DataAccess CV, BlockMap RowMap, BlockMap ColMap, 
            int NumBlockEntriesPerRow, bool ignoreNonLocalEntries = False) -> FEVbrMatrix
        __init__(self, Epetra_DataAccess CV, BlockMap RowMap, BlockMap ColMap, 
            int NumBlockEntriesPerRow, bool ignoreNonLocalEntries = False) -> FEVbrMatrix
        __init__(self, Epetra_DataAccess CV, CrsGraph Graph, bool ignoreNonLocalEntries = False) -> FEVbrMatrix
        __init__(self, FEVbrMatrix src) -> FEVbrMatrix
        """
        this = ___init__.new_FEVbrMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_FEVbrMatrix
    __del__ = lambda self : None;
    def PutScalar(self, *args):
        """PutScalar(self, double ScalarConstant) -> int"""
        return ___init__.FEVbrMatrix_PutScalar(self, *args)

    def BeginInsertGlobalValues(self, *args):
        """BeginInsertGlobalValues(self, int BlockRow, int NumBlockEntries, int BlockIndices) -> int"""
        return ___init__.FEVbrMatrix_BeginInsertGlobalValues(self, *args)

    def BeginReplaceGlobalValues(self, *args):
        """BeginReplaceGlobalValues(self, int BlockRow, int NumBlockEntries, int BlockIndices) -> int"""
        return ___init__.FEVbrMatrix_BeginReplaceGlobalValues(self, *args)

    def BeginSumIntoGlobalValues(self, *args):
        """BeginSumIntoGlobalValues(self, int BlockRow, int NumBlockEntries, int BlockIndices) -> int"""
        return ___init__.FEVbrMatrix_BeginSumIntoGlobalValues(self, *args)

    def SubmitBlockEntry(self, *args):
        """
        SubmitBlockEntry(self, Epetra_SerialDenseMatrix Mat) -> int
        SubmitBlockEntry(self, double Values, int LDA, int NumRows, int NumCols) -> int
        """
        return ___init__.FEVbrMatrix_SubmitBlockEntry(self, *args)

    def EndSubmitEntries(self, *args):
        """EndSubmitEntries(self) -> int"""
        return ___init__.FEVbrMatrix_EndSubmitEntries(self, *args)

    def GlobalAssemble(self, *args):
        """GlobalAssemble(self, bool callFillComplete = True) -> int"""
        return ___init__.FEVbrMatrix_GlobalAssemble(self, *args)

FEVbrMatrix_swigregister = ___init__.FEVbrMatrix_swigregister
FEVbrMatrix_swigregister(FEVbrMatrix)

class JadMatrix(BasicRowMatrix):
    """Proxy of C++ Epetra_JadMatrix class"""
    __swig_setmethods__ = {}
    for _s in [BasicRowMatrix]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, JadMatrix, name, value)
    __swig_getmethods__ = {}
    for _s in [BasicRowMatrix]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, JadMatrix, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """__init__(self, RowMatrix Matrix) -> JadMatrix"""
        this = ___init__.new_JadMatrix(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_JadMatrix
    __del__ = lambda self : None;
    def UpdateValues(self, *args):
        """UpdateValues(self, RowMatrix Matrix, bool CheckStructure = False) -> int"""
        return ___init__.JadMatrix_UpdateValues(self, *args)

    def ExtractMyRowCopy(self, *args):
        """
        ExtractMyRowCopy(int myRow, int length, numpy.ndarray numEntries,
            numpy.ndarray values, numpy.ndarray indices) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....

        Arguments values and indices are double* and int*, respectively, in
        C++.  In python, these are provided to you as numpy arrays of the
        given length, so that you may alter their entries in-place.
        """
        return ___init__.JadMatrix_ExtractMyRowCopy(self, *args)

    def NumMyRowEntries(self, *args):
        """
        NumMyRowEntries(int myRow, numpy.ndarray numEntries) -> int

        In C++, numEntries in an int&.  In python, it is provided to you as a
        numpy array of length one so that you can set its value in-place using
        numEntries[0] = ....
        """
        return ___init__.JadMatrix_NumMyRowEntries(self, *args)

    def Multiply(self, *args):
        """
        Multiply(bool useTranspose, MultiVector x, MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.JadMatrix_Multiply(self, *args)

    def Solve(self, *args):
        """
        Solve((bool upper, bool trans, bool unitDiagonal, MultiVector x,
            MultiVector y) -> int

        In C++, arguments x and y are Epetra_MultiVectors.  In python, they
        are provided to you as numpy-hybrid Epetra.MultiVectors, giving you
        access to the numpy interface in addition to the Epetra_MultiVector
        C++ interface.
        """
        return ___init__.JadMatrix_Solve(self, *args)

JadMatrix_swigregister = ___init__.JadMatrix_swigregister
JadMatrix_swigregister(JadMatrix)

easy = ___init__.easy
moderate = ___init__.moderate
hard = ___init__.hard
unsure = ___init__.unsure
class LinearProblem(_object):
    """Proxy of C++ Epetra_LinearProblem class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearProblem, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, LinearProblem, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self) -> LinearProblem
        __init__(self, RowMatrix A, Epetra_MultiVector X, Epetra_MultiVector B) -> LinearProblem
        __init__(self, Operator A, Epetra_MultiVector X, Epetra_MultiVector B) -> LinearProblem
        __init__(self, LinearProblem Problem) -> LinearProblem
        """
        this = ___init__.new_LinearProblem(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_LinearProblem
    __del__ = lambda self : None;
    def CheckInput(self, *args):
        """CheckInput(self) -> int"""
        return ___init__.LinearProblem_CheckInput(self, *args)

    def AssertSymmetric(self, *args):
        """AssertSymmetric(self)"""
        return ___init__.LinearProblem_AssertSymmetric(self, *args)

    def SetPDL(self, *args):
        """SetPDL(self, ProblemDifficultyLevel PDL)"""
        return ___init__.LinearProblem_SetPDL(self, *args)

    def SetOperator(self, *args):
        """
        SetOperator(self, RowMatrix A)
        SetOperator(self, Operator A)
        """
        return ___init__.LinearProblem_SetOperator(self, *args)

    def SetLHS(self, *args):
        """SetLHS(self, Epetra_MultiVector X)"""
        return ___init__.LinearProblem_SetLHS(self, *args)

    def SetRHS(self, *args):
        """SetRHS(self, Epetra_MultiVector B)"""
        return ___init__.LinearProblem_SetRHS(self, *args)

    def LeftScale(self, *args):
        """LeftScale(self, Epetra_Vector D) -> int"""
        return ___init__.LinearProblem_LeftScale(self, *args)

    def RightScale(self, *args):
        """RightScale(self, Epetra_Vector D) -> int"""
        return ___init__.LinearProblem_RightScale(self, *args)

    def GetOperator(self, *args):
        """GetOperator(self) -> Operator"""
        return ___init__.LinearProblem_GetOperator(self, *args)

    def GetMatrix(self, *args):
        """GetMatrix(self) -> RowMatrix"""
        return ___init__.LinearProblem_GetMatrix(self, *args)

    def GetLHS(self, *args):
        """GetLHS(self) -> Epetra_MultiVector"""
        return ___init__.LinearProblem_GetLHS(self, *args)

    def GetRHS(self, *args):
        """GetRHS(self) -> Epetra_MultiVector"""
        return ___init__.LinearProblem_GetRHS(self, *args)

    def GetPDL(self, *args):
        """GetPDL(self) -> ProblemDifficultyLevel"""
        return ___init__.LinearProblem_GetPDL(self, *args)

    def IsOperatorSymmetric(self, *args):
        """IsOperatorSymmetric(self) -> bool"""
        return ___init__.LinearProblem_IsOperatorSymmetric(self, *args)

LinearProblem_swigregister = ___init__.LinearProblem_swigregister
LinearProblem_swigregister(LinearProblem)

import PyTrilinos.NOX.Abstract
import Interface
class Group(PyTrilinos.NOX.Abstract.Group):
    """
    Concrete implementation of NOX::Abstract::Group for Trilinos/Epetra.

    This group is set up to use the linear algebra services provided
    through the Trilinos/Epetra package with AztecOO for the linear
    solver.

    C++ includes: NOX_Epetra_Group.H 
    """
    __swig_setmethods__ = {}
    for _s in [PyTrilinos.NOX.Abstract.Group]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Group, name, value)
    __swig_getmethods__ = {}
    for _s in [PyTrilinos.NOX.Abstract.Group]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Group, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, ParameterList printingParams, Teuchos::RCP<(NOX::Epetra::Interface::Required)> i, 
            Vector initialGuess) -> Group
        __init__(self, ParameterList printingParams, Teuchos::RCP<(NOX::Epetra::Interface::Required)> i, 
            Vector initialGuess, 
            Teuchos::RCP<(NOX::Epetra::LinearSystem)> linSys) -> Group
        __init__(self, Group source, CopyType type = DeepCopy) -> Group

        Group::Group(const
        NOX::Epetra::Group &source, NOX::CopyType type=NOX::DeepCopy)

        Copy constructor. If type is DeepCopy, takes ownership of valid shared
        linear system. 
        """
        this = ___init__.new_Group(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_Group
    __del__ = lambda self : None;
    def setX(self, *args):
        """
        setX(self, Vector y)
        setX(self, Vector y)

        void
        Group::setX(const NOX::Abstract::Vector &y)

        Set the solution vector x to y.

        This should invalidate the function value, Jacobian, gradient, and
        Newton direction.

        Throw an error if the copy fails.

        Reference to this object 
        """
        return ___init__.Group_setX(self, *args)

    def computeX(self, *args):
        """
        computeX(self, Group grp, Vector d, double step)
        computeX(self, Group grp, Vector d, double step)

        void
        Group::computeX(const NOX::Abstract::Group &grp, const
        NOX::Abstract::Vector &d, double step)

        Compute x = grp.x + step * d.

        Let $x$ denote this group's solution vector. Let $\\hat x$ denote
        the result of grp.getX(). Then set \\[ x = \\hat x +
        \\mbox{step} \\; d. \\]

        This should invalidate the function value, Jacobian, gradient, and
        Newton direction.

        Throw an error if the copy fails.

        Reference to this object 
        """
        return ___init__.Group_computeX(self, *args)

    def computeF(self, *args):
        """
        computeF(self) -> ReturnType

        Abstract::Group::ReturnType Group::computeF()

        Compute and store F(x).

        It's generally useful to also compute and store the 2-norm of F(x) at
        this point for later access by the getNormF() function.

        NOX::Abstract::Group::Failed - If the computation fails in any way

        NOX::Abstract::Group::Ok - Otherwise 
        """
        return ___init__.Group_computeF(self, *args)

    def computeJacobian(self, *args):
        """
        computeJacobian(self) -> ReturnType

        Abstract::Group::ReturnType Group::computeJacobian()

        Compute and store Jacobian.

        Recall that \\[ F(x) = \\left[ \\begin{array}{c} F_1(x) \\\\
        F_2(x) \\\\ \\vdots \\\\ F_n(x) \\\\ \\end{array}
        \\right]. \\]

        The Jacobian is denoted by $J$ and defined by \\[ J_{ij} =
        \\frac{\\partial F_i}{\\partial x_j} (x). \\]

        If this is a shared object, this group should taken ownership of the
        Jacobian before it computes it.

        NOX::Abstract::Group::NotDefined - Returned by default implementation
        in NOX::Abstract::Group

        NOX::Abstract::Group::Failed - If the computation fails in any other
        way

        NOX::Abstract::Group::Ok - Otherwise 
        """
        return ___init__.Group_computeJacobian(self, *args)

    def computeGradient(self, *args):
        """
        computeGradient(self) -> ReturnType

        Abstract::Group::ReturnType Group::computeGradient()

        Compute and store gradient.

        We can pose the nonlinear equation problem $F(x) = 0$ as an
        optimization problem as follows: \\[ \\min f(x) \\equiv
        \\frac{1}{2} \\|F(x)\\|_2^2. \\]

        In that case, the gradient (of $f$) is defined as \\[ g \\equiv
        J^T F. \\]

        NOX::Abstract::Group::NotDefined - Returned by default implementation
        in NOX::Abstract::Group

        NOX::Abstract::Group::BadDependency - If either $F$ or $J$ has not
        been computed

        NOX::Abstract::Group::Failed - If the computation fails in any other
        way

        NOX::Abstract::Group::Ok - Otherwise 
        """
        return ___init__.Group_computeGradient(self, *args)

    def computeNewton(self, *args):
        """
        computeNewton(self, ParameterList params) -> ReturnType

        Abstract::Group::ReturnType
        Group::computeNewton(Teuchos::ParameterList &params)

        Compute the Newton direction, using parameters for the linear solve.

        The Newton direction is the solution, s, of \\[ J s = -F. \\]

        The parameters are from the "Linear %Solver" sublist of the
        "Direction" sublist that is passed to solver during construction.

        The "Tolerance" parameter may be added/modified in the sublist of
        "Linear Solver" parameters that is passed into this function. The
        solution should be such that \\[ \\frac{\\| J s - (-F)
        \\|_2}{\\max \\{ 1, \\|F\\|_2\\} } < \\mbox{Tolerance}
        \\]

        NOX::Abstract::Group::NotDefined - Returned by default implementation
        in NOX::Abstract::Group

        NOX::Abstract::Group::BadDependency - If either $F$ or $J$ has not
        been computed

        NOX::Abstract::Group::NotConverged - If the linear solve fails to
        satisfy the "Tolerance" specified in params

        NOX::Abstract::Group::Failed - If the computation fails in any other
        way

        NOX::Abstract::Group::Ok - Otherwise 
        """
        return ___init__.Group_computeNewton(self, *args)

    def applyJacobian(self, *args):
        """
        applyJacobian(self, Vector input, Vector result) -> ReturnType
        applyJacobian(self, Vector input, Vector result) -> ReturnType

        Abstract::Group::ReturnType Group::applyJacobian(const
        NOX::Abstract::Vector &input, NOX::Abstract::Vector &result) const

        Applies Jacobian to the given input vector and puts the answer in the
        result.

        Computes \\[ v = J u, \\] where $J$ is the Jacobian, $u$ is the
        input vector, and $v$ is the result vector.

        NOX::Abstract::Group::NotDefined - Returned by default implementation
        in NOX::Abstract::Group

        NOX::Abstract::Group::BadDependency - If the Jacobian $J$ has not been
        computed

        NOX::Abstract::Group::Failed - If the computation fails

        NOX::Abstract::Group::Ok - Otherwise 
        """
        return ___init__.Group_applyJacobian(self, *args)

    def applyJacobianTranspose(self, *args):
        """
        applyJacobianTranspose(self, Vector input, Vector result) -> ReturnType
        applyJacobianTranspose(self, Vector input, Vector result) -> ReturnType

        Abstract::Group::ReturnType Group::applyJacobianTranspose(const
        NOX::Abstract::Vector &input, NOX::Abstract::Vector &result) const

        Applies Jacobian-Transpose to the given input vector and puts the
        answer in the result.

        Computes \\[ v = J^T u, \\] where $J$ is the Jacobian, $u$ is the
        input vector, and $v$ is the result vector.

        NOX::Abstract::Group::NotDefined - Returned by default implementation
        in NOX::Abstract::Group

        NOX::Abstract::Group::BadDependency - If $J$ has not been computed

        NOX::Abstract::Group::Failed - If the computation fails

        NOX::Abstract::Group::Ok - Otherwise 
        """
        return ___init__.Group_applyJacobianTranspose(self, *args)

    def applyJacobianInverse(self, *args):
        """
        applyJacobianInverse(self, ParameterList params, Vector input, Vector result) -> ReturnType
        applyJacobianInverse(self, ParameterList params, Vector input, Vector result) -> ReturnType

        Abstract::Group::ReturnType
        Group::applyJacobianInverse(Teuchos::ParameterList &params, const
        NOX::Abstract::Vector &input, NOX::Abstract::Vector &result) const

        Applies the inverse of the Jacobian matrix to the given input vector
        and puts the answer in result.

        Computes \\[ v = J^{-1} u, \\] where $J$ is the Jacobian, $u$ is
        the input vector, and $v$ is the result vector.

        The "Tolerance" parameter specifies that the solution should be such
        that \\[ \\frac{\\| J v - u \\|_2}{\\max \\{ 1,
        \\|u\\|_2\\} } < \\mbox{Tolerance} \\]

        NOX::Abstract::Group::NotDefined - Returned by default implementation
        in NOX::Abstract::Group

        NOX::Abstract::Group::BadDependency - If $J$ has not been computed

        NOX::Abstract::Group::NotConverged - If the linear solve fails to
        satisfy the "Tolerance" specified in params

        NOX::Abstract::Group::Failed - If the computation fails

        NOX::Abstract::Group::Ok - Otherwise

        The parameter "Tolerance" may be added/modified in the list of
        parameters - this is the ideal solution tolerance for an iterative
        linear solve. 
        """
        return ___init__.Group_applyJacobianInverse(self, *args)

    def applyRightPreconditioning(self, *args):
        """
        applyRightPreconditioning(self, bool useTranspose, ParameterList params, Vector input, 
            Vector result) -> ReturnType
        applyRightPreconditioning(self, bool useTranspose, ParameterList params, Vector input, 
            Vector result) -> ReturnType

        Abstract::Group::ReturnType Group::applyRightPreconditioning(bool
        useTranspose, Teuchos::ParameterList &params, const
        NOX::Abstract::Vector &input, NOX::Abstract::Vector &result) const

        Apply right preconditiong to the given input vector.

        Let $M$ be a right preconditioner for the Jacobian $J$; in other
        words, $M$ is a matrix such that \\[ JM \\approx I. \\]

        Compute \\[ u = M^{-1} v, \\] where $u$ is the input vector and
        $v$ is the result vector.

        If useTranspose is true, then the transpose of the preconditioner is
        applied: \\[ u = {M^{-1}}^T v, \\] The transpose preconditioner is
        currently only required for Tensor methods.

        The "Tolerance" parameter specifies that the solution should be such
        that \\[ \\frac{\\| M v - u \\|_2}{\\max \\{ 1,
        \\|u\\|_2\\} } < \\mbox{Tolerance} \\]

        NOX::Abstract::Group::NotDefined - Returned by default implementation
        in NOX::Abstract::Group

        NOX::Abstract::Group::NotConverged - If the linear solve fails to
        satisfy the "Tolerance" specified in params

        NOX::Abstract::Group::Failed - If the computation fails

        NOX::Abstract::Group::Ok - Otherwise

        The parameters are from the "Linear %Solver" sublist of the
        "Direction" sublist that is passed to solver during construction. 
        """
        return ___init__.Group_applyRightPreconditioning(self, *args)

    def isF(self, *args):
        """
        isF(self) -> bool

        bool Group::isF()
        const

        Return true if F is valid. 
        """
        return ___init__.Group_isF(self, *args)

    def isJacobian(self, *args):
        """
        isJacobian(self) -> bool

        bool
        Group::isJacobian() const

        Return true if the Jacobian is valid.

        Default implementation in NOX::Abstract::Group returns false. 
        """
        return ___init__.Group_isJacobian(self, *args)

    def isGradient(self, *args):
        """
        isGradient(self) -> bool

        bool
        Group::isGradient() const

        Return true if the gradient is valid.

        Default implementation in NOX::Abstract::Group returns false. 
        """
        return ___init__.Group_isGradient(self, *args)

    def isNewton(self, *args):
        """
        isNewton(self) -> bool

        bool
        Group::isNewton() const

        Return true if the Newton direction is valid.

        Default implementation in NOX::Abstract::Group returns false. 
        """
        return ___init__.Group_isNewton(self, *args)

    def isNormNewtonSolveResidual(self, *args):
        """
        isNormNewtonSolveResidual(self) -> bool

        bool Group::isNormNewtonSolveResidual() const

        Returns true if the value of the Norm of the linear model for a full
        Newton step ||Js + f|| is valid with respect to the current solution
        vector. 
        """
        return ___init__.Group_isNormNewtonSolveResidual(self, *args)

    def isPreconditioner(self, *args):
        """
        isPreconditioner(self) -> bool

        bool
        Group::isPreconditioner() const

        Returns true if an explicitly constructed preconditioner exists (i.e.
        one that is computed and saved for further use in multiple calls to
        applyRightPreconditioner). 
        """
        return ___init__.Group_isPreconditioner(self, *args)

    def isConditionNumber(self, *args):
        """
        isConditionNumber(self) -> bool

        bool
        Group::isConditionNumber() const

        Returns true if the condition number has been computed. 
        """
        return ___init__.Group_isConditionNumber(self, *args)

    def getX(self, *args):
        """
        getX(self) -> Vector

        const
        Abstract::Vector & Group::getX() const

        Return solution vector. 
        """
        return ___init__.Group_getX(self, *args)

    def getF(self, *args):
        """
        getF(self) -> Vector

        const
        Abstract::Vector & Group::getF() const

        Return F(x). 
        """
        return ___init__.Group_getF(self, *args)

    def getNormF(self, *args):
        """
        getNormF(self) -> double

        double
        Group::getNormF() const

        Return 2-norm of F(x).

        In other words, \\[ \\sqrt{\\sum_{i=1}^n F_i^2} \\] 
        """
        return ___init__.Group_getNormF(self, *args)

    def getGradient(self, *args):
        """
        getGradient(self) -> Vector

        const
        Abstract::Vector & Group::getGradient() const

        Return gradient. 
        """
        return ___init__.Group_getGradient(self, *args)

    def getNewton(self, *args):
        """
        getNewton(self) -> Vector

        const
        Abstract::Vector & Group::getNewton() const

        Return Newton direction. 
        """
        return ___init__.Group_getNewton(self, *args)

    def getNormLastLinearSolveResidual(self, *args):
        """
        getNormLastLinearSolveResidual(self, double residual) -> ReturnType

        Abstract::Group::ReturnType
        NOX::Epetra::Group::getNormLastLinearSolveResidual(double &residual)
        const

        Returns the 2-norm of the residual of the linear model used in the
        Newton solve computation, ||Js+f||. This does not account for line
        search adjustments to the step length! 
        """
        return ___init__.Group_getNormLastLinearSolveResidual(self, *args)

    def clone(self, *args):
        """
        clone(self, CopyType type = DeepCopy) -> Teuchos::RCP<(NOX::Abstract::Group)>

        Teuchos::RCP<
        NOX::Abstract::Group > Group::clone(CopyType type=DeepCopy) const

        Create a new Group of the same derived type as this one by cloning
        this one, and return a ref count pointer to the new group.

        If type is NOX::DeepCopy, then we need to create an exact replica of
        "this". Otherwise, if type is NOX::ShapeCopy, we need only replicate
        the shape of "this" (only the memory is allocated, the values are
        not copied into the vectors and Jacobian). Returns NULL if clone is
        not supported.

        Any shared data should have its ownership transfered to this group
        from the source for a NOX::DeepCopy. 
        """
        return ___init__.Group_clone(self, *args)

    def getRequiredInterface(self, *args):
        """
        getRequiredInterface(self) -> Teuchos::RCP<(NOX::Epetra::Interface::Required)>

        Teuchos::RCP< NOX::Epetra::Interface::Required >
        Group::getRequiredInterface()

        Return the userInterface. 
        """
        return ___init__.Group_getRequiredInterface(self, *args)

    def getLinearSystem(self, *args):
        """
        getLinearSystem(self) -> Teuchos::RCP<(q(const).NOX::Epetra::LinearSystem)>
        getLinearSystem(self) -> Teuchos::RCP<(NOX::Epetra::LinearSystem)>

        Teuchos::RCP< NOX::Epetra::LinearSystem > Group::getLinearSystem()

        Return the Linear System. 
        """
        return ___init__.Group_getLinearSystem(self, *args)

    def computeJacobianConditionNumber(self, *args):
        """
        computeJacobianConditionNumber(self, int maxIters, double tolerance, int krylovSubspaceSize = 100, 
            bool printOutput = False) -> ReturnType

        Abstract::Group::ReturnType
        NOX::Epetra::Group::computeJacobianConditionNumber(int maxIters,
        double tolerance, int krylovSubspaceSize=100, bool printOutput=false)

        """
        return ___init__.Group_computeJacobianConditionNumber(self, *args)

    def getJacobianConditionNumber(self, *args):
        """
        getJacobianConditionNumber(self) -> double

        double NOX::Epetra::Group::getJacobianConditionNumber() const

        Returns the condition number of the Jacobian matrix. 
        """
        return ___init__.Group_getJacobianConditionNumber(self, *args)

Group_swigregister = ___init__.Group_swigregister
Group_swigregister(Group)

class Vector(PyTrilinos.NOX.Abstract.Vector):
    """
    Implementation of NOX::Abstract::Vector for Epetra vectors.

    C++ includes: NOX_Epetra_Vector.H 
    """
    __swig_setmethods__ = {}
    for _s in [PyTrilinos.NOX.Abstract.Vector]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Vector, name, value)
    __swig_getmethods__ = {}
    for _s in [PyTrilinos.NOX.Abstract.Vector]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, Vector, name)
    __repr__ = _swig_repr
    CreateView = ___init__.Vector_CreateView
    CreateCopy = ___init__.Vector_CreateCopy
    def __init__(self, *args): 
        """
        __init__(self, Teuchos::RCP<(Epetra_Vector)> source, MemoryType memoryType = CreateCopy, 
            CopyType type = DeepCopy, 
            Teuchos::RCP<(NOX::Epetra::VectorSpace)> vs = Teuchos::null) -> Vector
        __init__(self, Epetra_Vector source, CopyType type = DeepCopy, Teuchos::RCP<(NOX::Epetra::VectorSpace)> vs = Teuchos::null) -> Vector
        __init__(self, Vector source, CopyType type = DeepCopy) -> Vector

        NOX::Epetra::Vector::Vector(const NOX::Epetra::Vector &source,
        NOX::CopyType type=NOX::DeepCopy)

        Copy constructor. 
        """
        this = ___init__.new_Vector(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_Vector
    __del__ = lambda self : None;
    def getEpetraVector(self, *args):
        """
        getEpetraVector(self) -> Epetra_Vector

        const
        Epetra_Vector & NOX::Epetra::Vector::getEpetraVector() const

        Get const reference to underlying Epetra vector. 
        """
        return ___init__.Vector_getEpetraVector(self, *args)

    def init(self, *args):
        """
        init(self, double gamma) -> Vector

        NOX::Abstract::Vector & NOX::Epetra::Vector::init(double gamma)

        Initialize every element of this vector with gamma.

        Here x represents this vector, and we update it as \\[ x_i =
        \\gamma \\quad \\mbox{for } i=1,\\dots,n \\] Reference to
        this object 
        """
        return ___init__.Vector_init(self, *args)

    def random(self, *args):
        """
        random(self, bool useSeed = False, int seed = 1) -> Vector

        NOX::Abstract::Vector & NOX::Epetra::Vector::random(bool
        useSeed=false, int seed=1)

        Initialize each element of this vector with a random value.

        If useSeed is true, uses the value of seed to seed the random number
        generator before filling the entries of this vector. So, if two calls
        are made where useSeed is true and seed is the same, then the vectors
        returned should be the same.

        Default implementation throw an error. Only referenced by LOCA
        methods.

        Reference to this object 
        """
        return ___init__.Vector_random(self, *args)

    def abs(self, *args):
        """
        abs(self, Vector y) -> Vector
        abs(self, Vector y) -> Vector

        NOX::Abstract::Vector & NOX::Epetra::Vector::abs(const
        NOX::Abstract::Vector &y)

        Put element-wise absolute values of source vector y into this vector.

        Here x represents this vector, and we update it as \\[ x_i = | y_i |
        \\quad \\mbox{for } i=1,\\dots,n \\]

        Reference to this object 
        """
        return ___init__.Vector_abs(self, *args)

    def reciprocal(self, *args):
        """
        reciprocal(self, Vector y) -> Vector
        reciprocal(self, Vector y) -> Vector

        NOX::Abstract::Vector & NOX::Epetra::Vector::reciprocal(const
        NOX::Abstract::Vector &y)

        Put element-wise reciprocal of source vector y into this vector.

        Here x represents this vector, and we update it as \\[ x_i =
        \\frac{1}{y_i} \\quad \\mbox{for } i=1,\\dots,n \\]

        Reference to this object 
        """
        return ___init__.Vector_reciprocal(self, *args)

    def scale(self, *args):
        """
        scale(self, double gamma) -> Vector
        scale(self, Vector a) -> Vector
        scale(self, Vector a) -> Vector

        NOX::Abstract::Vector & NOX::Epetra::Vector::scale(const
        NOX::Abstract::Vector &a)

        Scale this vector element-by-element by the vector a.

        Here x represents this vector, and we update it as \\[ x_i = x_i
        \\cdot a_i \\quad \\mbox{for } i=1,\\dots,n \\]

        Reference to this object 
        """
        return ___init__.Vector_scale(self, *args)

    def update(self, *args):
        """
        update(self, double alpha, Vector a, double gamma = 0.0) -> Vector
        update(self, double alpha, Vector a, double gamma = 0.0) -> Vector
        update(self, double alpha, Vector a, double beta, Vector b, double gamma = 0.0) -> Vector
        update(self, double alpha, Vector a, double beta, Vector b, double gamma = 0.0) -> Vector

        NOX::Abstract::Vector & NOX::Epetra::Vector::update(double alpha,
        const NOX::Abstract::Vector &a, double beta, const
        NOX::Abstract::Vector &b, double gamma=0.0)

        Compute x = (alpha * a) + (beta * b) + (gamma * x) where x is this
        vector.

        Here x represents this vector, and we update it as \\[ x_i =
        \\alpha \\; a_i + \\beta \\; b_i + \\gamma \\; x_i
        \\quad \\mbox{for } i=1,\\dots,n \\]

        Reference to this object 
        """
        return ___init__.Vector_update(self, *args)

    def clone(self, *args):
        """
        clone(self, CopyType type = DeepCopy) -> Teuchos::RCP<(NOX::Abstract::Vector)>

        Teuchos::RCP<
        NOX::Abstract::Vector > NOX::Epetra::Vector::clone(CopyType
        type=DeepCopy) const

        Create a new Vector of the same underlying type by cloning "this",
        and return a pointer to the new vector.

        If type is NOX::DeepCopy, then we need to create an exact replica of
        "this". Otherwise, if type is NOX::ShapeCopy, we need only replicate
        the shape of "this" (the memory is allocated for the objects, but
        the current values are not copied into the vector). Note that there is
        no assumption that a vector created by ShapeCopy is initialized to
        zeros.

        Pointer to newly created vector or NULL if clone is not supported. 
        """
        return ___init__.Vector_clone(self, *args)

    def createMultiVector(self, *args):
        """
        createMultiVector(self, Vector vecs, int numVecs, CopyType type = DeepCopy) -> Teuchos::RCP<(NOX::Abstract::MultiVector)>
        createMultiVector(self, int numVecs, CopyType type = DeepCopy) -> Teuchos::RCP<(NOX::Abstract::MultiVector)>

        Teuchos::RCP< NOX::Abstract::MultiVector >
        NOX::Epetra::Vector::createMultiVector(int numVecs, NOX::CopyType
        type=NOX::DeepCopy) const

        Create a MultiVector with numVecs columns.

        The implementation here creates a NOX::Epetra::MultiVector with either
        Shape or Deep copies of the supplied vector. 
        """
        return ___init__.Vector_createMultiVector(self, *args)

    def norm(self, *args):
        """
        norm(self, NormType type = TwoNorm) -> double
        norm(self, Vector weights) -> double
        norm(self, Vector weights) -> double

        double
        NOX::Epetra::Vector::norm(const NOX::Abstract::Vector &weights) const

        Weighted 2-Norm.

        Here x represents this vector, and we compute its weighted norm as
        follows: \\[ \\|x\\|_w = \\sqrt{\\sum_{i=1}^{n} w_i \\;
        x_i^2} \\]  $ \\|x\\|_w $ 
        """
        return ___init__.Vector_norm(self, *args)

    def innerProduct(self, *args):
        """
        innerProduct(self, Vector y) -> double
        innerProduct(self, Vector y) -> double

        double
        NOX::Epetra::Vector::innerProduct(const NOX::Abstract::Vector &y)
        const

        Inner product with y.

        Here x represents this vector, and we compute its inner product with y
        as follows: \\[ \\langle x,y \\rangle = \\sum_{i=1}^n x_i y_i
        \\]  $\\langle x,y \\rangle$ 
        """
        return ___init__.Vector_innerProduct(self, *args)

    def length(self, *args):
        """
        length(self) -> int

        int
        NOX::Epetra::Vector::length() const

        Return the length of vector.

        The length of this vector

        Even if the vector is distributed across processors, this should
        return the  global length of the vector. 
        """
        return ___init__.Vector_length(self, *args)

    def _print(self, *args):
        """
        _print(self,  stream)

        void
        NOX::Epetra::Vector::print(std::ostream &stream) const

        Print the vector. To be used for debugging only. 
        """
        return ___init__.Vector__print(self, *args)

    def getVectorSpace(self, *args):
        """
        getVectorSpace(self) -> Teuchos::RCP<(NOX::Epetra::VectorSpace)>

        Teuchos::RCP< NOX::Epetra::VectorSpace >
        NOX::Epetra::Vector::getVectorSpace() const

        Returns the NOX::Epetra::VectorSpace associated with this vector. 
        """
        return ___init__.Vector_getVectorSpace(self, *args)

Vector_swigregister = ___init__.Vector_swigregister
Vector_swigregister(Vector)

class FiniteDifference(RowMatrix,Interface.Jacobian,Interface.Preconditioner):
    """
    Concrete implementation for creating an Epetra_RowMatrix Jacobian via
    finite differencing of the residual.

    The Jacobian entries are calculated via 1st order finite differencing.
    This requires $ N + 1 $ calls to computeF() where $ N $ is the number
    of unknowns in the problem.

    \\[ J_{ij} = \\frac{\\partial F_i}{\\partial x_j} =
    \\frac{F_i(x+\\delta\\mathbf{e}_j) - F_i(x)}{\\delta} \\]

    where $J$ is the Jacobian, $F$ is the function evaluation, $x$ is the
    solution vector, and $\\delta$ is a small perturbation to the $x_j$
    entry.

    The perturbation, $ \\delta $, is calculated based on one of the
    following equations:

    \\[ \\delta = \\alpha * | x_j | + \\beta \\] \\[ \\delta
    = \\alpha * | x_j | + \\beta_j \\]

    where $ \\alpha $ is a scalar value (defaults to 1.0e-4) and $
    \\beta $ can be either a scalar or a vector (defaults to a scalar
    value of 1.0e-6). The choice is defined by the type of constructor
    used. All parameters are supplied in the constructor. In addition to
    the forward difference derivative approximation, backward or centered
    differences can be used via the setDifferenceMethod function. Note
    that centered difference provides second order spatial accuracy but at
    the cost of twice as many function evaluations.

    Since this inherits from the Epetra_RowMatrix class, it can be used as
    the preconditioning matrix for AztecOO preconditioners. This method is
    very inefficient when computing the Jacobian and is not recommended
    for large-scale systems but only for debugging purposes.

    C++ includes: NOX_Epetra_FiniteDifference.H 
    """
    __swig_setmethods__ = {}
    for _s in [RowMatrix,Interface.Jacobian,Interface.Preconditioner]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FiniteDifference, name, value)
    __swig_getmethods__ = {}
    for _s in [RowMatrix,Interface.Jacobian,Interface.Preconditioner]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FiniteDifference, name)
    __repr__ = _swig_repr
    Forward = ___init__.FiniteDifference_Forward
    Backward = ___init__.FiniteDifference_Backward
    Centered = ___init__.FiniteDifference_Centered
    def __init__(self, *args): 
        """
        __init__(self, ParameterList printingParams, Teuchos::RCP<(NOX::Epetra::Interface::Required)> i, 
            Vector initialGuess, 
            double beta = 1.0e-6, double alpha = 1.0e-4) -> FiniteDifference
        __init__(self, ParameterList printingParams, Teuchos::RCP<(NOX::Epetra::Interface::Required)> i, 
            Vector initialGuess, 
            Teuchos::RCP<(q(const).Epetra_Vector)> beta, 
            double alpha = 1.0e-4) -> FiniteDifference
        __init__(self, ParameterList printingParams, Teuchos::RCP<(NOX::Epetra::Interface::Required)> i, 
            Vector initialGuess, 
            Teuchos::RCP<(Epetra_CrsGraph)> g, double beta = 1.0e-6, 
            double alpha = 1.0e-4) -> FiniteDifference
        __init__(self, ParameterList printingParams, Teuchos::RCP<(NOX::Epetra::Interface::Required)> i, 
            Vector initialGuess, 
            Teuchos::RCP<(Epetra_CrsGraph)> g, Teuchos::RCP<(q(const).Epetra_Vector)> beta, 
            double alpha = 1.0e-4) -> FiniteDifference

        FiniteDifference::FiniteDifference(Teuchos::ParameterList
        &printingParams, const Teuchos::RCP< NOX::Epetra::Interface::Required
        > &i, const NOX::Epetra::Vector &initialGuess, const Teuchos::RCP<
        Epetra_CrsGraph > &g, const Teuchos::RCP< const Epetra_Vector > &beta,
        double alpha=1.0e-4)

        Constructor with output control that takes a pre-constructed
        Epetra_CrsGraph so it does not have to determine the non-zero entries
        in the matrix. 
        """
        this = ___init__.new_FiniteDifference(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_FiniteDifference
    __del__ = lambda self : None;
    def Label(self, *args):
        """
        Label(self) -> char

        const
        char * FiniteDifference::Label() const

        Returns a character string describing the name of the operator. 
        """
        return ___init__.FiniteDifference_Label(self, *args)

    def SetUseTranspose(self, *args):
        """
        SetUseTranspose(self, bool UseTranspose) -> int

        int FiniteDifference::SetUseTranspose(bool UseTranspose)

        If set true, the transpose of this operator will be applied. 
        """
        return ___init__.FiniteDifference_SetUseTranspose(self, *args)

    def Apply(self, *args):
        """
        Apply(self, Epetra_MultiVector X, Epetra_MultiVector Y) -> int

        int
        FiniteDifference::Apply(const Epetra_MultiVector &X,
        Epetra_MultiVector &Y) const

        Return the result on an Epetra_Operator applied to an
        Epetra_MultiVector X in Y. 
        """
        return ___init__.FiniteDifference_Apply(self, *args)

    def ApplyInverse(self, *args):
        """
        ApplyInverse(self, Epetra_MultiVector X, Epetra_MultiVector Y) -> int

        int FiniteDifference::ApplyInverse(const Epetra_MultiVector &X,
        Epetra_MultiVector &Y) const

        Return the result on an Epetra_Operator inverse applied to an
        Epetra_MultiVector X in Y. 
        """
        return ___init__.FiniteDifference_ApplyInverse(self, *args)

    def UseTranspose(self, *args):
        """
        UseTranspose(self) -> bool

        bool FiniteDifference::UseTranspose() const

        Returns the current use transpose setting. 
        """
        return ___init__.FiniteDifference_UseTranspose(self, *args)

    def HasNormInf(self, *args):
        """
        HasNormInf(self) -> bool

        bool FiniteDifference::HasNormInf() const

        Returns true if the this object can provide an approximate Inf-norm,
        false otherwise. 
        """
        return ___init__.FiniteDifference_HasNormInf(self, *args)

    def OperatorDomainMap(self, *args):
        """
        OperatorDomainMap(self) -> Map

        const Epetra_Map &
        FiniteDifference::OperatorDomainMap() const

        Returns the Epetra_BlockMap object associated with the domain of this
        matrix operator. 
        """
        return ___init__.FiniteDifference_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args):
        """
        OperatorRangeMap(self) -> Map

        const Epetra_Map & FiniteDifference::OperatorRangeMap() const

        Returns the Epetra_BlockMap object associated with the range of this
        matrix operator. 
        """
        return ___init__.FiniteDifference_OperatorRangeMap(self, *args)

    def Filled(self, *args):
        """
        Filled(self) -> bool

        bool
        FiniteDifference::Filled() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_Filled(self, *args)

    def NumMyRowEntries(self, *args):
        """
        NumMyRowEntries(self, int MyRow, int NumEntries) -> int

        int FiniteDifference::NumMyRowEntries(int MyRow, int &NumEntries)
        const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NumMyRowEntries(self, *args)

    def MaxNumEntries(self, *args):
        """
        MaxNumEntries(self) -> int

        int FiniteDifference::MaxNumEntries() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_MaxNumEntries(self, *args)

    def ExtractMyRowCopy(self, *args):
        """
        ExtractMyRowCopy(self, int MyRow, int Length, int NumEntries, double Values, 
            int Indices) -> int

        int FiniteDifference::ExtractMyRowCopy(int MyRow, int Length, int
        &NumEntries, double *Values, int *Indices) const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_ExtractMyRowCopy(self, *args)

    def ExtractDiagonalCopy(self, *args):
        """
        ExtractDiagonalCopy(self, Epetra_Vector Diagonal) -> int

        int
        FiniteDifference::ExtractDiagonalCopy(Epetra_Vector &Diagonal) const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_ExtractDiagonalCopy(self, *args)

    def Multiply(self, *args):
        """
        Multiply(self, bool TransA, Epetra_MultiVector X, Epetra_MultiVector Y) -> int

        int
        FiniteDifference::Multiply(bool TransA, const Epetra_MultiVector &X,
        Epetra_MultiVector &Y) const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_Multiply(self, *args)

    def Solve(self, *args):
        """
        Solve(self, bool Upper, bool Trans, bool UnitDiagonal, Epetra_MultiVector X, 
            Epetra_MultiVector Y) -> int

        int
        FiniteDifference::Solve(bool Upper, bool Trans, bool UnitDiagonal,
        const Epetra_MultiVector &X, Epetra_MultiVector &Y) const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_Solve(self, *args)

    def InvRowSums(self, *args):
        """
        InvRowSums(self, Epetra_Vector x) -> int

        int
        FiniteDifference::InvRowSums(Epetra_Vector &x) const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_InvRowSums(self, *args)

    def LeftScale(self, *args):
        """
        LeftScale(self, Epetra_Vector x) -> int

        int
        FiniteDifference::LeftScale(const Epetra_Vector &x)

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_LeftScale(self, *args)

    def InvColSums(self, *args):
        """
        InvColSums(self, Epetra_Vector x) -> int

        int
        FiniteDifference::InvColSums(Epetra_Vector &x) const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_InvColSums(self, *args)

    def RightScale(self, *args):
        """
        RightScale(self, Epetra_Vector x) -> int

        int
        FiniteDifference::RightScale(const Epetra_Vector &x)

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_RightScale(self, *args)

    def NormInf(self, *args):
        """
        NormInf(self) -> double

        double
        FiniteDifference::NormInf() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NormInf(self, *args)

    def NormOne(self, *args):
        """
        NormOne(self) -> double

        double
        FiniteDifference::NormOne() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NormOne(self, *args)

    def NumGlobalNonzeros(self, *args):
        """
        NumGlobalNonzeros(self) -> int

        int
        FiniteDifference::NumGlobalNonzeros() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NumGlobalNonzeros(self, *args)

    def NumGlobalRows(self, *args):
        """
        NumGlobalRows(self) -> int

        int FiniteDifference::NumGlobalRows() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NumGlobalRows(self, *args)

    def NumGlobalCols(self, *args):
        """
        NumGlobalCols(self) -> int

        int FiniteDifference::NumGlobalCols() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NumGlobalCols(self, *args)

    def NumGlobalDiagonals(self, *args):
        """
        NumGlobalDiagonals(self) -> int

        int
        FiniteDifference::NumGlobalDiagonals() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NumGlobalDiagonals(self, *args)

    def NumMyNonzeros(self, *args):
        """
        NumMyNonzeros(self) -> int

        int FiniteDifference::NumMyNonzeros() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NumMyNonzeros(self, *args)

    def NumMyRows(self, *args):
        """
        NumMyRows(self) -> int

        int
        FiniteDifference::NumMyRows() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NumMyRows(self, *args)

    def NumMyCols(self, *args):
        """
        NumMyCols(self) -> int

        int
        FiniteDifference::NumMyCols() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NumMyCols(self, *args)

    def NumMyDiagonals(self, *args):
        """
        NumMyDiagonals(self) -> int

        int FiniteDifference::NumMyDiagonals() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_NumMyDiagonals(self, *args)

    def LowerTriangular(self, *args):
        """
        LowerTriangular(self) -> bool

        bool FiniteDifference::LowerTriangular() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_LowerTriangular(self, *args)

    def UpperTriangular(self, *args):
        """
        UpperTriangular(self) -> bool

        bool FiniteDifference::UpperTriangular() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_UpperTriangular(self, *args)

    def Comm(self, *args):
        """
        Comm(self) -> Comm

        const
        Epetra_Comm & FiniteDifference::Comm() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_Comm(self, *args)

    def RowMatrixRowMap(self, *args):
        """
        RowMatrixRowMap(self) -> Map

        const Epetra_Map & FiniteDifference::RowMatrixRowMap() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_RowMatrixRowMap(self, *args)

    def RowMatrixColMap(self, *args):
        """
        RowMatrixColMap(self) -> Map

        const Epetra_Map & FiniteDifference::RowMatrixColMap() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_RowMatrixColMap(self, *args)

    def RowMatrixImporter(self, *args):
        """
        RowMatrixImporter(self) -> Import

        const Epetra_Import
        * FiniteDifference::RowMatrixImporter() const

        See Epetra_RowMatrix documentation. 
        """
        return ___init__.FiniteDifference_RowMatrixImporter(self, *args)

    def Map(self, *args):
        """
        Map(self) -> BlockMap

        const
        Epetra_BlockMap & FiniteDifference::Map() const

        See Epetra_SrcDistObj documentation. 
        """
        return ___init__.FiniteDifference_Map(self, *args)

    def computeJacobian(self, *args):
        """
        computeJacobian(self, Epetra_Vector x, Operator Jac) -> bool
        computeJacobian(self, Epetra_Vector x) -> bool

        bool FiniteDifference::computeJacobian(const Epetra_Vector &x)

        Compute Jacobian given the specified input vector, x. Returns true if
        computation was successful. 
        """
        return ___init__.FiniteDifference_computeJacobian(self, *args)

    def computePreconditioner(self, *args):
        """
        computePreconditioner(self, Epetra_Vector x, Operator Prec, ParameterList precParams = None) -> bool

        bool
        FiniteDifference::computePreconditioner(const Epetra_Vector &x,
        Epetra_Operator &Prec, Teuchos::ParameterList *precParams=0)

        Compute an Epetra_RowMatrix to be used by Aztec preconditioners given
        the specified input vector, x. Returns true if computation was
        successful. 
        """
        return ___init__.FiniteDifference_computePreconditioner(self, *args)

    def setDifferenceMethod(self, *args):
        """
        setDifferenceMethod(self, DifferenceType type)

        void
        FiniteDifference::setDifferenceMethod(DifferenceType type)

        Set the type of perturbation method used (default is Forward). 
        """
        return ___init__.FiniteDifference_setDifferenceMethod(self, *args)

    def getUnderlyingMatrix(self, *args):
        """
        getUnderlyingMatrix(self) -> CrsMatrix

        Epetra_CrsMatrix
        & FiniteDifference::getUnderlyingMatrix() const

        An accessor method for the underlying Epetra_CrsMatrix. 
        """
        return ___init__.FiniteDifference_getUnderlyingMatrix(self, *args)

    def setGroupForComputeF(self, *args):
        """
        setGroupForComputeF(self, Group group)

        void
        FiniteDifference::setGroupForComputeF(NOX::Abstract::Group &group)

        Register a NOX::Abstract::Group derived object and use the computeF()
        method of that group for the perturbation instead of the
        NOX::Epetra::Interface::Required::computeF() method. This is required
        for LOCA to get the operators correct during homotopy. 
        """
        return ___init__.FiniteDifference_setGroupForComputeF(self, *args)

FiniteDifference_swigregister = ___init__.FiniteDifference_swigregister
FiniteDifference_swigregister(FiniteDifference)

class FiniteDifferenceColoring(FiniteDifference):
    """
    Concrete implementation for creating an Epetra_RowMatrix Jacobian via
    finite differencing of the residual using coloring.

    The Jacobian entries are calculated via 1st or 2nd order finite
    differencing. This requires $ N + 1 $ or $ 2N + 1 $ calls to
    computeF(), respectively, where $ N $ is the number of colors.

    \\[ J_{ij} = \\frac{\\partial F_i}{\\partial x_j} =
    \\frac{F_i(x+\\delta\\mathbf{e}_j) - F_i(x)}{\\delta} \\]

    where $J$ is the Jacobian, $F$ is the function evaluation, $x$ is the
    solution vector, and $\\delta$ is a small perturbation to the $x_j$
    entry.

    Instead of perturbing each $ N_{dof} $ problem degrees of freedom
    sequentially and then evaluating all $ N_{dof} $ functions for each
    perturbation, coloring allows several degrees of freedom (all
    belonging to the same color) to be perturbed at the same time. This
    reduces the total number of function evaluations needed to compute
    $\\mathbf{J}$ from $ N_{dof}^2 $ as is required using
    FiniteDifference to $ N\\cdot N_{dof} $, often representing
    substantial computational savings.

    Coloring is based on a user-supplied color map generated using an
    appropriate algorithm, eg greedy-algorithm - Y. Saad, "Iterative
    Methods for Sparse Linear Systems, 2nd ed.," chp. 3, SIAM, 2003.. Use
    can be made of the coloring algorithm provided by the EpetraExt
    package in Trilinos. The 1Dfem_nonlinearColoring and Brusselator
    example problems located in the nox/epetra-examples subdirectory
    demonstrate use of the EpetraExt package, and the
    1Dfem_nonlinearColoring directory also contains a stand-alone coloring
    algorithm very similar to that in EpetraExt.

    The perturbation, $ \\delta $, is calculated using the following
    equation:

    \\[ \\delta = \\alpha * | x_j | + \\beta \\]

    where $ \\alpha $ is a scalar value (defaults to 1.0e-4) and $
    \\beta $ is another scalar (defaults to 1.0e-6).

    Since both FiniteDifferenceColoring and FiniteDifference inherit from
    the Epetra_RowMatrix class, they can be used as preconditioning
    matrices for AztecOO preconditioners.

    As for FiniteDifference, 1st order accurate Forward and Backward
    differences as well as 2nd order accurate Centered difference can be
    specified using setDifferenceMethod with the appropriate enumerated
    type passed as the argument.

    Using FiniteDifferenceColoring in Parallel

    Two ways of using this class in a distributed parallel environment are
    currently supported. From an application standpoint, the two
    approaches differ only in the status of the solution iterate used in
    the residual fill. If an object of this class is contructed with
    parallelColoring = true the solution iterate will be passe back in a
    non-ghosted form. On the contrary, setting this parameter to false in
    the constructor will cause the solution iterate to be in a ghosted
    form when calling back for a residual fill. When using the second
    approach, the user should be aware that the perturbed vector used to
    compute residuals has already been scattered to a form consistent with
    the column space of the Epetra_CrsGraph. In practice, this means that
    the perturbed vector used by computeF() has already been scattered to
    a ghosted or overlapped state. The application should then not perform
    this step but rather simply use the vector provided with the possible
    exception of requiring a local index reordering to bring the column-
    space based vector in sync with a potentially different ghosted index
    ordering. See the Brusselator and 1Dfem_nonlinearColoring example
    problems for details.

    Special Case for Approximate Jacobian Construction

    Provision is made for a simplified and cheaper use of coloring that
    currently provides only for the diagonal of the Jacobian to be
    computed. This is based on using a first-neighbors coloring of the
    original Jacobian graph using the Epetra_Ext MapColoring class with
    the distance1 argument set to true. This same argument should also be
    set to true in the constructor to this class. The result will be a
    diagonal Jacobian filled in a much more efficient manner.

    C++ includes: NOX_Epetra_FiniteDifferenceColoring.H 
    """
    __swig_setmethods__ = {}
    for _s in [FiniteDifference]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, FiniteDifferenceColoring, name, value)
    __swig_getmethods__ = {}
    for _s in [FiniteDifference]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, FiniteDifferenceColoring, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_FiniteDifferenceColoring
    __del__ = lambda self : None;
    def computeJacobian(self, *args):
        """
        computeJacobian(self, Epetra_Vector x, Operator Jac) -> bool
        computeJacobian(self, Epetra_Vector x) -> bool

        bool
        FiniteDifferenceColoring::computeJacobian(const Epetra_Vector &x)

        Compute Jacobian given the specified input vector, x. Returns true if
        computation was successful. 
        """
        return ___init__.FiniteDifferenceColoring_computeJacobian(self, *args)

    def createColorContainers(self, *args):
        """
        createColorContainers(self)

        void
        FiniteDifferenceColoring::createColorContainers()

        Output the coloring map, index map and underlying matrix.

        Create containers for using color and index maps in parallel coloring

        """
        return ___init__.FiniteDifferenceColoring_createColorContainers(self, *args)

    def __init__(self, *args): 
        """
        __init__(self, ParameterList printingParams, Required i, Vector initialGuess, 
            CrsGraph rawGraph, bool parallelColoring = False, 
            bool distance1 = False, double beta = 1.0e-6, 
            double alpha = 1.0e-4) -> FiniteDifferenceColoring

        FiniteDifferenceColoring::FiniteDifferenceColoring(Teuchos::ParameterList
        &printingParams, const Teuchos::RCP< Interface::Required > &i, const
        NOX::Epetra::Vector &initialGuess, const Teuchos::RCP< Epetra_CrsGraph
        > &rawGraph, const Teuchos::RCP< Epetra_MapColoring > &colorMap, const
        Teuchos::RCP< vector< Epetra_IntVector > > &columns, bool
        parallelColoring=false, bool distance1=false, double beta=1.0e-6,
        double alpha=1.0e-4)

        Constructor with output control. 
        """
        this = ___init__.new_FiniteDifferenceColoring(*args)
        try: self.this.append(this)
        except: self.this = this
FiniteDifferenceColoring_swigregister = ___init__.FiniteDifferenceColoring_swigregister
FiniteDifferenceColoring_swigregister(FiniteDifferenceColoring)

class MatrixFree(Operator,Interface.Jacobian):
    """
    Concrete implementation for creating an Epetra_Operator Jacobian based
    on the Matrix-Free Newton-Krylov method.

    Matrix-Free Newton-Krylov is a method that takes advantage of the fact
    the Newton Krylov solvers do not require an explicit Jacobian matrix.
    Newton-Krylov solvers only require the matrix-vector product $Jy$ in
    the iteration sequence. This product can approximated by the
    following:

    \\[ Jy = \\frac{F(x + \\delta y) - F(x)}{\\delta} \\]

    where $J$ is the Jacobian, $F$ is the function evaluation, $x$ is the
    solution vector, $y$ is the vector to be operated on, and $\\delta$
    is a scalar perturbation calculated by:

    \\[ \\delta = \\lambda * (\\lambda + \\frac{\\|
    x\\|}{\\| y\\|} ) \\]

    where $ \\lambda = 1.0e-6 $.

    C++ includes: NOX_Epetra_MatrixFree.H 
    """
    __swig_setmethods__ = {}
    for _s in [Operator,Interface.Jacobian]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, MatrixFree, name, value)
    __swig_getmethods__ = {}
    for _s in [Operator,Interface.Jacobian]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, MatrixFree, name)
    __repr__ = _swig_repr
    Forward = ___init__.MatrixFree_Forward
    Backward = ___init__.MatrixFree_Backward
    Centered = ___init__.MatrixFree_Centered
    def __init__(self, *args): 
        """
        __init__(self, ParameterList printParams, Teuchos::RCP<(NOX::Epetra::Interface::Required)> i, 
            Vector cloneVector, 
            bool useNewPerturbation = False) -> MatrixFree

        MatrixFree::MatrixFree(Teuchos::ParameterList &printParams, const
        Teuchos::RCP< NOX::Epetra::Interface::Required > &i, const
        NOX::Epetra::Vector &cloneVector, bool useNewPerturbation=false)

        Constructor.

        The vector x is used to clone the solution vector. 
        """
        this = ___init__.new_MatrixFree(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_MatrixFree
    __del__ = lambda self : None;
    def SetUseTranspose(self, *args):
        """
        SetUseTranspose(self, bool UseTranspose) -> int

        int
        MatrixFree::SetUseTranspose(bool UseTranspose)

        If set true, transpose of this operator will be applied.

        This flag allows the transpose of the given operator to be used
        implicitly. Setting this flag affects only the Apply() and
        ApplyInverse() methods. If the implementation of this interface does
        not support transpose use, this method should return a value of -1.

        Parameters:
        -----------

        UseTranspose:  -If true, multiply by the transpose of operator,
        otherwise just use operator.

        Integer error code, set to 0 if successful. Set to -1 if this
        implementation does not support transpose. 
        """
        return ___init__.MatrixFree_SetUseTranspose(self, *args)

    def Apply(self, *args):
        """
        Apply(self, Epetra_MultiVector X, Epetra_MultiVector Y) -> int

        int
        MatrixFree::Apply(const Epetra_MultiVector &X, Epetra_MultiVector &Y)
        const

        Returns the result of a Epetra_Operator applied to a
        Epetra_MultiVector X in Y.

        Parameters:
        -----------

        X:  - A Epetra_MultiVector of dimension NumVectors to multiply with
        matrix.

        Y:  -A Epetra_MultiVector of dimension NumVectors containing result.

        Integer error code, set to 0 if successful. 
        """
        return ___init__.MatrixFree_Apply(self, *args)

    def ApplyInverse(self, *args):
        """
        ApplyInverse(self, Epetra_MultiVector X, Epetra_MultiVector Y) -> int

        int
        MatrixFree::ApplyInverse(const Epetra_MultiVector &X,
        Epetra_MultiVector &Y) const

        Returns the result of a Epetra_Operator inverse applied to an
        Epetra_MultiVector X in Y.

        Parameters:
        -----------

        X:  - A Epetra_MultiVector of dimension NumVectors to solve for.

        Y:  -A Epetra_MultiVector of dimension NumVectors containing result.

        Integer error code, set to 0 if successful.

        WARNING:  In order to work with AztecOO, any implementation of this
        method must support the case where X and Y are the same object. 
        """
        return ___init__.MatrixFree_ApplyInverse(self, *args)

    def NormInf(self, *args):
        """
        NormInf(self) -> double

        double
        MatrixFree::NormInf() const

        Returns the infinity norm of the global matrix. 
        """
        return ___init__.MatrixFree_NormInf(self, *args)

    def Label(self, *args):
        """
        Label(self) -> char

        const char *
        MatrixFree::Label() const

        Returns a character string describing the operator. 
        """
        return ___init__.MatrixFree_Label(self, *args)

    def UseTranspose(self, *args):
        """
        UseTranspose(self) -> bool

        bool
        MatrixFree::UseTranspose() const

        Returns the current UseTranspose setting. 
        """
        return ___init__.MatrixFree_UseTranspose(self, *args)

    def HasNormInf(self, *args):
        """
        HasNormInf(self) -> bool

        bool
        MatrixFree::HasNormInf() const

        Returns true if the this object can provide an approximate Inf-norm,
        false otherwise. 
        """
        return ___init__.MatrixFree_HasNormInf(self, *args)

    def Comm(self, *args):
        """
        Comm(self) -> Comm

        const
        Epetra_Comm & MatrixFree::Comm() const

        Returns a reference to the Epetra_Comm communicator associated with
        this operator. 
        """
        return ___init__.MatrixFree_Comm(self, *args)

    def OperatorDomainMap(self, *args):
        """
        OperatorDomainMap(self) -> Map

        const Epetra_Map & MatrixFree::OperatorDomainMap() const

        Returns the Epetra_BlockMap object associated with the domain of this
        matrix operator. 
        """
        return ___init__.MatrixFree_OperatorDomainMap(self, *args)

    def OperatorRangeMap(self, *args):
        """
        OperatorRangeMap(self) -> Map

        const Epetra_Map & MatrixFree::OperatorRangeMap() const

        Returns the Epetra_BlockMap object associated with the range of this
        matrix operator. 
        """
        return ___init__.MatrixFree_OperatorRangeMap(self, *args)

    def computeJacobian(self, *args):
        """
        computeJacobian(self, Epetra_Vector x, Operator Jac) -> bool

        bool
        MatrixFree::computeJacobian(const Epetra_Vector &x, Epetra_Operator
        &Jac)

        Compute Jacobian given the specified input vector, x. Returns true if
        computation was successful. 
        """
        return ___init__.MatrixFree_computeJacobian(self, *args)

    def setDifferenceMethod(self, *args):
        """
        setDifferenceMethod(self, DifferenceType type)

        void MatrixFree::setDifferenceMethod(DifferenceType type)

        Set the type of perturbation method used (default is Forward). 
        """
        return ___init__.MatrixFree_setDifferenceMethod(self, *args)

    def setLambda(self, *args):
        """
        setLambda(self, double lambda_)

        void
        MatrixFree::setLambda(double lambda_)

        Allows the user to change the value of $ \\lambda $ in the
        perturbation calculation. 
        """
        return ___init__.MatrixFree_setLambda(self, *args)

    def setComputePerturbation(self, *args):
        """
        setComputePerturbation(self, bool bVal)

        void MatrixFree::setComputePerturbation(bool bVal)

        Flag that toggles whether MatrixFree should compute the perturbation
        parameter $ \\eta $ or use a value supplied by the user through
        setPerturbation(). 
        """
        return ___init__.MatrixFree_setComputePerturbation(self, *args)

    def setPerturbation(self, *args):
        """
        setPerturbation(self, double eta_)

        void
        MatrixFree::setPerturbation(double eta_)

        Set the perturbation parameter $ \\eta $. 
        """
        return ___init__.MatrixFree_setPerturbation(self, *args)

    def getPerturbation(self, *args):
        """
        getPerturbation(self) -> double

        double MatrixFree::getPerturbation() const

        Returns the most recently used value of the perturbation parameter $
        \\eta $. 
        """
        return ___init__.MatrixFree_getPerturbation(self, *args)

    def setGroupForComputeF(self, *args):
        """
        setGroupForComputeF(self, Group group)

        void MatrixFree::setGroupForComputeF(const NOX::Abstract::Group
        &group)

        Clone a NOX::Abstract::Group derived object and use the computeF()
        method of that group for the perturbation instead of the
        NOX::Epetra::Interface::Required::computeF() method. This is required
        for LOCA to get the operators correct during homotopy. 
        """
        return ___init__.MatrixFree_setGroupForComputeF(self, *args)

MatrixFree_swigregister = ___init__.MatrixFree_swigregister
MatrixFree_swigregister(MatrixFree)

class Scaling(_object):
    """
    Object to control scaling of vectors and linear systems.

    Currently this assumes a diagonal scaling only! Once epetra can do
    matrix-matrix multiplies we will expand this class.

    C++ includes: NOX_Epetra_Scaling.H 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Scaling, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Scaling, name)
    __repr__ = _swig_repr
    Scaling_None = ___init__.Scaling_Scaling_None
    RowSum = ___init__.Scaling_RowSum
    ColSum = ___init__.Scaling_ColSum
    UserDefined = ___init__.Scaling_UserDefined
    Left = ___init__.Scaling_Left
    Right = ___init__.Scaling_Right
    def __init__(self, *args): 
        """
        __init__(self) -> Scaling

        NOX::Epetra::Scaling::Scaling()

        Constructor. 
        """
        this = ___init__.new_Scaling(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_Scaling
    __del__ = lambda self : None;
    def addUserScaling(self, *args):
        """
        addUserScaling(self, ScaleType type, Teuchos::RCP<(Epetra_Vector)> D)

        void
        NOX::Epetra::Scaling::addUserScaling(ScaleType type, const
        Teuchos::RCP< Epetra_Vector > &D)

        Add a user supplied diagonal scale vector to the scaling object. 
        """
        return ___init__.Scaling_addUserScaling(self, *args)

    def addRowSumScaling(self, *args):
        """
        addRowSumScaling(self, ScaleType type, Teuchos::RCP<(Epetra_Vector)> D)

        void
        NOX::Epetra::Scaling::addRowSumScaling(ScaleType type, const
        Teuchos::RCP< Epetra_Vector > &D)

        Add "Row Sum" scaling to the scaling object. The supplied vector is
        used to store the current row sum vector. 
        """
        return ___init__.Scaling_addRowSumScaling(self, *args)

    def addColSumScaling(self, *args):
        """
        addColSumScaling(self, ScaleType type, Teuchos::RCP<(Epetra_Vector)> D)

        void
        NOX::Epetra::Scaling::addColSumScaling(ScaleType type, const
        Teuchos::RCP< Epetra_Vector > &D)

        Add "Col Sum" scaling to the scaling object. The supplied vector is
        used to store the current column sum vector. 
        """
        return ___init__.Scaling_addColSumScaling(self, *args)

    def computeScaling(self, *args):
        """
        computeScaling(self, LinearProblem problem)

        void
        NOX::Epetra::Scaling::computeScaling(const Epetra_LinearProblem
        &problem)

        Computes Row Sum scaling diagonal vectors. Only needs to be called if
        a row or column sum scaling has been requested. 
        """
        return ___init__.Scaling_computeScaling(self, *args)

    def scaleLinearSystem(self, *args):
        """
        scaleLinearSystem(self, LinearProblem problem)

        void
        NOX::Epetra::Scaling::scaleLinearSystem(Epetra_LinearProblem &problem)

        Scales the linear system. 
        """
        return ___init__.Scaling_scaleLinearSystem(self, *args)

    def unscaleLinearSystem(self, *args):
        """
        unscaleLinearSystem(self, LinearProblem problem)

        void NOX::Epetra::Scaling::unscaleLinearSystem(Epetra_LinearProblem
        &problem)

        Remove the scaling from the linear system. 
        """
        return ___init__.Scaling_unscaleLinearSystem(self, *args)

    def applyRightScaling(self, *args):
        """
        applyRightScaling(self, Epetra_Vector input, Epetra_Vector result)

        void
        NOX::Epetra::Scaling::applyRightScaling(const Epetra_Vector &input,
        Epetra_Vector &result)

        Applies any RIGHT scaling vectors to an input vector. 
        """
        return ___init__.Scaling_applyRightScaling(self, *args)

    def applyLeftScaling(self, *args):
        """
        applyLeftScaling(self, Epetra_Vector input, Epetra_Vector result)

        void
        NOX::Epetra::Scaling::applyLeftScaling(const Epetra_Vector &input,
        Epetra_Vector &result)

        Applies any LEFT scaling vectors to an input vector. 
        """
        return ___init__.Scaling_applyLeftScaling(self, *args)

Scaling_swigregister = ___init__.Scaling_swigregister
Scaling_swigregister(Scaling)

class LinearSystem(_object):
    """
    Pure virtual class interface for allowing different linear solvers to
    be used by the NOX::Epetra::Group.

    C++ includes: NOX_Epetra_LinearSystem.H 
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearSystem, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, LinearSystem, name)
    __repr__ = _swig_repr
    PRPT_REBUILD = ___init__.LinearSystem_PRPT_REBUILD
    PRPT_RECOMPUTE = ___init__.LinearSystem_PRPT_RECOMPUTE
    PRPT_REUSE = ___init__.LinearSystem_PRPT_REUSE
    def __init__(self, *args): 
        """
        __init__(self) -> LinearSystem

        NOX::Epetra::LinearSystem::LinearSystem()

        Constructor. 
        """
        if self.__class__ == LinearSystem:
            _self = None
        else:
            _self = self
        this = ___init__.new_LinearSystem(_self, *args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_LinearSystem
    __del__ = lambda self : None;
    def applyJacobian(self, *args):
        """
        applyJacobian(self, Vector input, Vector nox_result) -> bool

        virtual bool NOX::Epetra::LinearSystem::applyJacobian(const
        NOX::Epetra::Vector &input, NOX::Epetra::Vector &result) const =0

        Applies Jacobian to the given input vector and puts the answer in the
        result.

        Computes \\[ v = J u, \\] where $J$ is the Jacobian, $u$ is the
        input vector, and $v$ is the result vector. Returns true if
        successful. 
        """
        return ___init__.LinearSystem_applyJacobian(self, *args)

    def applyJacobianTranspose(self, *args):
        """
        applyJacobianTranspose(self, Vector input, Vector nox_result) -> bool

        virtual bool
        NOX::Epetra::LinearSystem::applyJacobianTranspose(const
        NOX::Epetra::Vector &input, NOX::Epetra::Vector &result) const =0

        Applies Jacobian-Transpose to the given input vector and puts the
        answer in the result.

        Computes \\[ v = J^T u, \\] where $J$ is the Jacobian, $u$ is the
        input vector, and $v$ is the result vector. Returns true if
        successful. 
        """
        return ___init__.LinearSystem_applyJacobianTranspose(self, *args)

    def applyJacobianInverse(self, *args):
        """
        applyJacobianInverse(self, ParameterList params, Vector input, Vector nox_result) -> bool

        virtual bool
        NOX::Epetra::LinearSystem::applyJacobianInverse(Teuchos::ParameterList
        &params, const NOX::Epetra::Vector &input, NOX::Epetra::Vector
        &result)=0

        Applies the inverse of the Jacobian matrix to the given input vector
        and puts the answer in result.

        Computes \\[ v = J^{-1} u, \\] where $J$ is the Jacobian, $u$ is
        the input vector, and $v$ is the result vector.

        The parameter list contains the linear solver options. 
        """
        return ___init__.LinearSystem_applyJacobianInverse(self, *args)

    def applyRightPreconditioning(self, *args):
        """
        applyRightPreconditioning(self, bool useTranspose, ParameterList params, Vector input, 
            Vector nox_result) -> bool

        virtual bool
        NOX::Epetra::LinearSystem::applyRightPreconditioning(bool
        useTranspose, Teuchos::ParameterList &params, const
        NOX::Epetra::Vector &input, NOX::Epetra::Vector &result) const =0

        Apply right preconditiong to the given input vector.

        Let $M$ be a right preconditioner for the Jacobian $J$; in other
        words, $M$ is a matrix such that \\[ JM \\approx I. \\]

        Compute \\[ u = M^{-1} v, \\] where $u$ is the input vector and
        $v$ is the result vector.

        If useTranspose is true, then the transpose of the preconditioner is
        applied: \\[ u = {M^{-1}}^T v, \\] The transpose preconditioner is
        currently only required for Tensor methods.

        The parameter list contains the linear solver options. 
        """
        return ___init__.LinearSystem_applyRightPreconditioning(self, *args)

    def getScaling(self, *args):
        """
        getScaling(self) -> Teuchos::RCP<(NOX::Epetra::Scaling)>

        virtual
        Teuchos::RCP<NOX::Epetra::Scaling>
        NOX::Epetra::LinearSystem::getScaling()=0

        Get the scaling object. 
        """
        return ___init__.LinearSystem_getScaling(self, *args)

    def resetScaling(self, *args):
        """
        resetScaling(self, Teuchos::RCP<(NOX::Epetra::Scaling)> s)

        virtual void NOX::Epetra::LinearSystem::resetScaling(const
        Teuchos::RCP< NOX::Epetra::Scaling > &s)=0

        Sets the diagonal scaling vector(s) used in scaling the linear system.

        See NOX::Epetra::Scaling for details on how to specify scaling of the
        linear system. 
        """
        return ___init__.LinearSystem_resetScaling(self, *args)

    def computeJacobian(self, *args):
        """
        computeJacobian(self, Vector x) -> bool

        virtual bool NOX::Epetra::LinearSystem::computeJacobian(const
        NOX::Epetra::Vector &x)=0

        Evaluates the Jacobian based on the solution vector x. 
        """
        return ___init__.LinearSystem_computeJacobian(self, *args)

    def createPreconditioner(self, *args):
        """
        createPreconditioner(self, Vector x, ParameterList p, bool recomputeGraph) -> bool

        virtual bool NOX::Epetra::LinearSystem::createPreconditioner(const
        NOX::Epetra::Vector &x, Teuchos::ParameterList &p, bool
        recomputeGraph) const =0

        Explicitly constructs a preconditioner based on the solution vector x
        and the parameter list p.

        The user has the option of recomputing the graph when a new
        preconditioner is created. The NOX::Epetra::Group controls the isValid
        flag for the preconditioner and will control when to call this. 
        """
        return ___init__.LinearSystem_createPreconditioner(self, *args)

    def destroyPreconditioner(self, *args):
        """
        destroyPreconditioner(self) -> bool

        virtual bool
        NOX::Epetra::LinearSystem::destroyPreconditioner() const =0

        Deletes the preconditioner.

        The NOX::Epetra::Group controls the isValid flag for the
        preconditioner and will control when to call this. 
        """
        return ___init__.LinearSystem_destroyPreconditioner(self, *args)

    def recomputePreconditioner(self, *args):
        """
        recomputePreconditioner(self, Vector x, ParameterList linearSolverParams) -> bool

        virtual bool
        NOX::Epetra::LinearSystem::recomputePreconditioner(const
        NOX::Epetra::Vector &x, Teuchos::ParameterList &linearSolverParams)
        const =0

        Recalculates the preconditioner using an already allocated graph.

        Use this to compute a new preconditioner while using the same graph
        for the preconditioner. This avoids deleting and reallocating the
        memory required for the preconditioner and results in a big speed-up
        for large-scale jobs. 
        """
        return ___init__.LinearSystem_recomputePreconditioner(self, *args)

    def getPreconditionerPolicy(self, *args):
        """
        getPreconditionerPolicy(self, bool advanceReuseCounter = True) -> PreconditionerReusePolicyType

        virtual
        PreconditionerReusePolicyType
        NOX::Epetra::LinearSystem::getPreconditionerPolicy(bool
        advanceReuseCounter=true)=0

        Evaluates the preconditioner policy at the current state.

        NOTE: This can change values between nonlienar iterations. It is not a
        static value. 
        """
        return ___init__.LinearSystem_getPreconditionerPolicy(self, *args)

    def isPreconditionerConstructed(self, *args):
        """
        isPreconditionerConstructed(self) -> bool

        virtual bool
        NOX::Epetra::LinearSystem::isPreconditionerConstructed() const =0

        Indicates whether a preconditioner has been constructed. 
        """
        return ___init__.LinearSystem_isPreconditionerConstructed(self, *args)

    def hasPreconditioner(self, *args):
        """
        hasPreconditioner(self) -> bool

        virtual bool NOX::Epetra::LinearSystem::hasPreconditioner() const =0

        Indicates whether the linear system has a preconditioner. 
        """
        return ___init__.LinearSystem_hasPreconditioner(self, *args)

    def getJacobianOperator(self, *args):
        """
        getJacobianOperator(self) -> Teuchos::RCP<(q(const).Epetra_Operator)>
        getJacobianOperator(self) -> Teuchos::RCP<(Epetra_Operator)>

        virtual Teuchos::RCP<Epetra_Operator>
        NOX::Epetra::LinearSystem::getJacobianOperator()=0

        Return Jacobian operator. 
        """
        return ___init__.LinearSystem_getJacobianOperator(self, *args)

    def getGeneratedPrecOperator(self, *args):
        """
        getGeneratedPrecOperator(self) -> Teuchos::RCP<(q(const).Epetra_Operator)>
        getGeneratedPrecOperator(self) -> Teuchos::RCP<(Epetra_Operator)>

        virtual
        Teuchos::RCP<Epetra_Operator>
        NOX::Epetra::LinearSystem::getGeneratedPrecOperator()=0

        Return preconditioner operator. 
        """
        return ___init__.LinearSystem_getGeneratedPrecOperator(self, *args)

    def setJacobianOperatorForSolve(self, *args):
        """
        setJacobianOperatorForSolve(self, Teuchos::RCP<(q(const).Epetra_Operator)> solveJacOp)

        virtual void
        NOX::Epetra::LinearSystem::setJacobianOperatorForSolve(const
        Teuchos::RCP< const Epetra_Operator > &solveJacOp)=0

        Set Jacobian operator for solve. 
        """
        return ___init__.LinearSystem_setJacobianOperatorForSolve(self, *args)

    def setPrecOperatorForSolve(self, *args):
        """
        setPrecOperatorForSolve(self, Teuchos::RCP<(q(const).Epetra_Operator)> solvePrecOp)

        virtual void
        NOX::Epetra::LinearSystem::setPrecOperatorForSolve(const Teuchos::RCP<
        const Epetra_Operator > &solvePrecOp)=0

        Set preconditioner operator for solve.

        Note: This should only be called if hasPreconditioner() returns true.

        """
        return ___init__.LinearSystem_setPrecOperatorForSolve(self, *args)

    def __disown__(self):
        self.this.disown()
        ___init__.disown_LinearSystem(self)
        return weakref_proxy(self)
LinearSystem_swigregister = ___init__.LinearSystem_swigregister
LinearSystem_swigregister(LinearSystem)

class LinearSystemAztecOO(LinearSystem):
    """
    Concrete implementation of NOX::Epetra::LinearSolver for AztecOO.

    This solver provides the linear algebra services provided through the
    AztecOO parallel iterative linear solver.

    The NOX::Epetra::LinearSystemAztecOO object provides a flexible and
    efficient way to interface an Epetra based application code to the
    Aztec linear solver. This class handles construction of both the
    preconditioners and AztecOO solver. All options are determined through
    parameter lists and the basic constructors.

    Constructing a Linear System

    There are four different constructors that can be used. The difference
    between constructors is based on whether the user supplies a Jacobian,
    a preconditioner, neither or both.

    If a Jacobian is not supplied then this object can create an
    internally constructed Jacobian based on a Finite Difference or
    Matrif-Free object. The user can specify which type of object to use
    by setting the parameter "Jacobian Operator" in the parameter list.
    The choices are "Matrix-Free" or "Finite Difference".

    The user can supply their own preconditioner as an Epetra_Operator, or
    they can supply their own matrix (an Epetra_RowMatrix derived object)
    that can be used by one of the internal preconditioner libraries
    (currently aztecoo or ifpack). If they supply their own preconditioner
    the object must implement the Epetra_Operator::ApplyInverse method.
    This is the method called during the linear solve to introduce
    preconditoning into aztecoo. If the user supplies a matrix to be used
    with an internal preconditioner, it must be derived from the
    Epetra_RowMatrix class and must implement all functionality in the
    Epetra_RowMatrix. If a Preconditioner is not supplied, then this
    object can create an internal preconditioner matrix by finite
    differencing or it can use the Jacobian operator if the Jacobian
    derives from the Epetra_RowMatrix class. The user can specify which
    type of object to use by setting the parameter "Preconditioner
    Operator" in the parameter list. The choices are "Use Jacobian" or
    "Finite Difference".

    The Jacobian and preconditioner each require an interface to update
    the state of the operator with respect to the solution vector and any
    other parameters. There are three interfaces that can be implemented,
    NOX::Epetra::Interface::Required, NOX::Epetra::Interface::Jacobian,
    and NOX::Epetra::Interface::Preconditioner.

    NOX::Epetra::Interface::Required supplies the computeF() function so
    codes can tell NOX what the nonlinear equations are. This is the
    minimum requirement to run nox through the epetra interface.
    LinearSolverAztecOO requires this in some constructors so that if a
    Jacobian or preconditoner is not supplied, it will use computeF from
    the Required interface to estimate the Jacobian or preconditioner via
    finite differences or directional derivatives.

    NOX::Epetra::Interface::Jacobian is used for updating a user supplied
    Jacobian opertor with respect to the solution vector and any other
    parameters. It is required only in constructors in which a user
    supplies a Jacobian operator.

    NOX::Epetra::Interface::Preconditioner is used for updating a user
    supplied preconditioner opertor/matrix with respect to the solution
    vector and any other parameters. It is required only in constructors
    in which a user supplies a preconditioner operator.

    "Linear Solver" sublist parameters

    A Teuchos::ParameterList called linearSolverParams is required in the
    various constructors and during some method calls such as
    applyJacobianInverse() and applyRightPreconditioning(). Typically,
    this list is the "Linear Solver" sublist found in the nox parameter
    list. The following parameters can be set in the linear solver sublist
    and are vaild for the NOX::Epetra::LinearSolverAztecOO object: "Aztec
    Solver" - Determine the iterative technique used in the solve. The
    following options are valid:

    "GMRES" - Restarted generalized minimal residual (default).

    "CG" - Conjugate gradient.

    "CGS" - Conjugate gradient squared.

    "TFQMR" - Transpose-free quasi-minimal reasidual.

    "BiCGStab" - Bi-conjugate gradient with stabilization.

    "LU" - Sparse direct solve (single processor only).

    "Size of Krylov Subspace" - When using restarted GMRES this sets the
    maximum size of the Krylov subspace (defaults to 300).

    "Orthogonalization" - The orthogonalization routine used for the
    Gram-Schmidt orthogonalization procedure in Aztec. The following
    options are valid:

    "Classical" - (default).

    "Modified"

    "Convergence Test" - Algorithm used to calculate the residual that
    is used for determining the convergence of the linear solver. See the
    Aztec 2.1 manual for more information. The following options are
    valid:

    "r0" - (default)

    "rhs"

    "norm"

    "no scaling"

    "sol"

    "Tolerance" - Tolerance used by AztecOO to determine if an iterative
    linear solve has converged.

    "Ill-Conditioning Threshold" - If the upper hessenberg matrix during
    GMRES generates a condition number greater than this parameter value,
    aztec will exit the linear solve returning the it's current solution.
    The default is 1.0e11.

    "Preconditioner Iterations" - Number of iterations an
    AztecOO_Operator should take when solving the preconditioner. This is
    only used if an AztecOO preconditioner is used and the solver makes a
    call to NOX::Epetra::Group::applyRightPreconditioning(). This is NOT a
    recomended approach.

    "Max Iterations" - maximum number of iterations in the linear solve.
    Default is 400.

    "Zero Initial Guess" - boolean. Zero out the initial guess for
    linear solves performed through applyJacobianInverse calls (i.e. zero
    out the result vector before the linear solve). Defaults to false.

    "Throw Error on Prec Failure" - boolean. If set to true, an
    exception will be thrown if the preconditioner fails to initialize or
    recompute/refactor. If set to false, a warning will br printed if the
    NOX::Utils::Warning is enabled in the printing utilities (
    NOX::Utils). Defaults to true.

    "Output Frequency" - number of linear solve iterations between
    output of the linear solve residual. Takes an integer, or one of the
    AztecOO flags: AZ_none, AZ_last, or AZ_all as a value. Defaults to
    AZ_last.

    "Jacobian Operator" - When a constructor does not require a Jacobian
    operator, the linear system will create a default operator using:

    "Matrix-Free" (default)

    "Finite Difference"

    "Preconditioner" - Sets the choice of the preconditioner to use
    during linear solves. The validity of the choice of preconditioner
    will depend on the types of operators that are available for the
    Jacobian and preconditioner. NOTE: This flag will override any
    constructor details. For example, if you supply a preconditioner
    operator in the constructor, it will not be used if this flag is set
    to "None". If you supply an Epetra_Operator for the preconditioner
    but the "Preconditioner" flag is set to "AztecOO" (this requires
    an Epetra_RowMatrix for the preconditioner operator), this object will
    exit with a failure. The valid options and any requirements on the
    operator type are listed below:

    "None" - No preconditioning. (default)

    "AztecOO" - AztecOO internal preconditioner. This requires a
    preconditioner operator that derives from the Epetra_RowMatrix class.

    "Ifpack" - Ifpack internal preconditioner. This requires a
    preconditioner object that derives from the Epetra_RowMatrix class or
    it can use a Jacobian if the Jacobian derives from an
    Epetra_RowMatrix. This option is deprecated. Please use "New
    Ifpack".

    "New Ifpack" - Ifpack internal preconditioner. This requires a
    preconditioner object that derives from the Epetra_RowMatrix class or
    it can use a Jacobian if the Jacobian derives from an
    Epetra_RowMatrix.

    "User Defined" - The user supplies an Epetra_Operator derived class.
    Users must implement at a minimum the ApplyInverse() function of the
    Epetra_Operator class since preconditioning of vectors is accomplished
    through calls to this method.

    "Jacobian Operator" - If a constructor is used that does not supply
    a Jacobian operator, nox will create an internal Jacobian operator.
    This flag is ONLY valid in such cases. This will determine which
    Operator is used: "Matrix-Free" - Create a NOX::Epetra::MatrixFree
    object.

    "Finite Difference" - Create a NOX::Epetra::FiniteDifference object.

    "Preconditioner Operator" - If a constructor is used that does not
    supply a preconditioner operator, nox will create an internal
    preconditioner operator. This flag is ONLY valid in such cases. This
    will determine which Operator is used: "Use Jacobian" - Use the
    Jacobian Operator (it must be an Epetra_RowMatrix derived object).

    "Finite Difference" - Create a NOX::Epetra::FiniteDifference object.

    "Aztec Preconditioner" - If the "Preconditioner" flag is set to
    "AztecOO" then the specific AztecOO preconditioner is specified with
    this flag. Currently supported preconditioners and their corresponding
    parameters that can be set are shown below (See the Aztec 2.1 manual
    for more information):

    "ilu" - ilu preconditioning. This choice allows the following
    additional parameters to be specified: "Overlap" - defaults to 0

    "Graph Fill" - defaults to 0

    "ilut" - ilut preconditioning. This choice allows the following
    additional parameters to be specified: "Overlap" - defaults to 0

    "Fill Factor" - defaults to 1.0

    "Drop Tolerance" - defaults to 1.0e-12

    "Jacobi" - k step Jacobi where k is set by the "Steps" flag:
    "Steps" - defaults to 3.

    "Symmetric Gauss-Siedel" - Non-overlapping domain decomposition k
    step symmetric Gauss-Siedel where k is set by the "Steps" flag:

    "Steps" - defaults to 3.

    "Polynomial" - Neumann polynomial with order set by the parameter:
    "Polynomial Order" - defaults to 3.

    "Least-squares Polynomial" - Least-squares polynomial with order set
    by the parameter: "Polynomial Order" - defaults to 3.

    "Ifpack" - If the "Preconditioner" flag is set to "New Ifpack"
    then any of the options supported by the Ifpack Create factory can be
    specified using a Teuchos::ParameterList containing the Ifpack options
    and then setting this as a parameter named "Ifpack" in the "Linear
    Solver" sublist.

    "ML" - If the "Preconditioner" flag is set to "ML" then any of
    the options supported by the ML factory can be specified using a
    Teuchos::ParameterList containing the ML options and then setting this
    as a parameter named "ML" in the "Linear Solver" sublist.

    "Preconditioner Reuse Policy" - (string) Allows the user to set how
    and when the preconditioner should be computed. This flag supports
    native Aztec, Ifpack and ML preconditioners. There are three options:
    "Rebuild" - The "Rebuild" option always completely destroys and
    then rebuilds the preconditioner each time a linear solve is
    requested.

    "Reuse" - The group/linear solver will not recompute the
    preconditioner even if the group's solution vector changes. It just
    blindly reuses what has been constructed. This turns off control of
    preconditioner recalculation. This is a dangerous condition but can
    really speed up the computations if the user knows what they are
    doing. We don't recommend users trying this.

    "Recompute" - Recomputes the preconditioner, but will try to
    efficiently reuse any objects that don't need to be destroyed. How
    efficient the "Recompute" option is depends on the type of
    preconditioner. For example if we are using ILU from the Ifpack
    library, we would like to not destroy and reallocate the graph each
    solve. With this option, we tell Ifpack to reuse the graph from last
    time - e.g the sparisty pattern has not changed between applications
    of the preconditioner.

    "Max Age Of Prec" - (int) If the "Preconditioner Reuse Policy" is
    set to "Reuse", this integer tells the linear system how many times
    to reuse the preconditioner before rebuilding it. Defaults to 1.

    "RCM Reordering" - Enables RCM reordering in conjunction with domain
    decomp incomplete factorization preconditioning. The following options
    are valid:

    "Disabled" - (default).

    "Enabled"

    "Use Adaptive Linear Solve" - Enables the use of AztecOO's
    AdaptiveIterate() method instead of calling the Iterate() method. This
    causes the preconditioning matrix to be modified to make the linear
    solves easier. AztecOO will attempt to solve the linear system
    multiple times now and if the solves are failing it will modify the
    preconditioner and try again. Boolean value, defaults to false. NOTE:
    This only works for internal Aztec preconditioners! The
    "Preconditioning" parameter must be set to "AztecOO: Jacobian
    Matrix" or "AztecOO: User RowMatrix". (NOTE: This parameter is
    currently NOT supported)

    "Max Adaptive Solve Iterations" - (integer) Maximum number of
    attempts that the linear solver will make when trying to solve a
    linear system. Defaults to 5. (NOTE: This parameter is currently NOT
    supported)

    "Compute Scaling Manually" - (boolean) The linear system can be
    scaled if a NOX::Epetra::Scaling object is supplied to
    LinearSystemAztecOO. When to compute the scaling can be handled either
    manually by the user, or this object can automatically compute the
    scaling prior to a linear solve. By setting this flag to true, the
    user will call NOX::Epetra::Scaling::computeScaling() manually - on
    their own! Setting this to false means the LinearSystemAztecOO object
    will call the computeScaling function right before it applies the
    scaling to the matrix in the applyJacobianInverse function. Default is
    true (user will call compute scaling).

    "Output Solver Details" - (boolean) Write the output sublist below
    to the parameter list after each linear solve. default is true.

    "Write Linear System" - (boolean) If set to true, the linear system
    (Epetra_Map, Jacobian, LHS and RHS) is printed to a set of files in
    matrix market format. This option requires building nox with the flag
    --enable-nox-debug and building the EpetraExt library.

    "Write Linear System File Prefix" - (string) If writing of the
    linear system is enabled (see above parameter) users can change the
    name of the output file prefix. The default is "NOX_LinSys". This
    option requires building nox with the flag --enable-nox-debug and
    building the EpetraExt library.

    "Output" sublist

    The parameter list passed in during calls to ApplyJacobianInverse()
    will have an "Output" sublist created that contains the following
    parameters if the flag "Output Solver Details" is set to true:

    "Acheived Tolerance" - Actual tolerance achieved by the linear
    solver computed via the convergence test requested.

    "Number of Linear Iterations" - Number of iterations used by the
    linear solver in the last call to applyJacobianInverse

    "Total Number of Linear Iterations" - Total number of linear solve
    iterations performed by groups that have used this input list

    C++ includes: NOX_Epetra_LinearSystem_AztecOO.H 
    """
    __swig_setmethods__ = {}
    for _s in [LinearSystem]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LinearSystemAztecOO, name, value)
    __swig_getmethods__ = {}
    for _s in [LinearSystem]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, LinearSystemAztecOO, name)
    __repr__ = _swig_repr
    def __init__(self, *args): 
        """
        __init__(self, ParameterList printingParams, ParameterList linearSolverParams, 
            Teuchos::RCP<(NOX::Epetra::Interface::Required)> iReq, 
            Vector cloneVector, Teuchos::RCP<(NOX::Epetra::Scaling)> scalingObject = Teuchos::null) -> LinearSystemAztecOO
        __init__(self, ParameterList printingParams, ParameterList linearSolverParams, 
            Teuchos::RCP<(NOX::Epetra::Interface::Required)> iReq, 
            Teuchos::RCP<(NOX::Epetra::Interface::Jacobian)> iJac, 
            Teuchos::RCP<(Epetra_Operator)> J, 
            Vector cloneVector, Teuchos::RCP<(NOX::Epetra::Scaling)> scalingObject = Teuchos::null) -> LinearSystemAztecOO
        __init__(self, ParameterList printingParams, ParameterList linearSolverParams, 
            Teuchos::RCP<(NOX::Epetra::Interface::Required)> i, 
            Teuchos::RCP<(NOX::Epetra::Interface::Preconditioner)> iPrec, 
            Teuchos::RCP<(Epetra_Operator)> M, 
            Vector cloneVector, 
            Teuchos::RCP<(NOX::Epetra::Scaling)> scalingObject = Teuchos::null) -> LinearSystemAztecOO
        __init__(self, ParameterList printingParams, ParameterList linearSolverParams, 
            Teuchos::RCP<(NOX::Epetra::Interface::Jacobian)> iJac, 
            Teuchos::RCP<(Epetra_Operator)> J, 
            Teuchos::RCP<(NOX::Epetra::Interface::Preconditioner)> iPrec, 
            Teuchos::RCP<(Epetra_Operator)> M, 
            Vector cloneVector, Teuchos::RCP<(NOX::Epetra::Scaling)> scalingObject = Teuchos::null) -> LinearSystemAztecOO

        NOX::Epetra::LinearSystemAztecOO::LinearSystemAztecOO(Teuchos::ParameterList
        &printingParams, Teuchos::ParameterList &linearSolverParams, const
        Teuchos::RCP< NOX::Epetra::Interface::Jacobian > &iJac, const
        Teuchos::RCP< Epetra_Operator > &J, const Teuchos::RCP<
        NOX::Epetra::Interface::Preconditioner > &iPrec, const Teuchos::RCP<
        Epetra_Operator > &M, const NOX::Epetra::Vector &cloneVector, const
        Teuchos::RCP< NOX::Epetra::Scaling > scalingObject=Teuchos::null)

        Constructor with user supplied separate objects for the Jacobian (J)
        and Preconditioner (M). linearSolverParams is the "Linear Solver"
        sublist of parameter list. 
        """
        this = ___init__.new_LinearSystemAztecOO(*args)
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = ___init__.delete_LinearSystemAztecOO
    __del__ = lambda self : None;
    def applyJacobian(self, *args):
        """
        applyJacobian(self, Vector input, Vector nox_result) -> bool

        bool NOX::Epetra::LinearSystemAztecOO::applyJacobian(const
        NOX::Epetra::Vector &input, NOX::Epetra::Vector &result) const

        Applies Jacobian to the given input vector and puts the answer in the
        result.

        Computes \\[ v = J u, \\] where $J$ is the Jacobian, $u$ is the
        input vector, and $v$ is the result vector. Returns true if
        successful. 
        """
        return ___init__.LinearSystemAztecOO_applyJacobian(self, *args)

    def applyJacobianTranspose(self, *args):
        """
        applyJacobianTranspose(self, Vector input, Vector nox_result) -> bool

        bool
        NOX::Epetra::LinearSystemAztecOO::applyJacobianTranspose(const
        NOX::Epetra::Vector &input, NOX::Epetra::Vector &result) const

        Applies Jacobian-Transpose to the given input vector and puts the
        answer in the result.

        Computes \\[ v = J^T u, \\] where $J$ is the Jacobian, $u$ is the
        input vector, and $v$ is the result vector. Returns true if
        successful. 
        """
        return ___init__.LinearSystemAztecOO_applyJacobianTranspose(self, *args)

    def applyJacobianInverse(self, *args):
        """
        applyJacobianInverse(self, ParameterList linearSolverParams, Vector input, Vector nox_result) -> bool

        bool
        NOX::Epetra::LinearSystemAztecOO::applyJacobianInverse(Teuchos::ParameterList
        &linearSolverParams, const NOX::Epetra::Vector &input,
        NOX::Epetra::Vector &result)

        Applies the inverse of the Jacobian matrix to the given input vector
        and puts the answer in result.

        Computes \\[ v = J^{-1} u, \\] where $J$ is the Jacobian, $u$ is
        the input vector, and $v$ is the result vector.

        The parameter list contains the linear solver options. 
        """
        return ___init__.LinearSystemAztecOO_applyJacobianInverse(self, *args)

    def applyRightPreconditioning(self, *args):
        """
        applyRightPreconditioning(self, bool useTranspose, ParameterList linearSolverParams, 
            Vector input, Vector nox_result) -> bool

        bool
        NOX::Epetra::LinearSystemAztecOO::applyRightPreconditioning(bool
        useTranspose, Teuchos::ParameterList &linearSolverParams, const
        NOX::Epetra::Vector &input, NOX::Epetra::Vector &result) const

        Apply right preconditiong to the given input vector.

        Let $M$ be a right preconditioner for the Jacobian $J$; in other
        words, $M$ is a matrix such that \\[ JM \\approx I. \\]

        Compute \\[ u = M^{-1} v, \\] where $u$ is the input vector and
        $v$ is the result vector.

        If useTranspose is true, then the transpose of the preconditioner is
        applied: \\[ u = {M^{-1}}^T v, \\] The transpose preconditioner is
        currently only required for Tensor methods.

        The parameter list contains the linear solver options. 
        """
        return ___init__.LinearSystemAztecOO_applyRightPreconditioning(self, *args)

    def createPreconditioner(self, *args):
        """
        createPreconditioner(self, Vector x, ParameterList linearSolverParams, bool recomputeGraph) -> bool

        bool
        NOX::Epetra::LinearSystemAztecOO::createPreconditioner(const
        NOX::Epetra::Vector &x, Teuchos::ParameterList &linearSolverParams,
        bool recomputeGraph) const

        Explicitly constructs a preconditioner based on the solution vector x
        and the parameter list p.

        The user has the option of recomputing the graph when a new
        preconditioner is created. The NOX::Epetra::Group controls the isValid
        flag for the preconditioner and will control when to call this. 
        """
        return ___init__.LinearSystemAztecOO_createPreconditioner(self, *args)

    def destroyPreconditioner(self, *args):
        """
        destroyPreconditioner(self) -> bool

        bool
        NOX::Epetra::LinearSystemAztecOO::destroyPreconditioner() const

        Deletes all objects associated with the chosen preconditioner. This is
        called during linear solves and when the solution vector changes to
        reset the preconditioner. 
        """
        return ___init__.LinearSystemAztecOO_destroyPreconditioner(self, *args)

    def recomputePreconditioner(self, *args):
        """
        recomputePreconditioner(self, Vector x, ParameterList linearSolverParams) -> bool

        bool
        NOX::Epetra::LinearSystemAztecOO::recomputePreconditioner(const
        NOX::Epetra::Vector &x, Teuchos::ParameterList &linearSolverParams)
        const

        Recalculates the preconditioner using an already allocated graph.

        Use this to compute a new preconditioner while using the same graph
        for the preconditioner. This avoids deleting and reallocating the
        memory required for the preconditioner and results in a big speed-up
        for large-scale jobs. 
        """
        return ___init__.LinearSystemAztecOO_recomputePreconditioner(self, *args)

    def getPreconditionerPolicy(self, *args):
        """
        getPreconditionerPolicy(self, bool advanceReuseCounter = True) -> PreconditionerReusePolicyType

        NOX::Epetra::LinearSystem::PreconditionerReusePolicyType
        NOX::Epetra::LinearSystemAztecOO::getPreconditionerPolicy(bool
        advanceReuseCounter=true)

        Evaluates the preconditioner policy at the current state.

        NOTE: This can change values between nonlienar iterations. It is not a
        static value. 
        """
        return ___init__.LinearSystemAztecOO_getPreconditionerPolicy(self, *args)

    def reset(self, *args):
        """
        reset(self, ParameterList linearSolverParams)

        void
        NOX::Epetra::LinearSystemAztecOO::reset(Teuchos::ParameterList
        &linearSolverParams)

        Reset the linear solver parameters. 
        """
        return ___init__.LinearSystemAztecOO_reset(self, *args)

    def getScaling(self, *args):
        """
        getScaling(self) -> Teuchos::RCP<(NOX::Epetra::Scaling)>

        Teuchos::RCP< NOX::Epetra::Scaling >
        NOX::Epetra::LinearSystemAztecOO::getScaling()

        Get the scaling object. 
        """
        return ___init__.LinearSystemAztecOO_getScaling(self, *args)

    def resetScaling(self, *args):
        """
        resetScaling(self, Teuchos::RCP<(NOX::Epetra::Scaling)> s)

        void NOX::Epetra::LinearSystemAztecOO::resetScaling(const
        Teuchos::RCP< NOX::Epetra::Scaling > &s)

        Sets the diagonal scaling vector(s) used in scaling the linear system.
        See NOX::Epetra::Scaling for details on how to specify scaling of the
        linear system. 
        """
        return ___init__.LinearSystemAztecOO_resetScaling(self, *args)

    def computeJacobian(self, *args):
        """
        computeJacobian(self, Vector x) -> bool

        bool
        NOX::Epetra::LinearSystemAztecOO::computeJacobian(const
        NOX::Epetra::Vector &x)

        Compute the Jacobian. 
        """
        return ___init__.LinearSystemAztecOO_computeJacobian(self, *args)

    def getJacobianInterface(self, *args):
        """
        getJacobianInterface(self) -> Teuchos::RCP<(q(const).NOX::Epetra::Interface::Jacobian)>

        Teuchos::RCP<
        const NOX::Epetra::Interface::Jacobian >
        NOX::Epetra::LinearSystemAztecOO::getJacobianInterface() const

        NOX::Interface::Jacobian accessor. 
        """
        return ___init__.LinearSystemAztecOO_getJacobianInterface(self, *args)

    def getPrecInterface(self, *args):
        """
        getPrecInterface(self) -> Teuchos::RCP<(q(const).NOX::Epetra::Interface::Preconditioner)>

        Teuchos::RCP<
        const NOX::Epetra::Interface::Preconditioner >
        NOX::Epetra::LinearSystemAztecOO::getPrecInterface() const

        NOX::Interface::Preconditioiner accessor. 
        """
        return ___init__.LinearSystemAztecOO_getPrecInterface(self, *args)

    def isPreconditionerConstructed(self, *args):
        """
        isPreconditionerConstructed(self) -> bool

        bool
        NOX::Epetra::LinearSystemAztecOO::isPreconditionerConstructed() const

        Indicates whether a preconditioner has been constructed. 
        """
        return ___init__.LinearSystemAztecOO_isPreconditionerConstructed(self, *args)

    def hasPreconditioner(self, *args):
        """
        hasPreconditioner(self) -> bool

        bool
        NOX::Epetra::LinearSystemAztecOO::hasPreconditioner() const

        Indicates whether the linear system has a preconditioner. 
        """
        return ___init__.LinearSystemAztecOO_hasPreconditioner(self, *args)

    def getJacobianOperator(self, *args):
        """
        getJacobianOperator(self) -> Teuchos::RCP<(q(const).Epetra_Operator)>
        getJacobianOperator(self) -> Teuchos::RCP<(Epetra_Operator)>

        Teuchos::RCP<
        Epetra_Operator >
        NOX::Epetra::LinearSystemAztecOO::getJacobianOperator()

        Jacobian Epetra_Operator accessor. 
        """
        return ___init__.LinearSystemAztecOO_getJacobianOperator(self, *args)

    def getPrecOperator(self, *args):
        """
        getPrecOperator(self) -> Teuchos::RCP<(q(const).Epetra_Operator)>

        Teuchos::RCP<
        const Epetra_Operator >
        NOX::Epetra::LinearSystemAztecOO::getPrecOperator() const

        Preconditioner Epetra_Operator accessor (only the base matrix if using
        an internal preconditioner - aztecoo or ifpack). 
        """
        return ___init__.LinearSystemAztecOO_getPrecOperator(self, *args)

    def getGeneratedPrecOperator(self, *args):
        """
        getGeneratedPrecOperator(self) -> Teuchos::RCP<(q(const).Epetra_Operator)>
        getGeneratedPrecOperator(self) -> Teuchos::RCP<(Epetra_Operator)>

        Teuchos::RCP< Epetra_Operator >
        NOX::Epetra::LinearSystemAztecOO::getGeneratedPrecOperator()

        Return preconditioner operator generated and stored in AztecOO. 
        """
        return ___init__.LinearSystemAztecOO_getGeneratedPrecOperator(self, *args)

    def getTimeCreatePreconditioner(self, *args):
        """
        getTimeCreatePreconditioner(self) -> double

        double
        NOX::Epetra::LinearSystemAztecOO::getTimeCreatePreconditioner() const

        Returns the total time (sec.) spent in createPreconditioner(). 
        """
        return ___init__.LinearSystemAztecOO_getTimeCreatePreconditioner(self, *args)

    def getTimeApplyJacobianInverse(self, *args):
        """
        getTimeApplyJacobianInverse(self) -> double

        double
        NOX::Epetra::LinearSystemAztecOO::getTimeApplyJacobianInverse() const

        Returns the total time (sec.) spent in applyJacobianInverse(). 
        """
        return ___init__.LinearSystemAztecOO_getTimeApplyJacobianInverse(self, *args)

    def setJacobianOperatorForSolve(self, *args):
        """
        setJacobianOperatorForSolve(self, Teuchos::RCP<(q(const).Epetra_Operator)> solveJacOp)

        void
        NOX::Epetra::LinearSystemAztecOO::setJacobianOperatorForSolve(const
        Teuchos::RCP< const Epetra_Operator > &solveJacOp)

        Set Jacobian operator for solve. 
        """
        return ___init__.LinearSystemAztecOO_setJacobianOperatorForSolve(self, *args)

    def setPrecOperatorForSolve(self, *args):
        """
        setPrecOperatorForSolve(self, Teuchos::RCP<(q(const).Epetra_Operator)> solvePrecOp)

        void
        NOX::Epetra::LinearSystemAztecOO::setPrecOperatorForSolve(const
        Teuchos::RCP< const Epetra_Operator > &solvePrecOp)

        Set preconditioner operator for solve.

        Note: This should only be called if hasPreconditioner() returns true.

        """
        return ___init__.LinearSystemAztecOO_setPrecOperatorForSolve(self, *args)

LinearSystemAztecOO_swigregister = ___init__.LinearSystemAztecOO_swigregister
LinearSystemAztecOO_swigregister(LinearSystemAztecOO)

import PyTrilinos.EpetraExt
import PyTrilinos.Epetra
class ModelEvaluatorInterface(Interface.Required,Interface.Jacobian,Interface.Preconditioner):
    """
    Wrapper for an EpetraExt::ModelEvaluator.

    If an application interfaces their code to solvers using the
    EpetraExt::ModelEvaluator, this class provides a wrapper so that the
    model evaluator can be used instead of having the user write concrete
    versions of the NOX::Epetra::Interface objects.

    C++ includes: NOX_Epetra_ModelEvaluatorInterface.H 
    """
    __swig_setmethods__ = {}
    for _s in [Interface.Required,Interface.Jacobian,Interface.Preconditioner]: __swig_setmethods__.update(getattr(_s,'__swig_setmethods__',{}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ModelEvaluatorInterface, name, value)
    __swig_getmethods__ = {}
    for _s in [Interface.Required,Interface.Jacobian,Interface.Preconditioner]: __swig_getmethods__.update(getattr(_s,'__swig_getmethods__',{}))
    __getattr__ = lambda self, name: _swig_getattr(self, ModelEvaluatorInterface, name)
    __repr__ = _swig_repr
    __swig_destroy__ = ___init__.delete_ModelEvaluatorInterface
    __del__ = lambda self : None;
    def computeF(self, *args):
        """
        computeF(self, Epetra_Vector x, Epetra_Vector F, FillType fillFlag) -> bool

        bool NOX::Epetra::ModelEvaluatorInterface::computeF(const
        Epetra_Vector &x, Epetra_Vector &F, const FillType fillFlag)

        Compute the function, F, given the specified input vector x. Returns
        true if computation was successful. 
        """
        return ___init__.ModelEvaluatorInterface_computeF(self, *args)

    def computeJacobian(self, *args):
        """
        computeJacobian(self, Epetra_Vector x, Operator Jac) -> bool

        bool
        NOX::Epetra::ModelEvaluatorInterface::computeJacobian(const
        Epetra_Vector &x, Epetra_Operator &Jac)

        Compute Jacobian given the specified input vector x. Returns true if
        computation was successful. 
        """
        return ___init__.ModelEvaluatorInterface_computeJacobian(self, *args)

    def computePreconditioner(self, *args):
        """
        computePreconditioner(self, Epetra_Vector x, Operator M, ParameterList precParams = None) -> bool

        bool
        NOX::Epetra::ModelEvaluatorInterface::computePreconditioner(const
        Epetra_Vector &x, Epetra_Operator &M, Teuchos::ParameterList
        *precParams=0)

        Computes a user defined preconditioner. 
        """
        return ___init__.ModelEvaluatorInterface_computePreconditioner(self, *args)

    def inargs_set_p(self, *args):
        """
        inargs_set_p(self, Teuchos::RCP<(q(const).Epetra_Vector)> p, int l = 0) -> bool

        bool
        NOX::Epetra::ModelEvaluatorInterface::inargs_set_p(const Teuchos::RCP<
        const Epetra_Vector > p, const int l=0)

        Set the parameter vector in inargs of the underlying model evaluator.

        """
        return ___init__.ModelEvaluatorInterface_inargs_set_p(self, *args)

    def __init__(self, *args): 
        """
        __init__(self, ModelEvaluator eeme) -> ModelEvaluatorInterface

        NOX::Epetra::ModelEvaluatorInterface::ModelEvaluatorInterface(const
        Teuchos::RCP< EpetraExt::ModelEvaluator > &m)

        Constructor. 
        """
        this = ___init__.new_ModelEvaluatorInterface(*args)
        try: self.this.append(this)
        except: self.this = this
ModelEvaluatorInterface_swigregister = ___init__.ModelEvaluatorInterface_swigregister
ModelEvaluatorInterface_swigregister(ModelEvaluatorInterface)



